# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK

CLASS_DIR=$(MCOM_ROOT)/adminserver/built/java/$(DIR)
DOC_DIR=$(CLASS_DIR)/doc
NMC_DIR=$(CLASS_DIR)/com/netscape/management
SOURCE_DIR=$(ABS_ROOT)/adminserver/admserv/console/$(DIR_SUFFIX)
PACKAGE_DIR=$(ABS_ROOT)/adminserver/built/package/java/$(DIR)

comma:= ,
empty:=
space:= $(empty) $(empty)

NO_BUILD_NUM=true

ifdef DEBUG
  JAVACFLAGS += -g
else
  JAVACFLAGS += -O
endif

ifdef DEPRECATION
  JAVACFLAGS += -deprecation
endif

LDAPJARFILE= $(CLASS_DEST)/ldapjdk.jar

ifeq ($(OS), Windows_NT)
PATH_SEP=;
JAVAC=javac $(JAVACFLAGS)
JAVA=java $(JAVAFLAGS)
JAVADOC=java -ms32m -mx48m sun.tools.javadoc.Main
CLASSPATH:=$(SOURCE_DIR)$(PATH_SEP)$(CLASS_DEST)$(PATH_SEP)$(LDAPJARFILE)
NMCJARS:=$(addprefix $(CLASS_DEST)/,$(NMCJDK_JARS))
else
PATH_SEP=:
CLASSPATH=  .$(PATH_SEP)$(SOURCE_DIR)$(PATH_SEP)$(LDAPJARFILE)
#JAVABIN=/share/builds/components/jdk/1.4.0_01/SunOS/bin
JAVABIN=/usr/java/j2sdk1.4.2_06/bin
JAVAC=${JAVABIN}/javac $(JAVACFLAGS)
JAVA=${JAVABIN}/java
JAVADOC=${JAVABIN}/javadoc
NMCJARS:=$(addprefix $(CLASS_DEST)/,$(NMCJDK_JARS))
endif

CONSOLE_JARS=$(subst $(space),$(PATH_SEP),$(NMCJARS))
CLASSPATH:=$(CONSOLE_JARS)$(PATH_SEP)$(CLASSPATH)$(PATH_SEP)

