//
// SmartUpdate install for Kingpin
//
// David Tompkins
// dt@netscape.com
// 12/9/97
//

kingpinBuild          = 882293362
kingpinName           = "Kingpin Pre-Release " + kingpinBuild;
kingpinRegistry       = "/netscape/Kingpin/";
kingpinInstallJarfile = "kingpin_installer.jar";
jarfileList           = makeArray("kingpin.jar", "admserv.jar", "nmclf.jar", "layout.jar", "swingall.jar");
awtRegistryName       = "java/classes/java40.jar";
trigger               = netscape.softupdate.Trigger;
reqNetscapeVersion    = "4.04j";

function makeArray()
{
   return (makeArray.arguments);
}

function getKingpinVersion()
{
   return (new netscape.softupdate.VersionInfo(1, 0, 0, kingpinBuild));
}

function getKingpinName()
{
   return (kingpinName);
}

function getKingpinRegistry()
{
   return (kingpinRegistry);
}

function getKingpinInstallJarfile()
{
   return (kingpinInstallJarfile);
}

function getJarfileList()
{
   return (jarfileList);
}

function getAwtRequiredVersionWin32()
{
   return (new netscape.softupdate.VersionInfo(4, 04, 10, 97313));
}

function print(msg)
{
   java.lang.System.out.println(msg);
}

function error(msg)
{
   top.kingpinInstallerError = msg;
   java.lang.System.err.println(msg);

   if (this.silent)
      return;

   alert(msg);
}

function checkKingpinConfiguration()
{
   print("Checking Kingpin Configuration...");

   print("Netscape version is " + navigator.appVersion);

   if (!navigator.javaEnabled())
   {
      error("Java must be enabled to install this product.");
      return -1;
   }

   if (navigator.appVersion.substring(0, reqNetscapeVersion.length) != reqNetscapeVersion)
   {
      error("You must first upgrade to Communicator 4.04j to use this product.");
      return -1;
   }

   if (!trigger.UpdateEnabled())
   {
      error("You must enable SmartUpdate to install products.");
      return -1;
   }

   // Check for AWT update

   /*
   if (navigator.platform == "Win32")
   {
      awtVersion    = trigger.GetVersionInfo(awtRegistryName);
      awtReqVersion = getAwtRequiredVersionWin32();

      print("Installer AWT Version is " + ((awtVersion == null) ? "NULL" : awtVersion));
      print("Required AWT Version is " + awtReqVersion);

      if ((awtVersion == null) || (awtVersion.compareTo(awtReqVersion) < 0))
      {
         error("You must upgrade Communicator with the latest AWT 1.1 SmartUpdate to use this product.");
         return -1;
      }
   }
   */

   // Check if Kingpin is already installed

   registryName = getKingpinRegistry();
   productName  = getKingpinName();
   version      = getKingpinVersion();

   installedVersion = trigger.GetVersionInfo(registryName);

   print("Installed Version is " + ((installedVersion == null) ? "NULL" : installedVersion));
   print("New Version is " + version);

   if ((installedVersion != null) && (installedVersion.compareTo(version) >= 0))
   {
      print(productName + " is already installed.");
      return 0;
   }

   // Update required

   return 1;
}
