/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
package com.netscape.management.admserv.config;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.netscape.management.client.util.*;
import com.netscape.management.nmclf.SuiLookAndFeel;

/**
 * Error Dialog for Config Exceptions
*/
public class ConfigInfoDialog {

    static ResourceSet _resource;
    static String  _i18nDefaultTitle;

    static {
        _resource = new ResourceSet("com.netscape.management.admserv.config.config");
        _i18nDefaultTitle = _resource.getString("infodialog", "DefaultTitle");
    }

    private Component _parent;
    private ButtonBar _buttons;
    private Font _fontLabel = UIManager.getFont("Panel.font");

    public static void showDialog(Component parent, String text,
            String title) {
        Frame frame = ConfigErrorDialog.getParentFrame(parent);

        BaseConfigPanel.clearProgressIndicator(parent);

        if (title == null || title.length() == 0) {
            title = _i18nDefaultTitle;
        }

        if (Thread.currentThread().getClass().getName().equals("java.awt.EventDispatchThread")) {
            JOptionPane.showMessageDialog(frame, text, title,
                    JOptionPane.INFORMATION_MESSAGE);
        } else {
            final String title_f = title, text_f = text;
            final Frame frame_f = frame;

            try {
                SwingUtilities.invokeAndWait(new Runnable() {
                            public void run() {
                                JOptionPane.showMessageDialog(frame_f,
                                        text_f, title_f,
                                        JOptionPane.INFORMATION_MESSAGE);
                            }
                        }
                        );
            } catch (Exception e1) {
                Debug.println("showDialog invokeAndWait " + e1);
            }
        }

    }
}
