/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
// constart.cpp : Defines the class behaviors for the application.
//

#include "afxwin.h"
#include "stdafx.h"
#include "constart.h"
#include "time.h"



#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConstartApp

BEGIN_MESSAGE_MAP(CConstartApp, CWinApp)
//{{AFX_MSG_MAP(CConstartApp)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG
ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

const CString RemovePhrase(CString strSrc, CString strPhrase)
{
  CString strTemp;
  int nPos;
  CString strLeft;
  CString strRight;

  strTemp = strSrc;

  //strTemp.MakeLower();

  nPos = strTemp.Find(strPhrase);
  if ((nPos == -1)) return strSrc; //no strPhrase

  strLeft = strSrc.Left(nPos);
  nPos = strTemp.GetLength() - nPos;
  nPos -= strPhrase.GetLength();
  strRight = strSrc.Right(nPos);

  strTemp = strLeft + strRight;
  strTemp.TrimRight();
  return strTemp;
}

static BOOL FileExists(LPCSTR pszFileName)
{
  OFSTRUCT ofs;

  if (OpenFile(pszFileName, &ofs, OF_EXIST) != HFILE_ERROR)
  {
    return TRUE;
  }

  return FALSE;
}

static int GetProductInfoString(const char* pszKey, char* pszValue, int cbValue, const char* pszFileName)
{
  FILE *fp;
  char szText[MAX_PATH];
  int nReturn = -1;

  pszValue[0] = '\0';

  if ((fp = fopen(pszFileName, "r")) != NULL)
  {
    while (fgets(szText, sizeof(szText), fp) != NULL)
    {
      char *pszToken;
      pszToken = strtok(szText, " : \t\n");
      if (pszToken && strcmp(pszToken, pszKey) == 0)
      {
        if ((pszToken = strtok(NULL, "\n")) != NULL)
        {
          strncpy(pszValue, pszToken, cbValue);
          pszValue[cbValue-1] = '\0'; //
          nReturn = strlen(pszValue);
        }
        else
        {
          nReturn = 0;
        }
        break;
      }
    }
    fclose(fp);
  }
  return nReturn;
}


/////////////////////////////////////////////////////////////////////////////
// CConstartApp construction

CConstartApp::CConstartApp()
{
  // TODO: add construction code here,
  // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CConstartApp object

CConstartApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CConstartApp initialization

BOOL CConstartApp::InitInstance()
{
  CString strCommandLine;
  strCommandLine = m_lpCmdLine;
//  strCommandLine.MakeLower();  //at this time nothing is case sensitive

  // Standard initialization
  // If you are not using these features and wish to reduce the size
  //  of your final executable, you should remove from the following
  //  the specific initialization routines you do not need.

#ifdef _AFXDLL
  Enable3dControls();     // Call this when using MFC in a shared DLL
#else
  Enable3dControlsStatic(); // Call this when linking to MFC statically
#endif

  if (!strCommandLine.IsEmpty())
  {
    CString strTemp;

    strTemp = strCommandLine;
    if ((strTemp.Find("http") == -1))
    {
      strTemp = SetUrl();
      strTemp += " ";
      strTemp += strCommandLine;
      StartConsole(strTemp);
    }
    else
    {
      if (strTemp.Find("-a") == -1)  // could be better basically this mandates that startconsole "url" then switches
      {
        strTemp = "-a ";
        strTemp += strCommandLine;
        strCommandLine = strTemp;
      }
      StartConsole(strCommandLine);
    }
  }
  else
  {
    StartConsole(SetUrl());
  }
  // Since the dialog has been closed, return FALSE so that we exit the
  //  application, rather than start the application's message pump.
  return FALSE;
}

CString CConstartApp::SetUrl()
{
  char szFileName[MAX_PATH];
  BOOL bErrorrBuildingAdminUrl = FALSE;
  char szValue[MAX_PATH];
  CString strTemp;
  CString m_strAdminUrl;

  if (!GetServerRoot(szFileName, sizeof(szFileName)))
  {
    m_strAdminUrl.Empty();
    return m_strAdminUrl;
  }

  strcat(szFileName, "\\admin-serv\\config\\adm.conf");

  if (FileExists(szFileName))
  {
    m_strAdminUrl = "-a http://";
    if (GetProductInfoString("security", szValue, MAX_PATH, szFileName) > 0)
    {
      strTemp = szValue;
      strTemp.TrimLeft();
      strTemp.TrimRight();
      if (strTemp.CompareNoCase("on") == 0)
      {
        m_strAdminUrl = "-a https://";
      }
    }
    if (GetProductInfoString("host", szValue, MAX_PATH, szFileName) > 0)
    {
      strTemp = szValue;
      strTemp.TrimLeft();
      strTemp.TrimRight();
      m_strAdminUrl += strTemp;
    }
    else bErrorrBuildingAdminUrl = TRUE;


    if (GetProductInfoString("port", szValue, MAX_PATH, szFileName) > 0)
    {
      strTemp = szValue;
      strTemp.TrimLeft();
      strTemp.TrimRight();
      m_strAdminUrl += ":";
      m_strAdminUrl += strTemp;
    }
    else bErrorrBuildingAdminUrl = TRUE;

  }
  else bErrorrBuildingAdminUrl = TRUE;

  if (bErrorrBuildingAdminUrl)
  {
    m_strAdminUrl.Empty(); // = "http://domain:port";
  }
  return m_strAdminUrl;
}

BOOL CConstartApp::StartConsole(const CString strUsrCmdLine)
{
  char szServerRoot[MAX_PATH];
  char *szCommandLine;
  char *szClassPathEnv;
  char *szPath;
  char *szJavaHome;
  BOOL bDebugWindow = FALSE;

  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  BOOL bSuccess = FALSE;
  BOOL bChangedRegistry = FALSE;
  CString strClassPath;
  CString strTempUsrCmdLine = strUsrCmdLine;

  GetServerRoot(szServerRoot, sizeof(szServerRoot));

  szJavaHome = getenv("JavaHome");

  // don't change the register for 1.2
  //bChangedRegistry = checkJRE(szServerRoot);
  bChangedRegistry = FALSE;

  strClassPath = GetClassPath(szServerRoot);
  szClassPathEnv = getenv("CLASSPATH");

  char szNewClassPath[MAX_PATH * 5];
  wsprintf(szNewClassPath, "CLASSPATH=%s", strClassPath);
  _putenv(szNewClassPath);

  szPath = getenv( "Path" );
  {
    char szTPath[MAX_PATH * 5];
    wsprintf(szTPath, "Path=%s\\bin\\base\\jre\\bin;%s", szServerRoot, szPath);
    _putenv(szTPath);
    wsprintf(szTPath, "SuiteSpotRoot=%s", szServerRoot);
    _putenv(szTPath);
  }

  CString str;
  CString tmp;
  if (strUsrCmdLine.Find("-D") != -1)
  {
    bDebugWindow = TRUE;
  }
  if ((strUsrCmdLine.Find("-env") != -1))
  {
    bDebugWindow = TRUE;
    strTempUsrCmdLine = RemovePhrase(strTempUsrCmdLine, "-env");
    str = "cmd /k ";
  }

  str += m_strJrePath; //full path of jre.exe
  if ((strUsrCmdLine.Find("-jit") != -1))
  {
    strTempUsrCmdLine = RemovePhrase(strTempUsrCmdLine, "-jit");
    str += " -mx64m ";
  }
  else str += " -mx64m ";
  tmp.Format(" -classpath \"%s\" com.netscape.management.client.console.Console ", strClassPath);
  str += tmp;
  str += strTempUsrCmdLine;
  szCommandLine = strdup(str);
  strcat(szServerRoot, "\\java");
  memset(&si,0,sizeof(si));
  si.cb = sizeof(si);
  GetStartupInfo(&si);
  si.dwFlags = STARTF_USESHOWWINDOW;
  si.wShowWindow = SW_SHOWDEFAULT;
  si.lpTitle = "Fedora Management Console 7.0 Information Window";
  if (bDebugWindow)
  {
    bSuccess = CreateProcess(
                            NULL,
                            szCommandLine,
                            NULL,
                            NULL,
                            FALSE,
                            NORMAL_PRIORITY_CLASS,
                            NULL,
                            szServerRoot,
                            &si,
                            &pi
                            );
  }
  else
  {
    bSuccess = CreateProcess(
                            NULL,
                            szCommandLine,
                            NULL,
                            NULL,
                            FALSE,
                            NORMAL_PRIORITY_CLASS | DETACHED_PROCESS,
                            NULL,
                            szServerRoot,
                            &si,
                            &pi
                            );
  }

  if (bSuccess)
  {
    //LPDWORD lpExitCode;
    WaitForSingleObject(pi.hProcess, INFINITE);
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
  }


  if (bChangedRegistry)
  {
    //SetUserJavaHome(m_strJreVer);
  }

  //put back original env
  if (szClassPathEnv)
  {
    char szTempPath[MAX_PATH * 5];
    wsprintf(szTempPath, "CLASSPATH=%s", szClassPathEnv);
    _putenv(szTempPath);
  }
  if (szPath)
  {
    char szTPath[MAX_PATH * 5];
    wsprintf(szTPath, "PATH=%s", szPath);
    _putenv(szTPath);
  }
  if (szJavaHome)
  {
    char szTPath[MAX_PATH * 5];
    wsprintf(szTPath, "JavaHome=%s", szJavaHome);
    _putenv(szTPath);
  }
  if (szCommandLine) free(szCommandLine);

  return bSuccess;
}

CString CConstartApp::GetClassPath(const CString strServerRoot)
{
  CString strClassPath = "";
  CString strJava;
  strJava = strServerRoot;
  strJava += "\\java";
  strClassPath = strJava + ";";
  strJava += "\\";

  CFileFind finder;
  BOOL bContinue = TRUE;

  //strClassPath.Format("%s\\bin\\base\\jre\\lib\\i18n.jar;%s\\bin\\base\\jre\\lib\\rt.jar;", strServerRoot, strServerRoot);
  if (bContinue = finder.FindFile(strJava + "\\*.jar"))
  {

    while (bContinue)
    {
      CString strFilename;
      bContinue = finder.FindNextFile();
      strFilename = finder.GetFileName();
      strFilename.MakeLower();
      if (strFilename.Find("kingpin_installer.jar") == -1)
      {
        strClassPath += strJava + strFilename;
        strClassPath += ";";
      }
    }
    finder.Close();
  }

  bContinue = TRUE;
  if (bContinue = finder.FindFile(strJava + "\\*.zip"))
  {

    while (bContinue)
    {
      CString strFilename;
      bContinue = finder.FindNextFile();
      strFilename = finder.GetFileName();
      strFilename.MakeLower();
      strClassPath += strJava + strFilename;
      strClassPath += ";";
    }
    finder.Close();
  }

  return strClassPath;
}

BOOL CConstartApp::GetServerRoot(char *szPath, int cbPath)
{
  BOOL bReturn = FALSE;
  HKEY hKey;
  char szKey[MAX_PATH];

  // HKLM\Software\Netscape\Administration\Version : RootPath
  wsprintf(szKey, KEY_SOFTWARE_NETSCAPE "\\" SVR_KEY_ROOT);
  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKey, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS)
  {
    DWORD dwSize = cbPath;
    RegQueryValueEx(hKey, VALUE_ROOT_PATH, 0, NULL, (unsigned char *) szPath, &dwSize);
    bReturn = (RegCloseKey(hKey) == ERROR_SUCCESS);
  }
  else
  {
    char* psz = strrchr(m_pszHelpFilePath, '\\');
    if (psz)  // If help file path is set, use it
    {
      CString strHelpFilePath = m_pszHelpFilePath;
      strcpy(szPath, strHelpFilePath.Left(psz - m_pszHelpFilePath));
    }
    else  // Otherwise, make an educated guess...
    {
      GetCurrentDirectory(strlen(szPath),szPath);
    }
  }
  return (bReturn);
}

BOOL CConstartApp::CheckJavaHome(const char *szTempJavaHome, CString strVer, CString strMicVer)
{
  BOOL bReturn = FALSE;
  HKEY hKey;
  char szKey[MAX_PATH];

  wsprintf(szKey, "SOFTWARE\\JavaSoft\\Java Runtime Environment\\%s", strVer);
  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKey, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
  {

    DWORD dwUJHSize = sizeof(szUserJavaHome);

    if (RegQueryValueEx(hKey, "JavaHome", 0, NULL, (unsigned char *) szUserJavaHome, &dwUJHSize) == ERROR_SUCCESS)
    {
      char szJavaVer[20];
      DWORD dwVerSize = sizeof(szJavaVer);

      if (RegQueryValueEx(hKey, "MicroVersion", 0, NULL, (unsigned char *) szJavaVer, &dwVerSize) == ERROR_SUCCESS)
      {
        if (szTempJavaHome != NULL)
        {
          if (stricmp(szJavaVer, strMicVer) == 0)
          {
            CString strJHome;
            strJHome = szUserJavaHome;
            strJHome += "\\bin\\java.exe";
            if (!FileExists(strJHome))
            {
              CString strMsg;
              strMsg.Format(IDS_CHANGING_JAVAHOME, strVer, strMicVer);
              AfxMessageBox(strMsg, MB_OK|MB_ICONEXCLAMATION);

              if (RegSetValueEx(hKey, "JavaHome", 0, REG_SZ, (const unsigned char *)  szTempJavaHome, strlen(szTempJavaHome)+1) != ERROR_SUCCESS)
              {
                strMsg.Format(IDS_ERR_JAVAHOME_CHANGE);
                AfxMessageBox(strMsg, MB_OK|MB_ICONEXCLAMATION);
              }
              else
              {
                bReturn = TRUE; //reg changed
              }
            }
            else
            {
               m_strJrePath = strJHome;
            }
          }
          else
          {
            CString strMsg;
            strMsg.Format(IDS_CHANGING_JAVAHOME,  strVer, strMicVer);
            AfxMessageBox(strMsg, MB_OK|MB_ICONEXCLAMATION);

            if (RegSetValueEx(hKey, "JavaHome", 0, REG_SZ, (const unsigned char *)  szTempJavaHome, strlen(szTempJavaHome)+1) != ERROR_SUCCESS)
            {
              strMsg.Format(IDS_ERR_JAVAHOME_CHANGE);
              AfxMessageBox(strMsg, MB_OK|MB_ICONEXCLAMATION);
            }
            else
            {
              bReturn = TRUE; //reg changed
            }
          }
        }
        else
        {
          if (stricmp(szJavaVer, strMicVer) != 0)
          {
            CString strMsg;
            strMsg.Format(IDS_INSTALL_JRE, strVer, strMicVer);
            if (AfxMessageBox(strMsg,  MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION)!= IDYES)
            {
              exit(1);
            }
          }
        }
      }
      RegCloseKey(hKey);
    }
  }
  else
  {
    if (szTempJavaHome == NULL)
    {
      CString strMsg;
      strMsg.Format(IDS_INSTALL_JRE, strVer, strMicVer);
      if (AfxMessageBox(strMsg,  MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION)!= IDYES)
      {
        exit(1);
      }
    }
    bReturn = FALSE;
  }
  return (bReturn);

}

BOOL CConstartApp::SetUserJavaHome(CString strVer)
{
  BOOL bReturn = FALSE;
  HKEY hKey;
  CString strErrMsg;
  char szKey[MAX_PATH];

  wsprintf(szKey, "SOFTWARE\\JavaSoft\\Java Runtime Environment\\%s", strVer);
  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKey, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
  {
    if (RegSetValueEx(hKey, "JavaHome", 0, REG_SZ, (const unsigned char *)  szUserJavaHome, strlen(szUserJavaHome)+1) != ERROR_SUCCESS)
    {
      //show strErrMsg
      strErrMsg.Format(IDS_ERR_RESET_JAVAHOME, strVer, szUserJavaHome );
      AfxMessageBox(strErrMsg, MB_OK|MB_ICONEXCLAMATION);
      bReturn = FALSE;
    }
    else
    {
      bReturn = TRUE;
    }
    RegCloseKey(hKey);
  }
  else
  {
    strErrMsg.Format(IDS_ERR_RESET_JAVAHOME, strVer, szUserJavaHome );
    AfxMessageBox(strErrMsg, MB_OK|MB_ICONEXCLAMATION);
    bReturn = FALSE;
  }
  return (bReturn);
}


BOOL CConstartApp::checkJRE(char * szServerRoot)
{
    char szTPath[MAX_PATH * 2];
    BOOL bInit = TRUE;
    BOOL bChangedRegistry;

    wsprintf(szTPath, "%s\\java\\jre.inf", szServerRoot);
    if (FileExists(szTPath))
    {
      char szValue[MAX_PATH];
      if (GetProductInfoString("Version", szValue, MAX_PATH, szTPath) > 0)
      {
        m_strJreVer = szValue;
        m_strJreVer.TrimLeft();
        m_strJreVer.TrimRight();
      }
      else bInit = FALSE;

      if (GetProductInfoString("MicroVersion", szValue, MAX_PATH, szTPath) > 0)
      {
        m_strJreMicroVer = szValue;
        m_strJreMicroVer.TrimLeft();
        m_strJreMicroVer.TrimRight();
      }
      else bInit = FALSE;
    }
    else
    {
      bInit = FALSE;
    }

    if (bInit == FALSE)
    {

      CString strMsg;
      strMsg.Format(IDS_JRE_INF_BAD, szTPath);
      AfxMessageBox(strMsg, MB_OK|MB_ICONEXCLAMATION);
      exit(1);
    }
    wsprintf(szTPath, "%s\\bin\\base\\jre\\bin\\java.exe", szServerRoot);
    if (FileExists(szTPath))
    {
      m_strJrePath = szTPath;
      wsprintf(szTPath, "JavaHome=%s\\bin\\base\\jre", szServerRoot);
      _putenv(szTPath);
      wsprintf(szTPath, "%s\\bin\\base\\jre", szServerRoot);
      //bChangedRegistry = CheckJavaHome((const char *) szTPath, m_strJreVer, m_strJreMicroVer);
      bChangedRegistry=FALSE;
    }
    else
    {
      //bChangedRegistry = CheckJavaHome(NULL, m_strJreVer, m_strJreMicroVer);
      bChangedRegistry=FALSE;
    }

  return bChangedRegistry;
}
