/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*********************************************************************
**
** NAME:
**   acidef.h
**
** DESCRIPTION:
**   ACIs for fixing access cotrol under o=netscapeRoot
**
** NOTES:
**
** HISTORY:
**
*********************************************************************/

/*
 * This ACI allows all authenticated users to read host, port, address, and
 * securtity attribute for admin servers. This is required to create http urls
 * for jar downloads.
 */
#define LOCATE_ADMSERV_ACI "\
(targetattr=\"nsServerPort||nsServerAddress||nsServerSecurity||serverHostName\")\
(targetfilter=(|(objectclass=nsAdminServer)(objectclass=nsAdminConfig)))\
(version 3.0; acl \"Locate Admin Server\";\
allow (read, search, compare) userdn=\"ldap:///all\";)"

/*
 * The correct definition for "Enable Group Expansion". For DS version prior
 * to 4.12, the ACI is defined with groupdnattr="ldap:///o=NetscapeRoot?uniquemember?sub" 
 * which instructs that all groups must be under o=netcapeRoot
 *
 */
#define GROUP_EXPANSION_ACI "\
(targetattr=\"*\")\
(version 3.0; acl \"Enable Group Expansion\"; allow (read, search, compare) \
groupdnattr=\"uniquemember\";)"
