/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*********************************************************************
**
** NAME:
**   servlet-conf.h
**
** DESCRIPTION:
**   Configuration parameters for the servlet engine startup file 
**   <server-root>/bin/https/bin/start-jvm
**   
**   Defines NSES_JRE_RUNTIME_LIBPATH and NSES_CLASSPATH used by ux-update.cc (Unix)
**   and config.c (NT)
**
**
** NOTES:
**   This file is based on the ES4.x header file jdkconfig.h in 
**   ns/netsite/include/sjava/jdkconfig.h.
**   Changes from the original file are:
**   1) JDK defines have been removed as AS does not support jsp
**   2) NSES_CLASSPATH has been changed for the AS environment
**   3) Conditional compilation for JAVA_VERSION 1.1, Solaris EXACT_VM
**      is removed. Java version is 1.2, we do not distribute Java Exact
**      VM on Solaris.
**
**   The file was originally created for AS5.0 with JRE 1.2 and 
**   ES4.1sp1 web-server engine.
**
**
** HISTORY:
**
*********************************************************************/

#if !defined (SEP)
#if defined (XP_UNIX)
#define SEP ":"
#else
#define SEP ";"
#endif
#endif

/*
 *
 *  Define NSES_JRE_RUNTIME_LIBPATH
 *
 */
#define NSES_VMTYPE "client"


/* With HP JRE 1.4 beta2 only the server VM is supported */
#define HP_NSES_VMTYPE "server"

#define LIB_JSS "${NSES_SERVER_HOME}/lib/jss"

#if defined (XP_WIN32)
#define NSES_JRE "${NSES_SERVER_HOME}/bin/base/jre"
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/bin/" NSES_VMTYPE SEP "${NSES_JRE}/bin" SEP LIB_JSS
#endif

#if defined (SOLARIS)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/lib/sparc/" NSES_VMTYPE SEP "${NSES_JRE}/lib/sparc/native_threads" SEP "${NSES_JRE}/lib/sparc" SEP LIB_JSS
#endif

#if defined (HPUX)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/lib/PA_RISC/" HP_NSES_VMTYPE SEP "${NSES_JRE}/lib/PA_RISC/native_threads" SEP "${NSES_JRE}/lib/PA_RISC" SEP LIB_JSS
#endif

#if defined (Linux) || defined (LINUX)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/lib" SEP "${NSES_JRE}/bin" SEP "${NSES_JRE}/bin/classic" SEP LIB_JSS
#endif

#if defined (OSF1)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/lib/alpha/" NSES_VMTYPE SEP "${NSES_JRE}/lib/alpha/native_threads" SEP "${NSES_JRE}/lib/alpha" SEP LIB_JSS
#endif

#if defined (IRIX)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/lib32/mips/" NSES_VMTYPE SEP "${NSES_JRE}/lib32/mips/native_threads" SEP "${NSES_JRE}/lib32/mips" SEP LIB_JSS
#endif

#if defined (AIX)
#define NSES_JRE_RUNTIME_LIBPATH "${NSES_JRE}/bin/" NSES_VMTYPE SEP "${NSES_JRE}/bin" SEP LIB_JSS
#endif

/*
 *
 *  Define NSES_CLASSPATH
 *
 */

#define NSES_CLASSPATH  \
 "${NSES_SERVER_HOME}/bin/https/jar/NSServletLayer.jar" SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/NSJavaUtil.jar" SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/NSJavaMiscUtil.jar"SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/servlet.jar"  SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/servlet-2.3-filters-api.jar"  SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/jaxp.jar"  SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/crimson.jar"  SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/xalan.jar"  SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/jspengine.jar" SEP \
 "${NSES_SERVER_HOME}/bin/https/jar/jakarta-naming.jar"  SEP \
 "${NSES_SERVER_HOME}/java/ldapjdk.jar" SEP \
 "${NSES_SERVER_HOME}/java/jss3.jar"
