# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
#
# Make file configuration for Windows NT Setup SDK
#

ifeq ($(ARCH), WINNT)

CPP=cl.exe
RSC=rc.exe
MTL=mktyplib.exe
BSC=bscmake.exe
LINK=link.exe
AR=lib.exe



MTL_FLAGS=/nologo /win32

RSC_FLAGS=/l 0x409

BSC_FLAGS=/nologo

LINK_FLAGS=/nologo /SUBSYSTEM:WINDOWS /PDB:NONE /OUT:"$@"


CPP_FLAGS=/nologo /W3





ifeq ($(DEBUG), full)

CPP_FLAGS += /Od /D_DEBUG
MTL_FLAGS += /D_DEBUG
RSC_FLAGS += /d_DEBUG
LINK_FLAGS += /DEBUG /INCREMENTAL:NO

else

CPP_FLAGS += /O2 /DNDEBUG
MTL_FLAGS += /DNDEBUG
RSC_FLAGS += /DNDEBUG
LINK_FLAGS += /INCREMENTAL:NO

endif
#/D_MBCS
CPP_FLAGS += /GT /GX /DWIN32 /D_WINDOWS /D_RWTOOLSDLL /c

ifeq ($(DEBUG), fulld)
DLL_FLAGS= /MDd /Z7 /Yd /D "XP_WIN32" /DDLL /DWINDLL /DCOPYRIGHT_CLEAN /DLZW_CLEAN /DUSE_EF_UX_TIME
EXE_FLAGS= /MTd
else
DLL_FLAGS= /MD /Z7 /Yd /D "XP_WIN32" /DDLL /DWINDLL /DCOPYRIGHT_CLEAN /DLZW_CLEAN /DUSE_EF_UX_TIME
EXE_FLAGS= /MT
endif

CPP_FLAGS +=
PROCESSOR := $(shell uname -p)
ifeq ($(PROCESSOR), I386)
LINK_FLAGS += /machine:I386
CPP_FLAGS += /D_X86_ /Dx386
else
ifeq ($(PROCESSOR), MIPS)
CPP_FLAGS += /D_MIPS_
else
ifeq ($(PROCESSOR), ALPHA)
CPP_FLAGS += /D_ALPHA=1
endif
endif
endif

EXTRA_LIBS=wsock32.lib kernel32.lib user32.lib gdi32.lib winspool.lib \
           comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib \
           rpcrt4.lib uuid.lib odbc32.lib odbccp32.lib winmm.lib comctl32.lib \
	   version.lib

$(OBJDEST)/%.res: %.rc $(NSROOT)/fversion.exe
	$(RSC) $(shell $(NSROOT)/fversion.exe $(FVERSION_FLAGS)) -Fo$@ $*.rc

$(OBJDEST)/%.o: %.cpp
	$(CPP) $(CPP_FLAGS) $(MCC_INCLUDE) $< -Fo$(OBJDEST)/$*.o

$(OBJDEST)/%.o: %.c
	$(CPP) $(CPP_FLAGS) $(MCC_INCLUDE) $< -Fo$(OBJDEST)/$*.o $(CBSCFLAGS)

$(OBJDEST)/%.exe: $(OBJDEST) $(DEF_FILE) %.o
	$(LINK) $(LINK_FLAGS) $(DEF_FILE) $(EXTRA_LIBS) $(DEPLIBS)

$(OBJDEST)/%.dll: $(OBJDEST) $(DEF_FILE) %.o
	$(LINK) /MAP /DLL $(LINK_FLAGS) $(DEF_FILE) $(EXTRA_LIBS) $(DEPLIBS)

endif # WINNT
