# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
# parameters: BUILD_MODULE version.h buildnum.dat security input name output [expDefine] [list of files to back up]

$module = shift;
$versionFile = shift;
$buildFile = shift;
$security = shift;
$input = shift;
$backup_files = pop( @ARGV );
grep { s/\s/,/g } $backup_files;
$expDefine = pop( @ARGV );	# -DPUMPKIN_HOUR=<number>
( $junk, $expires ) = split( /=/, $expDefine );
if ( defined( $expires ) ) {
    $output = pop( @ARGV );
} else {
    $output = $expDefine;
    $expires = 0;
}

$name = join( " ", @ARGV );

%xlations = ( 'HTTP_ADMIN' => 'ADMSERV_VERSION_DEF',
	      'HTTP_ENTERPRISE' => 'ENTERPRISE_VERSION_DEF',
	      'HTTP_PERSONAL' => 'PERSONAL_VERSION_DEF',
	      'HTTP_CATALOG' => 'CATALOG_VERSION_DEF'
	    );
$type = $xlations{$module};

%nameXlations = ( 'Personal Server' => 'FastTrack Server' );
$name = $nameXlations{$name} if $nameXlations{$name};

open( FILE, $versionFile );
while ( <FILE> ) {
    last if ( $version ) = /$type\s+"(.*)"/;
}
close( FILE );
open( FILE, $buildFile );
while ( <FILE> ) {
    last if ( $buildNum ) = /\\"(.*)\\"/;
}
close( FILE );
open( FILE, $input );
open( OUT, ">$output" );
while ( <FILE> ) {
    s/%%%SERVER_NAME%%%/$name/;
    s/%%%VERSION%%%/$version/;
    s/%%%BUILD_NUM%%%/$buildNum/;
    s/%%%PUMPKIN_HOUR%%%/$expires/;
    s/%%%BACKUP_FILES%%%/$backup_files/;
    s/%%%SECURITY%%%/$security/;
    print OUT;
}
close( OUT );
close( FILE );
