/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#define MAX_PROP_PAGES 3

#define NDX_PG_FIRST   0
#define NDX_PG_SECOND  1
#define NDX_PG_THIRD   2

#define ADM_DEFAULT_HOST "localhost"
#define ADM_DEFAULT_USER "admin"
#define ADM_KEY_BLOCKED  "BlockedPath"
#define NS_SLAPD_CFG_SECTION    "slapd"
#define NS_SLAPD_CFG_MCC        "SlapdConfigForMC"
#define NS_SLAPD_INSTANCE_ID    "ServerIdentifier"
#define ADM_CFG_SECTION         "admin"
#define ADM_CFG_SYSUSER         "SysUser"
#define ADM_CFG_HOST            "Host"
#define ADM_CFG_PORT            "Port"
#define ADM_CFG_USERID          "ServerAdminID"
#define ADM_CFG_PASSWORD        "ServerAdminPwd"
#define ADM_CFG_COMPONEMTS      "Components"
#define ADM_CFG_IPADDRESS       "ServerIpAddress"

#define ADM_ERR_DLG_TITLE       "Error"
#define ADM_ERR_PORT_BUSY       "The port you have selected is currently in use or invalid.  Choose another port."
#define ADM_ERR_PASSWORD_DIFF   "The passwords you have entered do not match.  Please enter both passwords again."

#define ADM_INFO_ADMUSER        "   Administration User ID: %s\r\n"
#define ADM_INFO_ADMPORT        "   Administration Port: %d\r\n"
#define ADM_INFO_ADMURL         "   Administration URL: %s\r\n"
#define ADM_INFO_REFRESH        "   Files will be updated, no configuraton changes.\r\n"
#define ADM_INFO_NOTHING        "   No install actions to be performed.\r\n"
#define ADM_INFO_SERVERIP       "   Administration IP Address: %s\r\n"

typedef struct tagMODULEINFO
{
  HINSTANCE m_hModule;
  HWND m_hwndParent;
  int m_nResult;
} MODULEINFO;


typedef struct tagLDAPDATA
{
  char szServerRoot[MAX_PATH];
  char szHost[MAX_PATH];
  char szPort[MAX_PATH];
  char szSuffix[MAX_PATH];
} LDAPDATA;


typedef struct tagCONTROLDATA
{
  HWND hwndPage[MAX_PROP_PAGES];
  BOOL bShowAdmConfig;
  BOOL bDoAdmInstall;
  char szHostname[MAX_PATH];
  char szUsername[MAX_PATH];
  char szPassword[MAX_PATH];
  char szPasswordConfirm[MAX_PATH];
  char szUrl[MAX_PATH];
  char szLanguage[MAX_PATH];
  int nPort;
  char* szCacheFile;                 //for post install in creating adm.conf can write ldapStart:
  char* szVendor;
  char* szDescription;
  char* szName;
  char* szNickname;
  char* szVersion;
  char* szBuildNumber;
  char* szRevision;
  char* szTimeStamp;
  char* szExpireDate;
  char* szSecurity;
  char* szServerAddress;
  BOOL  nReplaceVersion;        // 0:  none,  1:  40,   2:  41   3: 42
} CONTROLDATA;

//
// DLL exported functions
//

extern __declspec(dllexport) BOOL __cdecl ADM_PreInstall(VOID);
extern __declspec(dllexport) INT  __cdecl ADM_AskOptions(HWND, INT);
extern __declspec(dllexport) VOID __cdecl ADM_GetSummary(LPSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_WriteCacheGlobal(LPCSTR,LPCSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_WriteCacheLocal(LPCSTR,LPCSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_ReadCacheGlobal(LPCSTR,LPCSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_ReadComponentInf(LPCSTR,LPCSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_ReadCacheLocal(LPCSTR,LPCSTR);
extern __declspec(dllexport) BOOL __cdecl ADM_PostInstall(VOID);
extern __declspec(dllexport) BOOL __cdecl ADM_PostUnInstall(LPCSTR);
extern __declspec(dllexport) BOOL __cdecl CON_PreInstall(VOID);
extern __declspec(dllexport) BOOL __cdecl CON_PostInstall(VOID);
extern __declspec(dllexport) BOOL __cdecl CON_PostUnInstall(LPCSTR szServerRoot);
extern __declspec(dllexport) BOOL __cdecl CON_PreUnInstall(LPCSTR szServerRoot);
//
// DLL local functions
//

extern int  _CreateConfig(char *szServerRoot);
//extern BOOL _Get2xServerRoot(char *szPath, int cbPath);
extern BOOL _GetAdminConfig(const char *szServerRoot, char *szHostName, int *nPort);
//extern int  _VersionCompare(char *szMediaVersion, char *szInstalledVersion);
extern int  _UpdateConfig(char *szServerRoot);
extern int  _CreateConfig(char *szServerRoot);
extern int _UpdateSchema(char *szServerRoot);
extern BOOL _FixRootACIs();

extern BOOL CreateEventLog(char *szServerRoot, char *szServiceId);
extern LONG CreateAdminAdmpwFile(char *sroot, char *httpUser, char *httpPassword );
extern LONG CopyAdminAdmpwFile(char *sroot, char *oldRoot );
extern LONG CreateAdminNsAdminConfFile( char *sroot, char * hostname, int adminport, char * sysuser, char *adminhostnames, char *adminhostips, char *adminbackups);
extern int  CreateAdminACL(char *sroot,char *httpuser);
extern BOOL CreateLdapDefaultSwitch(char *sroot);
extern BOOL CreateSieConf(char *sroot);

// get these using /Zg option
extern long ConvertNtSlashesToUnix(char *lpszNtPath,char *lpszUnixPath);
extern char *make_shexp(char *source);
extern void escape_ldap_uri(char *s1, const char *s2);
extern int  do_uuencode(unsigned char *src,unsigned char *dst,int srclen);
