/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
// admin.cpp : Defines the class behaviors for the application
//

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#include "admin.h"
#include "ntos.h"
#include "nt/regparms.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define SERVICE_ADMIN           "Fedora Administration"

/////////////////////////////////////////////////////////////////////////////
// CAdminApp

BEGIN_MESSAGE_MAP(CAdminApp, CWinApp)
	//{{AFX_MSG_MAP(CAdminApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdminApp construction

CAdminApp::CAdminApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAdminApp object

CAdminApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAdminApp initialization

BOOL CAdminApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	Enable3dControls();

    if ( !FindOperatingSystem() ) {
        AfxMessageBox ( "This program requires Windows NT or Windows 95" );
        goto quit;
    }

    if ( !GetAdminPort() ) {
        AfxMessageBox ( "This Server software has not been properly installed."
                                 " Please install again." );
        goto quit;
    }

    /* check for existance of Netscape Naviagtor */
    if ( !FindNetscapeNavigator() ) {
        AfxMessageBox ( "This Netscape Navigator has not been properly installed."
                                 " Please install again." );
        goto quit;
    }

    StartBrowser();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
quit:
	return FALSE;
}
/*---------------------------------------------------------------------------*\
 *
 * Function:  FindOperatingSystem
 *
 *  Purpose:  This function finds the operating system
 *
 *    Input:
 *
 *  Returns:
 *
 * Comments:
\*---------------------------------------------------------------------------*/
BOOL CAdminApp::FindOperatingSystem()
{
    switch ( INFO_GetOperatingSystem() ) {
    case OS_WIN95:
        m_WinNT = FALSE;
        m_installAsService = FALSE;
        break;
    case OS_WINNT:
        m_WinNT = TRUE;
        m_installAsService = TRUE;
        break;
    default:
        return FALSE;        
    }
    return TRUE;        
}



BOOL CAdminApp::GetAdminPort()
{
    FILE *f;
    char tstr[MAX_PATH];
    char szKey[MAX_PATH];
    char szHostName[MAX_PATH];
    char szSecurity[MAX_PATH];
    char szServerConfig[MAX_PATH];
    DWORD cbServerConfig = sizeof(szServerConfig);
    DWORD dwValueType = 0;
    int port;

    m_szHostName.Empty();
    m_szAdminPort.Empty();
    m_szAdminSecurity.Empty();

    sprintf(szKey, KEY_SOFTWARE_NETSCAPE "\\" ADM_KEY_ROOT "\\" ADM_ID_SERVICE "-serv");
	if(!REG_GetRegistryParameter( HKEY_LOCAL_MACHINE, szKey, VALUE_CONFIG_PATH, &dwValueType, (LPBYTE)szServerConfig, &cbServerConfig))
        return FALSE;

    m_szAdminConfPath = szServerConfig;

    sprintf(tstr, "%s\\ns-admin.conf", (LPCTSTR)m_szAdminConfPath);
    if( (f = fopen(tstr, "r")) ) {
        while(fgets(tstr, sizeof(tstr), f)) {
            if( sscanf (tstr, "Port %d\n", &port ) == 1 )
                m_szAdminPort.Format ( "%d", port );
            if( sscanf (tstr, "ServerName %s\n", &szHostName ) == 1 )
                m_szHostName = szHostName;
            if( sscanf (tstr, "Security %s\n", &szSecurity ) == 1 )
                m_szAdminSecurity = szSecurity;
        }
        fclose(f);
    }

    if ( m_szHostName.IsEmpty() || m_szAdminPort.IsEmpty() )
        return FALSE;

    return TRUE;
}

/*---------------------------------------------------------------------------*\
 *
 * Function:  FindNetscapeNavigator
 *
 *  Purpose:  This function gets the default host name
 *
 *    Input:
 *
 *  Returns:
 *
 * Comments:
\*---------------------------------------------------------------------------*/

BOOL CAdminApp::FindNetscapeNavigator()
{
    char * szKey;
    char * szName;
    DWORD dwValueType;
    DWORD dwTempSize = 256;
    char szTemp[256];

	/* get Netscape Navigator executable */
    szKey = KEY_APP_PATH "\\netscape.exe";
	if( !REG_CheckIfKeyExists( HKEY_LOCAL_MACHINE, szKey ) )
        return FALSE;

	szName = "";
    dwTempSize = 256;
	if( !REG_GetRegistryParameter( HKEY_LOCAL_MACHINE, szKey, szName, &dwValueType, (LPBYTE)szTemp, &dwTempSize ) ) 
        return FALSE;
    m_szNetscapeNavigatorExe = szTemp;

    return TRUE;
}

/*---------------------------------------------------------------------------*\
 *
 * Function:  GetAdminServiceRunning
 *
 *  Purpose:  Installs and starts the Admin service if not already running
 *
 *    Input:
 *
 *  Returns:
 *
 * Comments:
\*---------------------------------------------------------------------------*/
BOOL CAdminApp::GetAdminServiceRunning ()
{
    char szMsg[MAX_PATH];
    DWORD dwLastError;
    if ( SERVICE_StartNTServiceAndWait( ADM_ID_SERVICE "-serv", &dwLastError) )
        return TRUE;

    wsprintf ( szMsg, "Unable to start %s", ADM_NAME_SERVICE);
    AfxMessageBox( szMsg );
    return FALSE;
}



/*---------------------------------------------------------------------------*\
 *
 * Function:  StartAdminService
 *
 *  Purpose:  Starts specified service
 *
 *    Input:
 *
 *  Returns:
 *
 * Comments:
\*---------------------------------------------------------------------------*/
BOOL CAdminApp::GetAdminServerRunning ()
{
    if ( m_WinNT )
    {
        return GetAdminServiceRunning();
    }
    return FALSE;
}




void CAdminApp::StartBrowser() 
{
    CString szCmdLine;
    CString szProgram;
    CString szParam;
    UINT error;

    // place quotes around program 
    szProgram = "\"";
    szProgram = szProgram + m_szNetscapeNavigatorExe;
    szProgram = szProgram + "\"";

#if 0
    szParam = "http://";		/* does not work with all browsers */
#else
    if ( m_szAdminSecurity.IsEmpty() || strcmp(m_szAdminSecurity, "on"))
        szParam = "";
    else
        szParam = "https://";		/* does not work with all browsers */
#endif
    szParam = szParam + m_szHostName;

    szParam = szParam + ":";
    szParam = szParam + m_szAdminPort;
    szParam = szParam + "/admin-serv/bin/index";
    
    szCmdLine = szProgram;
    szCmdLine = szCmdLine + " ";
    szCmdLine = szCmdLine + szParam;

    if ( !GetAdminServerRunning() )
        return;

	// TODO: Add extra validation here
    error = WinExec ( szCmdLine, SW_SHOW );
    if ( error <= 31 ) {
        AfxMessageBox ( "Netscape Navigator failed to start.\n"
                        "Please re-install Netscape Navigator." );
    }
}

