# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
#
# Makefile for the Admin Server package
#
#

MCOM_ROOT=$(shell cd ../..;pwd)
DEPTH=$(MCOM_ROOT)

include $(MCOM_ROOT)/adminserver/nsdefs.mk
include $(MCOM_ROOT)/adminserver/nsconfig.mk
include $(MCOM_ROOT)/adminserver/components.mk

# Path to Admin Acceptance test.
Admin_ACCEPTANCE_SRV=$(MCOM_ROOT)/tetframework/testcases/AS/5.0/acceptance/acceptServer
#commented out by kris since we no more using the GUI test
#Admin_ACCEPTANCE=$(MCOM_ROOT)/tetframework/testcases/AS/4.5/acceptance/accept

# Source directories
JAVADIR=$(MCOM_ROOT)/adminserver/built/java/$(DIR)

# Destination directories for package
RELTOP=$(BUILD_SHIP)/$(PLATFORM_DEST)
PKGTOP=$(PLATFORM_PACKAGE_DIR)
PKGDIR=$(PLATFORM_PACKAGE_DIR)/admin

ADMIN_JARS=$(MCOM_ROOT)/adminserver/built/package/java/admin

ADM_CORE=$(DIR)
ADM_CLIENT=client

UNZIPPED_DIR=$(PKGDIR)/unzipped
ADMIN_DIR=$(UNZIPPED_DIR)/$(ADM_CORE)
CLIENT_DIR=$(UNZIPPED_DIR)/$(ADM_CLIENT)

#BASELIB_UNZIPPED_DIR=$(PKGTOP)/base/unzipped/base/lib
#FILTER_DUP_FILES=$(MCOM_ROOT)/adminserver/admserv/filter-dupfiles.sh

CHMOD=chmod
CPIO=cpio -pdum$(VERBOSE)
MV=mv
MKDIR=mkdir -p
ifeq ($(BUILD_DEBUG), optimize)
ifeq ($(ARCH), IRIX)
STRIP=strip -x
else
STRIP=strip
endif
else
STRIP=true
endif

LWCP = cp      # cp -r behave different on HP

ifeq ($(ARCH), AIX)
export PATH:=/tools/ns-arch/rs6000_ibm_aix3.2.5/bin:/usr/local/aix32/bin:/usr/bin/X11:$(PATH)
export GTAR=/share/builds/f/gtar/bin/aix-gtar
export HTTPDLIB=libnshttpd$(DLL_PRESUF).$(DLL_SUFFIX)
export ADMSERVLIB=libnsadmin$(DLL_PRESUF).$(DLL_SUFFIX)
endif
ifeq ($(ARCH), HPUX)
export PATH:=/usr/local/hpux/bin:/usr/bin/X11:$(PATH)
export GTAR=/share/builds/f/gtar/bin/hpux-gtar
export HTTPDLIB=libnshttpd.sl
export ADMSERVLIB=libnsadmin.sl
LWCP = /usr/local/bin/cp
endif
ifeq ($(ARCH), Linux)
export PATH:=/bin:/usr/bin:/usr/sbin:/usr/X11R6/bin:$(PATH)
export HTTPDLIB=ns-httpd.so
export ADMSERVLIB=ns-admin.so
endif
ifeq ($(ARCH), OSF1)
export PATH:=/usr/local/dec/bin:/usr/bin/X11:$(PATH)
export GTAR=/share/builds/f/gtar/bin/osf1-gtar
export HTTPDLIB=ns-httpd.so
export ADMSERVLIB=ns-admin.so
endif
ifeq ($(ARCH), SOLARIS)
export PATH:=/usr/ccs/bin:/usr/openwin/bin:$(PATH)
export GTAR=/share/builds/f/gtar/bin/solaris-gtar
export HTTPDLIB=ns-httpd.so
export ADMSERVLIB=ns-admin.so
NO_JAVA=0
endif
ifeq ($(ARCH), SOLARISx86)
export OPENWINHOME:=/usr/openwin
export PATH:=/usr/ccs/bin:/usr/openwin/bin:$(PATH)
export HTTPDLIB=ns-httpd.so
export ADMSERVLIB=ns-admin.so
endif

ifeq ($(ARCH), SOLARISx86)
TAR=/bin/tar
else
TAR=tar
endif

# Temporary disable T zip option (test), as nighty builds are 
# failing because of it. Override IZIP definition in nsdefs.mk.
ifeq ($(ARCH), Linux)
#IZIP  = $(ZIP) -ry9u
IZIP  = $(ZIP) -ry9uT -n .gif
endif

ifneq ($(strip $(ADM_VERSION)),)
all:
	-if [ ! -d $(PKGTOP) ]; then \
	   $(MKDIR) $(PKGTOP) ; \
	fi
ifneq ($(ARCH), WINNT)
	cd $(PKGTOP); find . -type f -exec chmod go-w {} \;
endif
	cd $(PKGTOP); $(TAR) xf $(ADM_RELEASE)/admserv.tar
else

all:  pkguxClient pkguxAdmin pkgSetup pkgSBC

endif

pkguxClient: pkguxConsole $(CLIENT_DIR)
	echo "===== Packaging Admin Server client ======"
	echo
	rm -rf $(CLIENT_DIR)/*
	-$(MKDIR) $(CLIENT_DIR)/java
	-$(MKDIR) $(CLIENT_DIR)/java/jars

	cd $(ADMIN_JARS) ; \
	   cp -p admserv$(ADM_SUF).jar admserv$(ADM_SUF)_en.jar $(CLIENT_DIR)/java/jars

#
# Cleanup before making distributable zip
#

	-find $(PKGDIR) -type d -name CVS -prune -exec rm -rf {} \;
	-find $(PKGDIR) -type f \( -name '*.o' -o -name '.*' \) -exec rm {} \;
	-find $(PKGDIR) -type f -exec chmod go-w {} \;
	cd $(CLIENT_DIR) ; \
	   $(IZIP) $(PKGDIR)/ns$(ADM_CLIENT).zip * ;

pkguxConsole:
	cd console; $(MAKE) BUILD_MODULE=HTTP_ADMIN package $(MFLAGS)

pkguxAdmin: $(ADMIN_DIR) new-pkguxAdmin

new-pkguxAdmin:
# Note: need to create $(PKGDIR)/unzipped/admserv for backwards compat --MLM
# Note: need to do admin-nickname rather than admin-serv --MLM

	-touch $(ADMIN_DIR)/admserv

	-$(MKDIR) $(ADMIN_DIR)/dist
	-$(MKDIR) $(ADMIN_DIR)/java/jars
	-$(MKDIR) $(ADMIN_DIR)/java/html/en

	-$(MKDIR) $(ADMIN_DIR)/admin-serv
	-$(MKDIR) $(ADMIN_DIR)/admin-serv/config
	-$(MKDIR) $(ADMIN_DIR)/admin-serv/logs
	-$(MKDIR) $(ADMIN_DIR)/admin-serv/ldif

	-$(MKDIR) $(ADMIN_DIR)/bin/https
	-$(MKDIR) $(ADMIN_DIR)/bin/https/bin
	-$(MKDIR) $(ADMIN_DIR)/bin/https/lib
#ifneq ($(ARCH), SOLARISx86)
#	-$(MKDIR) $(ADMIN_DIR)/bin/https/lib/smartheap
#endif
	-$(MKDIR) $(ADMIN_DIR)/bin/https/jar
	-$(MKDIR) $(ADMIN_DIR)/bin/https/httpadmin
	-$(MKDIR) $(ADMIN_DIR)/bin/https/httpadmin/bin
	-$(MKDIR) $(ADMIN_DIR)/bin/https/dtds
	-$(MKDIR) $(ADMIN_DIR)/userdb
	-$(MKDIR) $(ADMIN_DIR)/bin/admin
	-$(MKDIR) $(ADMIN_DIR)/bin/admin/lib
	-$(MKDIR) $(ADMIN_DIR)/bin/admin/property
	-$(MKDIR) $(ADMIN_DIR)/bin/admin/admin
	-$(MKDIR) $(ADMIN_DIR)/bin/admin/admin/icons

	-$(MKDIR) $(ADMIN_DIR)/bin/user
	-$(MKDIR) $(ADMIN_DIR)/bin/user/admin
	-$(MKDIR) $(ADMIN_DIR)/bin/user/admin/bin
	-$(MKDIR) $(ADMIN_DIR)/bin/user/admin/gifs
	-$(MKDIR) $(ADMIN_DIR)/bin/user/admin/html/en

	-$(MKDIR) $(ADMIN_DIR)/lib
	-$(MKDIR) $(ADMIN_DIR)/lib/property

	-mkdir -p $(ADMIN_DIR)/include
	-$(MKDIR) $(ADMIN_DIR)/install
	-$(MKDIR) $(ADMIN_DIR)/manual

	-$(MKDIR) $(ADMIN_DIR)/setup
	-$(MKDIR) $(ADMIN_DIR)/setup/admin

	-$(MKDIR) $(ADMIN_DIR)/clients

# richm - new - for admin_ip.pl
	-$(MKDIR) $(ADMIN_DIR)/shared
	-$(MKDIR) $(ADMIN_DIR)/shared/bin
# for certmap.conf
	-$(MKDIR) $(ADMIN_DIR)/shared/config

	cp -p $(ADMSERV_OBJDIR)/cgi/bin/download $(ADMIN_DIR)/dist

	cd $(ADMSERV_OBJDIR)/install/bin ; \
	cp -p ns-config $(ADMIN_DIR)/bin/admin ; \
	cp -p ns-update $(ADMIN_DIR)/bin/admin ; \
	cp -p ns-remove $(ADMIN_DIR)/bin/admin

# Handle "lib" directory
# Copy LDAP SDK
	cd $(LDAP_LIBPATH); cp -p $(LDAP_SOLIBS) $(ADMIN_DIR)/bin/admin/lib

# 622185: Moved NSPR and NSS from admin package to client package.  Since
# client package is Mandatory at install, they will always get installed now.
# Copy NSPR SDK
#	cd $(NSPR_LIBPATH); cp -p $(NSPR_SOLIBS) $(ADMIN_DIR)/bin/admin/lib
#
# Copy SECURITY SDK
#	cd $(SECURITY_LIBPATH); cp -p $(SECURITY_SOLIBS) $(ADMIN_DIR)/bin/admin/lib

# Copy LIB ICU
	cd $(ICU_LIBPATH); cp -p $(ICU_SOLIBS) $(ADMIN_DIR)/bin/admin/lib

# Cert System needs chk files [154431]
	cd $(NSPR_LIBPATH); cp -p libsoftokn3.chk $(ADMIN_DIR)/bin/admin/lib
# libfreebl_*.chk files only exist on the 32-bit builds.
# They should be packaged only for the 32-bit builds.
ifneq ($(USE_64), 1)
ifeq ($(ARCH), SOLARIS)
	cd $(NSPR_LIBPATH); cp -p libfreebl_*.chk $(ADMIN_DIR)/bin/admin/lib
endif
ifeq ($(ARCH), HPUX)
	cd $(NSPR_LIBPATH); cp -p libfreebl_*.chk $(ADMIN_DIR)/bin/admin/lib
endif
endif

# Copy LIB ADMIN UTIL
	cd $(ADMSDK_LIBPATH); cp -p $(ADMSDK_SOLIBS) $(ADMIN_DIR)/bin/admin/lib
	-$(MKDIR) $(ADMIN_DIR)/bin/admin/lib/property
	cp -p $(ADMSDK_LIBPATH)/property/* $(ADMIN_DIR)/bin/admin/lib/property

# Need a copy of LIB ADMIN UTIL for adminserver plugin for https
	cd $(ADMSDK_LIBPATH); cp -p $(ADMSDK_SOLIBS) $(ADMIN_DIR)/bin/https/lib
	-$(MKDIR) $(ADMIN_DIR)/bin/https/lib/property
	cp -p $(ADMSDK_LIBPATH)/property/* $(ADMIN_DIR)/bin/https/lib/property

# Need a copy of LIB ICU for adminserver plugin for https
	cd $(ICU_LIBPATH); cp -p $(ICU_SOLIBS) $(ADMIN_DIR)/bin/https/lib

	cd $(ADMSERV_OBJDIR)/cmdln; \
	cp -p admconfig $(ADMIN_DIR)/bin/admin;

	cd $(ADMIN_JARS)/.. ; \
	   find *.html *.gif *.jpg | $(CPIO) $(ADMIN_DIR)/java/html
	cd $(ADMIN_JARS)/.. ; \
	   find *.html | $(CPIO) $(ADMIN_DIR)/java/html/en

	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/bin ; \
	   ls ns-httpd uxwdog Cgistub | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/bin

	-$(MKDIR) $(ADMIN_DIR)/bin/https/res
	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/res; \
	   ls cjava_root.res | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/res
 
    # Copy iWS library files excluding those that are at runtime 
    # already available in <server-root>/lib.
    # SECURITY_SECMOD_SOLIB must be removed explicitly as it is
    # stored in <server-root>/admin-serv/config and not found
    # in <server-root>/lib.
    # richm 20030425 - not anymore - Admin Server is responsible for packaging its own
    # files - AS will not use the common serverroot/lib directory anymore
	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/lib ; \
	   ls | $(CPIO) $(ADMIN_DIR)/bin/https/lib
	-rm $(ADMIN_DIR)/bin/https/lib/$(SECURITY_SECMOD_SOLIB)
#	   sh $(FILTER_DUP_FILES) . $(BASELIB_UNZIPPED_DIR) | \
#	      $(CPIO) $(ADMIN_DIR)/bin/https/lib
#	-rm $(ADMIN_DIR)/bin/https/lib/$(SECURITY_SECMOD_SOLIB)

#ifneq ($(ARCH), SOLARISx86)
#	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/lib/smartheap ; \
#	   ls *.* | \
#	      $(CPIO) $(ADMIN_DIR)/bin/https/lib/smartheap
#endif

	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/jar ; \
	   ls NSServletLayer.jar NSJavaUtil.jar NSJavaMiscUtil.jar servlet*.jar \
	      jaxp.jar crimson.jar xalan.jar jakarta-naming.jar jspengine.jar | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/jar

	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/res ; \
	   ls * | \
	      $(CPIO) $(ADMIN_DIR)/admin-serv/config

	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/httpadmin/bin ; \
	   ls shutdown  | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/httpadmin/bin

	cd $(NSCP_COMPDIR)/nescore/$(NSOBJDIR_NAME)/bin/https/dtds ; \
	   ls *.dtd  | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/dtds

	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/jvm12.conf $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/contexts.properties $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/rules.properties.default $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/servlets.properties.default $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/server.xml $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/server.dtd $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/mime.types $(ADMIN_DIR)/admin-serv/config
#	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/exempturis.conf $(ADMIN_DIR)/admin-serv/config
	cp -p $(MCOM_ROOT)/adminserver/admserv/newinst/common/config/not_installed.html $(ADMIN_DIR)/clients

	cd $(ADMSERV_OBJDIR)/plugins ; \
	   ls * | \
	      $(CPIO) $(ADMIN_DIR)/bin/https/lib

	cd $(ADMSERV_OBJDIR)/cgi ; \
	   find html bin -print | \
	      $(CPIO) $(ADMIN_DIR)/bin/admin/admin

	rm -f $(ADMIN_DIR)/bin/admin/admin/bin/download

	cd $(ADMSERV_OBJDIR)/cgi/icons40 ; \
	cp -p * $(ADMIN_DIR)/bin/admin/admin/icons;

	cd $(ADMSERV_OBJDIR)/manual ; \
		find help -print | \
			$(CPIO) $(ADMIN_DIR)/manual

	(cd $(ADMIN_DIR)/manual; $(UNZIP) -o $(ADMDOC_PATH)/$(ADMDOC_ADMONLINEHELP))

	cd $(ADMSERV_OBJDIR)/cgi/cfgstuff ; \
	   ls dsgw* | $(CPIO) $(ADMIN_DIR)/admin-serv/config

#	cat $(ADMSERV_OBJDIR)/ldif/tasks.ldif $(ADMSERV_OBJDIR)/ldif/unixtasks.ldif > $(ADMIN_DIR)/admin-serv/ldif/tasks.ldif
	cp -p $(ADMSERV_OBJDIR)/ldif/tasks.ldif $(ADMIN_DIR)/admin-serv/ldif
	cp -p $(ADMSERV_OBJDIR)/ldif/global.ldif $(ADMIN_DIR)/admin-serv/ldif

# Copy admin_ip.pl (see bug#357241)
	cp -p $(ADMSERV_OBJDIR)/cgi/cfgstuff/admin_ip.pl $(ADMIN_DIR)/shared/bin

# Handle "install" directory
# Copy Perl package
ifeq ($(ARCH), Linux)
	# Because this perl is broken on modern linuxen (it depends on libdb, wich isn't installed by default, for example), we don't package it. Instead we use the perl installed on the system
	#cd $(COMPONENTS_DIR)/perl5 ; \
	   ls artistic | $(CPIO) $(ADMIN_DIR)/install ; \
	   cd $(ARCH)2.1-perl5 ; ls perl | $(CPIO) $(ADMIN_DIR)/install
else
	cd $(COMPONENTS_DIR)/perl5 ; \
	   ls artistic | $(CPIO) $(ADMIN_DIR)/install ; \
	   cd $(ARCH)-perl5 ; ls perl | $(CPIO) $(ADMIN_DIR)/install
endif

# Copy shared configuration
	cp $(MCOM_ROOT)/adminserver/lib/ldaputil/certmap.conf $(ADMIN_DIR)/shared/config
# Same copy in <server root>/userdb for new core ES engine
	cp $(MCOM_ROOT)/adminserver/lib/ldaputil/certmap.conf $(ADMIN_DIR)/userdb

#
# Cleanup before making distributable tar
#

	-find $(PKGDIR) -type d -name CVS -prune -exec rm -rf {} \;
	-find $(PKGDIR) -type f \( -name '*.o' -o -name '.*' \) -exec rm {} \;

	-$(STRIP) $(ADMIN_DIR)/bin/admin/*
	-$(STRIP) $(ADMIN_DIR)/bin/admin/admin/bin/*
	-$(STRIP) $(ADMIN_DIR)/bin/user/admin/bin/*
	-$(STRIP) $(ADMIN_DIR)/dist/*
	-$(STRIP) $(ADMIN_DIR)/manual/help/*
	-find $(PKGDIR) -type f -exec chmod go-w {} \;

	cd $(ADMIN_DIR) ; \
	   $(IZIP) $(PKGDIR)/ns$(DIR).zip * ;

	if [ -f $(ADMSERV_OBJDIR)/$(ADM_CORE).inf ]; then \
	   cp -p $(ADMSERV_OBJDIR)/$(ADM_CORE).inf $(PKGDIR) ; \
        fi

	cp -p $(ADMIN_DIR)/bin/admin/ns-config $(PKGDIR)

pkgSetup:
	-find $(PKGDIR) -name setup -prune -exec rm -f {} \;
	-find $(PKGDIR) -name setup.inf -prune -exec rm -f {} \;
	-find $(PKGDIR) -name LICENSE.txt -prune -exec rm -f {} \;
	-find $(PKGDIR) -name README.txt  -prune -exec rm -f {} \;

	-if [ ! -d $(PKGTOP)/svrcore ]; then \
	   $(MKDIR) $(PKGTOP)/svrcore; \
	else \
	   rm -rf $(PKGTOP)/svrcore/*; \
	fi

	cp -p $(SETUPSDK_BIN)/setup $(PKGTOP)
	cp -p $(SETUPSDK_BIN)/setup.inf $(PKGTOP)
	cp -p $(ADMSERV_OBJDIR)/LICENSE.txt $(PKGTOP)
	cp -p $(ADMSERV_OBJDIR)/README.txt $(PKGTOP)

	cd $(SETUPSDK_BIN)/svrcore ; \
	   find * -print | \
	      $(CPIO) $(PKGTOP)/svrcore


#
# Creating unzipped directory
#
$(ADMIN_DIR):
	-if [ ! -d $(ADMIN_DIR) ]; then \
	   $(MKDIR) $(ADMIN_DIR) ; \
	else \
	   rm -f $(PKGDIR)/$(ADM_CORE).inf; \
	   rm -f $(ADMIN_DIR)/ns$(ADM_CORE).zip ; \
	fi

$(CLIENT_DIR):
	-if [ ! -d $(CLIENT_DIR) ]; then \
	   $(MKDIR) $(CLIENT_DIR) ; \
	else \
	   rm -f $(PKGDIR)/ns$(ADM_CLIENT).zip ; \
	fi

#
# For SNMP Plugins
#
pkguxSNMP:
	-$(MKDIR) $(ADMIN_DIR)/plugins/snmp/magt
	-$(MKDIR) $(ADMIN_DIR)/plugins/snmp/sagt
	if [ -f $(MCOM_ROOT)/adminserver/lib/libsnmp/netscape-main.mib ]; then \
	   cd $(MCOM_ROOT)/adminserver/lib/libsnmp ; \
	   cp -p netscape-main.mib $(ADMIN_DIR)/plugins/snmp/netscape-main.mib ; \
	fi
	cd $(DEVROOT)/$(NSOBJDIR_NAME) ; \
	   find magt sagt -print | $(CPIO) $(ADMIN_DIR)/plugins/snmp
	-$(STRIP) $(ADMIN_DIR)/plugins/snmp/magt/*
	-$(STRIP) $(ADMIN_DIR)/plugins/snmp/sagt/*

pkgSBC:
ifneq ($(ARCH), WINNT)
	cd $(PKGTOP); find . -type f -exec chmod go-w {} \;
endif
ifdef BUILD_SHIP
	-$(MKDIR) $(RELTOP)
	-rm $(RELTOP)/admserv.ex
	echo "base/unzipped" > $(RELTOP)/admserv.ex
	echo "admin/unzipped" >> $(RELTOP)/admserv.ex
	echo "svrcore/unzipped" >> $(RELTOP)/admserv.ex
	cd $(PKGTOP); $(TAR) cvfX $(RELTOP)/admserv.tar $(RELTOP)/admserv.ex *
	-rm  $(RELTOP)/admserv.tar.gz $(RELTOP)/admserv.ex
	cd $(RELTOP); gzip -f admserv.tar
endif      

Acceptance:

ifdef BUILD_SHIP
ifeq ($(BUILD_SECURITY), domestic)
ifeq ($(BUILD_DEBUG), optimize)
#	$(Admin_ACCEPTANCE) $(RELTOP)/admserv.tar.gz
	$(Admin_ACCEPTANCE_SRV) $(RELTOP)/admserv.tar.gz
endif  # optimize
endif  # domestic
endif  # BUILD_SHIP
