/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * admhash: takes a set of URIs on stdin, spits out structure 
 * initializations which are the 16-byte MD5 hash of the strings
 * 
 * Rob McCool (based on stuff by AL)
 */


#include "sec.h"

#define MAXITEM 1024
#define MAXURI 1024


int main(int argc, char *argv[])
{
    unsigned char digest[16];
    char item[MAXURI], prefix[MAXURI], uri[MAXURI];
    register int x;
    int first = 1;

    fputs("static char admin_urls[][16] = {\n", stdout);

    while(1) {
        if(scanf("%s", item) != 1)
            break;

        if(strchr(item, '/'))
            strcpy(prefix, item);
        else {
            if(!first)
                fputs(",\n", stdout);
            else
                first = 0;
            sprintf(uri, "%s%s", prefix, item);
            MD5_Hash(digest, uri);
            printf("/* %s */\n", uri);
            putchar('{');
            for(x = 0; x < 15; x++) {
                printf("0x%x,", (int) digest[x]);
                if(x == 12)
                    fputs("\n ", stdout);
            }
            printf("0x%x}", digest[15]);
        }
    }
    fputs("\n};\n", stdout);
    return 0;
}
