/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*********************************************/
/*                                           */
/* hashtable.c : a hashtable ADT             */
/*                                           */
/* David Tompkins 2/11/98                    */
/*                                           */
/*********************************************/

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include <base/util.h>
#include <base/plist.h>

#include "hashtable.h"

struct HashTable {
   PList_t plist;
};
 
HashTable*
HashTableCreate()
{
   HashTable *ht = malloc(sizeof(HashTable));
    
   if (!ht)
      return NULL;

   ht->plist = PListNew(0);

   return ht;
}

int
HashTableInsert(HashTable *ht, char *name, void *value)
{
   int rv;

   if ((rv = PListFindValue(ht->plist, name, 0, 0)) >= 0)
      return (PListSetValue(ht->plist, rv, value, 0) >= 0);

   return (PListInitProp(ht->plist, 0, name, value, 0) >= 0);
}

void *
HashTableFind(HashTable *ht, char *name)
{
   void *value = NULL;

   (void)PListFindValue(ht->plist, name, &value, 0);

   return value;
}

void
HashTableEnumerate(HashTable *ht, HashEnumFunc *fn, void *data)
{
   PListEnumerate(ht->plist, fn, data);
}
