/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

///////////////////////////////////////////////////////
//
//  ntinit.c --
//      init program for NT Netsite Service.
//
//	contains startup routines for the creation of windows for the Netsite application
//
//  1/23/95 aruna




#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

#include "netsite.h"
#include "base/eventlog.h"
#include "base/util.h"

#include "frame/conf.h"
#include "base/cinfo.h"

#include <nt/regparms.h>
#include <nt/magnus.h>

HWND hwndMain;
extern HINSTANCE hInstance;

#define MAIN_WIDTH          605    // Default width and height of main window
#define MAIN_HEIGHT         400

LONG APIENTRY WndProc(HWND hWndFrame, UINT wMsg, WPARAM wParam, LONG lParam);

BOOL InitializeService()
{
    WNDCLASS wc;
	int error;

	wc.style        = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc  = WndProc;
	wc.cbClsExtra   = 0;
	wc.cbWndExtra   = 0;
	wc.hInstance    = hInstance;
	//wc.hIcon      = LoadIcon(ghModule, MAKEINTRESOURCE(UI_FILERICON));
	wc.hIcon			= NULL;
	//wc.hCursor      = LoadIcon(ghModule, MAKEINTRESOURCE(UI_FILERICON));
	wc.hCursor			= NULL;
	wc.hbrBackground    = (HBRUSH)(COLOR_INACTIVECAPTION);
	wc.lpszMenuName = NULL;
	wc.lpszClassName    = TEXT("AdminClass");

    if (!RegisterClass(&wc)) {
		error = GetLastError();
		return FALSE;
	}

    hwndMain = CreateWindow(TEXT("AdminClass"),
                             TEXT("Admin"),
                             WS_OVERLAPPEDWINDOW | WS_POPUP,
                             CW_USEDEFAULT,
                             CW_USEDEFAULT,
                             MAIN_WIDTH,
                             MAIN_HEIGHT,
                             NULL,
                             NULL,
                             hInstance,
                             NULL);

    if (hwndMain == NULL) {
		return FALSE;
	}

	ShowWindow(hwndMain, SW_HIDE);
	UpdateWindow(hwndMain);

    return TRUE;
}

LONG APIENTRY WndProc(HWND hWndFrame, UINT wMsg, WPARAM wParam, LONG lParam)
{
	switch(wMsg) {
        case WM_PAINT:
            return 0;

        case WM_DESTROY:
            SuspendHttpdService();
            PostQuitMessage(0);

		default:
			return(DefWindowProc(hWndFrame, wMsg, wParam, lParam));
	}
    return 0;
}
