/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

///////////////////////////////////////////////////////
//
//  ntinit.c --
//      init program for NT Netsite Service.
//
//	contains startup routines for the creation of windows for the Netsite application
//
//  1/23/95 aruna




#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

#include "netsite.h"
#include "resource.h"
#include "base/eventlog.h"
#include "base/util.h"

#include "frame/conf.h"
#include "base/cinfo.h"

#include <nt/regparms.h>
#include <nt/magnus.h>

HWND hwndMain, hdlgMain;
#define MAIN_WIDTH          605    // Default width and height of main window
#define MAIN_HEIGHT         400

LRESULT WINAPI HttpdWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LONG APIENTRY WndProc(HWND hWndFrame, UINT wMsg, WPARAM wParam, LONG lParam);

BOOL
CreateNetsiteDialog()
{
	return TRUE;
	
}

BOOL InitializeService()
{
    WNDCLASS wc;

    wc.cbClsExtra   = 0;
    wc.cbWndExtra   = 0;
    wc.hInstance    = hInstance;
    //wc.hIcon      = LoadIcon(ghModule, MAKEINTRESOURCE(UI_FILERICON));
    wc.style        = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc  = WndProc;
    wc.hbrBackground    = (HBRUSH)(COLOR_INACTIVECAPTION);
    wc.lpszClassName    = TEXT("HttpdClass");
	wc.hIcon			= NULL;
	wc.lpszMenuName = NULL;

    if (!RegisterClass(&wc)) {
		return FALSE;
	}


    hwndMain = CreateWindow(TEXT("HttpdClass"),
                             TEXT("Httpd"),
                             WS_OVERLAPPEDWINDOW | WS_POPUP,
                             CW_USEDEFAULT,
                             CW_USEDEFAULT,
                             MAIN_WIDTH,
                             MAIN_HEIGHT,
                             NULL,
                             NULL,
                             hInstance,
                             NULL);

    if (hwndMain == NULL) {
		return FALSE;
	}

	ShowWindow(hwndMain, SW_HIDE);
	UpdateWindow(hwndMain);
	//hdlgMain = CreateDialog(hInstance,
							//MAKEINTRESOURCE(DLG_GETPASSWORD), HWND_DESKTOP,
							//(DLGPROC)HttpdWndProc);


    return TRUE;
}

int ServiceLoop()
{

    MSG  msg;

    while(GetMessage(&msg,NULL,0,0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

	return(msg.wParam);
}

LONG APIENTRY WndProc(HWND hWndFrame, UINT wMsg, WPARAM wParam, LONG lParam)
{
	switch(wMsg) {
		default:
			return(DefWindowProc(hWndFrame, wMsg, wParam, lParam));
	}
}


LRESULT WINAPI HttpdWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    static HBRUSH   hBrush;

    switch (message){
      case WM_INITDIALOG:{

        //
        // Sets background color of Toolbar non-modal dialog children.
        //
        hBrush = CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW));

        return(FALSE);
      }

      case WM_PAINT:{
        RECT     rc;
        PAINTSTRUCT ps;

        //
        // Paint btnshadow background.
        //
        GetClientRect(hDlg, &rc);
        InvalidateRect(hDlg, &rc, FALSE);

        BeginPaint(hDlg, &ps);

        FillRect(ps.hdc, &rc, hBrush);

        EndPaint(hDlg, &ps);

        return(TRUE);
      }


      case WM_DESTROY:{
          DeleteObject(hBrush);
          break;
      }
    }
    return(FALSE);
}


