# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
ifneq ($(ARCH), WINNT)

SRCDIR=$(MCOM_ROOT)/adminserver/admserv/src
#ADMUTILLINK = -L$(OBJDIR)/lib -l$(LIBADMSSLUTIL) -l$(LIBADMINUTIL)

ifdef USE_LD_RUN_PATH
EXTRA_LIBS += -L.
export LD_RUN_PATH=./lib:./.:../../lib
endif

ifeq ($(ARCH), OSF1)
DLL_LDFLAGS += -soname $(SONAME) 
endif

ifeq ($(ARCH), IRIX)
DLL_LDFLAGS += -soname $(SONAME)
EXTRA_LIBS += -L./lib -L. -L../../lib -rpath .:../../lib
SOLINK2=./ns-admin.so
endif

ifeq ($(ARCH), SOLARIS)
EXTRA_LIBS += -R./lib:.:../../lib
endif

ifeq ($(ARCH), UNIXWARE)
EXTRA_LIBS += -L./lib -L.
endif

ifeq ($(ARCH), HPUX)
DLL_LDFLAGS += -L.
SONAME=libnsadmin$(DLL_PRESUF).$(DLL_SUFFIX)
SOLINK=-L./lib -L. -L../../lib -lnsadmin $(ADMSDKLINK)
EXTRA_LIBS += -Wl,+b./lib:.:../../lib
#LDAPLINK=-L./lib -L. -L../../lib \
#	$(addprefix -l, $(LDAP_SSLLIB_NAMES)) \
#	$(addprefix -l, $(LDAP_SOLIB_NAMES))
endif

ifeq ($(ARCH), AIX)
EXTRA_LIBS := -L.:/usr/lib/threads:/usr/lpp/xlC/lib:/usr/lib:/lib \
	-bI:/usr/lib/lowsys.exp -L. -lC_r -lC -lpthreads -lc_r -lm \
	/usr/lib/libc.a -ldl -lbsd
SONAME=libnsadmin$(DLL_PRESUF).$(DLL_SUFFIX)
SOLINK=-L./lib -L. -L../../lib -lnsadmin$(DLL_PRESUF) $(ADMSDKLINK)
LIBSECDIR=$(MCOM_ROOT)/lib/libsec/$(NSOBJDIR_NAME)
#LDAPLINK=-L../../lib \
#	$(addprefix -l, $(LDAP_SSLLIB_NAMES)) \
#	$(addprefix -l, $(LDAP_SOLIB_NAMES))
endif

ifeq ($(ARCH), SUNOS4)
EXTRA_LIBS += -L./lib -L.
endif

EXTRA_LIBS += $(MATHLIB)

# It's important to understand := here.  This prevents later mods of
# EXTRA_LIBS from affecting the DLL_LINK line
# If shared object also have problems finding other shared objects without
# a -rpath command, then we need to define ADM_EXTRA for each system as
# well at EXTRA_LIBS depending up what command they use for LINK_DLL
#
ifneq ($(ARCH), SOLARIS)
ifneq ($(ARCH), IRIX)
ifneq ($(ARCH), HPUX)
ADM_EXTRA := $(EXTRA_LIBS)
# PVO
ifeq ($(ARCH), AIX)
ADM_EXTRA += -brtl -berok
endif
endif
endif
endif

ifndef SONAME
SONAME=ns-admin.so
endif

ifndef SOLINK
SOLINK=./ns-admin.so $(ADMSDKLINK)
endif

ifndef LDAPLINK
LDAPLINK=$(LDAPOBJNAME)
endif

# Temporary directory for the libraries and their object files
$(OBJDIR)/admin-lib:
#ifdef NSPR20
#	mkdir -p $(OBJDIR)/admin-lib/nspr20
#	mkdir -p $(OBJDIR)/admin-lib/sslio
#else
#	mkdir -p $(OBJDIR)/admin-lib/nspr
#endif
#	mkdir -p $(OBJDIR)/admin-lib/sslio
	mkdir -p $(OBJDIR)/admin-lib/mocha
#	mkdir -p $(OBJDIR)/admin-lib/libsec
#	mkdir -p $(OBJDIR)/admin-lib/libdbm
#	mkdir -p $(OBJDIR)/admin-lib/xp
	mkdir -p $(OBJDIR)/admin-lib/ldap

# Define a LIBSEC which doesn't include libdbm and xp.
#ifndef LIBSECOBJS
#LIBSEC1=$(MCOM_LIBDIR)/libsec/$(NSOBJDIR_NAME)/libsec-$(WHICHA).$(LIB_SUFFIX)
#else
#LIBSEC1=$(LIBSECOBJS)
#endif

ifdef FORTEZZA
#LIBSEC1 += $(MCOM_LIBDIR)/../dist/$(NSOBJDIR_NAME)/lib/libci.a
endif


#DEPLIBS = $(OBJDIR)/lib/libhttpdaemon.a $(OBJDIR)/lib/libsafs.a $(OBJDIR)/lib/libsi18n.a $(ADMLIB) $(LIBLDAP)
#
#DEPLINK = $(OBJDIR)/lib/libhttpdaemon.a $(OBJDIR)/lib/libsafs.a $(OBJDIR)/lib/libsi18n.a $(SOLINK) $(LDAPLINK) $(NLSLINK) $(SOLINK2)

DEPLIBS = $(OBJDIR)/lib/libhttpdaemon.a $(OBJDIR)/lib/libsafs.a $(ADMLIB) $(LIBLDAP)

DEPLINK = $(OBJDIR)/lib/libhttpdaemon.a $(OBJDIR)/lib/libsafs.a $(SOLINK) $(LDAPLINK) $(NLSLINK) $(SOLINK2)

# Relative to the directory that contains the .so
BUILTDIR = .


SERVLIBS = $(addprefix $(OBJDIR)/lib/, libadmin.a libframe.a \
		libaccess.a libldapu.a libbase.a libsi18n.a $(ADMLIB_SEARCH_TARGET))
SERVLIB_DIRS = $(addprefix $(OBJDIR)/lib/, libadmin frame \
		libaccess base ldaputil libsi18n $(ADMLIB_SEARCH_TARGET))
SERVLIB_OBJS = $(subst $(OBJDIR)/,$(BUILTDIR)/, \
                       $(filter-out $(OBJDIR)/lib/libadmin/nsnews.o, \
                               $(wildcard $(addsuffix /*.o, $(SERVLIB_DIRS)))))

MOCHA=$(NSCP_DISTDIR)/lib/mocha.a
ifdef NSPR20
NSLIBS = $(SECLIB) $(SEARCH_LIBS)
else
NSLIBS = $(SECLIB) $(MOCHA) $(LIBNSPR) $(SEARCH_LIBS)
endif

ADMLIB_LIBS = $(SERVLIBS) $(NSLIBS)

mocha:
	cd $(MCOM_ROOT)/mocha; $(MAKE) export $(NSDEFS) $(MFLAGS)


admobjs:
ifdef NSPR20
#	cd $(OBJDIR)/admin-lib/nspr20; ar x $(LIBNSPR)
#	cd $(OBJDIR)/admin-lib/sslio; ar x $(LIBSSLIO)
else
	cd $(OBJDIR)/admin-lib/nspr; ar x $(LIBNSPR)
	cd $(OBJDIR)/admin-lib/mocha; ar x $(MOCHA)
endif
#	cd $(OBJDIR)/admin-lib/libdbm; ar x $(LIBDBM)
#	cd $(OBJDIR)/admin-lib/xp; ar x $(LIBXP)
#	rm -f $(addprefix $(OBJDIR)/admin-lib/xp/, xp_time.o xplocale.o \
                                                   xp_cntxt.o)
ifeq ($(ARCH),OSF1)
#	chmod a+rw $(OBJDIR)/admin-lib/*/________64ELEL_
endif

$(LDAPOBJNAME):	ldapobjs

ldapobjs:
	(cd $(OBJDIR); rm -f $(LDAPOBJNAME))
	cp $(LIBLDAP) $(OBJDIR)

OBJRULES += ldapobjs

#Since nothing left in admin-lib/*/*.o, we remove it
#ADMOBJS=$(SERVLIB_OBJS) $(BUILTDIR)/admin-lib/*/*.o
ADMOBJS=$(SERVLIB_OBJS)
OBJRULES += admobjs
ADMLIB=$(OBJDIR)/$(SONAME)

ifeq ($(ARCH), AIX)
$(ADMLIB): $(OBJDIR)/admin-lib $(ADMLIB_LIBS)
	$(MAKE) $(OBJRULES) $(MFLAGS)
	cd $(OBJDIR); nm -B -C -g $(SERVLIB_OBJS) \
			| awk '/ [T,D,B] / {print $$3}' \
			| sed -e 's/^\.//' \
			| sort -u > $(EXPORT_FILE)
	cd $(OBJDIR); $(LD) $(DLL_LDFLAGS) -o $(SONAME) -bE:$(EXPORT_FILE) \
                        $(SERVLIB_OBJS) \
			$(ADM_EXTRA)
else
ifeq ($(ARCH), SCO)
$(ADMLIB): $(OBJDIR)/admin-lib $(ADMLIB_LIBS)
	$(MAKE) $(OBJRULES) $(MFLAGS)
	cd $(OBJDIR); $(LINK_DLL) \
			$(SERVLIB_OBJS) $(ADM_EXTRA)
else
$(ADMLIB): $(OBJDIR)/admin-lib $(ADMLIB_LIBS)
	$(MAKE) $(OBJRULES) $(MFLAGS)
	cd $(OBJDIR); \
	$(LINK_DLL) -o $(SONAME) $(SERVLIB_OBJS) $(ADM_EXTRA);
endif
endif


endif
