# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
ifneq ($(ARCH), WINNT)

OLD_MCOM_ROOT := $(MCOM_ROOT)
MCOM_ROOT := $(shell cd $(OLD_MCOM_ROOT); pwd)
SRCDIR=$(MCOM_ROOT)/adminserver/admserv/user-forms/src

ifeq ($(ARCH), OSF1)
EXTRA_LIBS += -Wl,-rpath,../..:../../../../lib
endif

ifeq ($(ARCH), Linux)
EXTRA_LIBS += -Wl,-rpath,../../lib:../..:../../../../lib
endif

ifeq ($(ARCH), IRIX)
EXTRA_LIBS += -rpath ../..:../../../../lib
endif

ifeq ($(ARCH), SOLARIS)
EXTRA_LIBS += -R../..:../../../../lib
endif

ifeq ($(ARCH), SONY)
EXTRA_LIBS += -rpath ../..:../../../../lib
endif

ifeq ($(ARCH), NECSVR4)
EXTRA_LIBS += -L../..
endif

ifeq ($(ARCH), HPUX)
SONAME=libnsadmin.sl
SOLINK=-L../.. -lnsadmin
EXTRA_LIBS += -Wl,+b,../..:../../../../lib
endif

ifeq ($(ARCH), AIX)
SONAME=libnsadmin$(DLL_PRESUF).$(DLL_SUFFIX)
SOLINK=-L. -L../.. -L../../../../lib -lnsadmin$(DLL_PRESUF)
endif

ifeq ($(ARCH), SUNOS4)
EXTRA_LIBS += -L../..
endif

EXTRA_LIBS += $(MATHLIB) $(CCCLIB)

ifndef SONAME
SONAME=ns-admin.so
endif
ifndef SOLINK
SOLINK=../../ns-admin.so
endif

LDAPLINK=-L../.. $(addprefix -l, $(LDAP_LIBNAMES))

ifndef NSPRLINK
NSPRLINK=-L$(NSPR_LIBPATH) $(addprefix -l, $(NSPR_LIBNAMES))
endif

# Define a LIBSEC which doesn't include libdbm and xp.
LIBSEC1=$(MCOM_LIBDIR)/libsec/$(NSOBJDIR_NAME)/libsec-$(WHICHA).$(LIB_SUFFIX)

DEPLIBS = $(OBJDIR)/$(SONAME) $(GLUEOBJS)
ifeq ($(ARCH), HPUX)
DEPLINK = $(SOLINK) $(ADMSDKLINK) $(LDAPLINK) $(NSPRLINK) $(GLUEOBJS)
else
ifeq ($(ARCH), IRIX)
DEPLINK = $(ADMSDKLINK) $(LDAPLINK) $(NSPRLINK) $(SOLINK) -lgen $(GLUEOBJS)
else
ifeq ($(ARCH), AIX)
DEPLINK = $(ADMSDKLINK) $(LDAPLINK) $(NSPRLINK) $(SOLINK) $(GLUEOBJS)
else
DEPLINK = $(SOLINK) $(ADMSDKLINK) $(LDAPLINK) $(NSPRLINK) $(GLUEOBJS)
endif
endif
endif
SECDEPS = $(OBJDIR)/$(SONAME) $(LIBSEC1) $(LIBLDAP) $(OBJDIR)/admin-lib/dllglue.o
ifeq ($(ARCH), HPUX)
SECLINK = $(SOLINK) $(LIBSEC1) $(ADMSDKLINK) $(LDAPLINK) $(NSPRLINK) $(OBJDIR)/admin-lib/dllglue.o
else
ifeq ($(ARCH), IRIX)
SECLINK = $(ADMSDKLINK) $(LDAPLINK) $(LIBSEC1) $(SOLINK) -lgen $(OBJDIR)/admin-lib/dllglue.o
else
ifeq ($(ARCH), AIX)
SECLINK = $(SOLINK) $(ADMSDKLINK) $(LIBSEC1) $(LDAPLINK) $(NSPRLINK) $(OBJDIR)/admin-lib/dllglue.o
else
SECLINK = $(SOLINK) $(ADMSDKLINK) $(LIBSEC1) $(LDAPLINK) $(NSPRLINK) $(OBJDIR)/admin-lib/dllglue.o
endif
endif
endif
# Relative to the directory that contains the .so
BUILTDIR = .
#GLUEOBJS=$(OBJDIR)/admin-lib/dllglue.o $(OBJDIR)/admin-lib/secglue.o
GLUEOBJS=$(OBJDIR)/admin-lib/dllglue.o

ifeq ($(ARCH), AIX)
#DEPLINK+=-bE:$(OBJDIR)/admin-lib/dllglue.exp -bE:$(OBJDIR)/admin-lib/secglue.exp
DEPLINK+=-bE:$(OBJDIR)/admin-lib/dllglue.exp
endif

ADMLIB=$(OBJDIR)/$(SONAME)

ifeq ($(ARCH), AIX)
$(OBJDIR)/admin-lib/dllglue.o: dllglue.c
	$(CC) -c $(CFLAGS) $(MCC_INCLUDE) dllglue.c \
              -o $(OBJDIR)/admin-lib/dllglue.o
	nm -B -g $(OBJDIR)/admin-lib/dllglue.o \
		| awk '/ [T,D] / {print $$3}' \
		| sed -e 's/^\.//' \
		| sort -u > $(OBJDIR)/admin-lib/dllglue.exp
	echo func_standard >> $(OBJDIR)/admin-lib/dllglue.exp

#$(OBJDIR)/admin-lib/secglue.o: secglue.c
#	$(CC) -c $(CFLAGS) $(MCC_INCLUDE) secglue.c \
#              -o $(OBJDIR)/admin-lib/secglue.o
#	nm -B -g $(OBJDIR)/admin-lib/secglue.o \
#		| awk '/ [T,D] / {print $$3}' \
#		| sed -e 's/^\.//' \
#		| sort -u > $(OBJDIR)/admin-lib/secglue.exp

else
#
# Puzzled! If this is not seperated, secglue.o will be removed after
# compiling the cgi programs!
#
$(OBJDIR)/admin-lib/dllglue.o: dllglue.c
	$(CC) -c $(CFLAGS) $(MCC_INCLUDE) dllglue.c \
              -o $(OBJDIR)/admin-lib/dllglue.o
#$(OBJDIR)/admin-lib/secglue.o: secglue.c
#	$(CC) -c $(CFLAGS) $(MCC_INCLUDE) secglue.c \
#              -o $(OBJDIR)/admin-lib/secglue.o
endif

$(OBJDIR)/admin-lib:
	mkdir -p $(OBJDIR)/admin-lib

#
# 10/01/96 achan
# The dependency rules for ADMLIB is really defined in ../../src/unixso.mk
# So go there and check!
#
# 5/12/97 achan
# For some reason the ns-admin.so got rebuilt even for no changes.  Don't
# check for it at this moment.
#
$(ADMLIB): FORCEIT

FORCEIT:

endif
