/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/* 
 * SCRIPT_NAME: Handle the user environment version of the frames interface
 * 
 * All blame to Mike McCool (mlm@netscape.com)
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../lib/libsi18n/gsadmserv.h"
#include "dbtuserforms.h"

#define SCRIPT_NAME "index"
#define TOP_NAME "tabs"
#define BOTTOM_NAME "category"
#define OPTIONS_NAME "options"
#define CONTENT_NAME "content"

#define CATEGORY "--Category:"
#define OPTION "--Option:"
#define INCLUDE "--include"

#define CATLIST_FILE "../html/$$LANGDIR/index.lst"
#define HTML_FILE    "../html/$$LANGDIR/index.html"

/* Note: WinNT does not require this special treatment */
#ifdef XP_UNIX
#define INCLUDE_PATH "%s/bin/user/admin/html/$$LANGDIR/%s"
#else
#define INCLUDE_PATH "%s\\bin\\user\\admin\\html\\$$LANGDIR\\%s"
#endif

#define LIST_SIZE 5

#define GFX_DIR "../icons/"

typedef struct catstruct {
    char *category_id;
    char *category_desc;
    char **optionlist;
} catstruct, *catptr, **catlist;

catptr new_catstruct(void)
{
    catptr ans;
    ans = (catptr) malloc(sizeof(catstruct)+4);
    ans->category_id = NULL;
    ans->category_desc = NULL;
    ans->optionlist = NULL;
    return ans;
}

catlist read_catlist(void)
{
    catlist ans=NULL;
    catptr entry=NULL;
    int listsize=LIST_SIZE, current=0;
    int numoptions=LIST_SIZE, curopt=0;
    char path[256];
    char existingpath[256];
    FILE *f;
    FILE *flst;
    char line[1024];
    char opt[128];
    char *tmp=NULL, *data=NULL, *div=NULL;
    char *root = getenv("NETSITE_ROOT");
    
    GetFileForLanguage(CATLIST_FILE,GetClientLanguage(),existingpath);
    f = fopen(existingpath, "r");
    if(!f)  {
        fprintf(stdout,
                XP_GetClientStr(DBT_errorCouldNotOpenServersListFile_));
        exit(1);
    }
    while(fgets(line, sizeof(line), f))  {
        if(line[0] == ';')  
            continue;
        else if((line[0] == '\n') || (line[0] == '\r'))
            continue;
        else if(!strncmp(line, CATEGORY, strlen(CATEGORY)))  {
            tmp=strchr(line, '\n');
            if(tmp) *tmp='\0';
            tmp=strchr(line, '\r');
            if(tmp) *tmp='\0';

            data=strchr(line, ':');
            if(!data) continue; /* huh?! */
            data++;
            div=strchr(data, ',');
            if(!div) continue; /* huh?! */
            *div++ = '\0';

            if(!ans)  {
                ans = (catlist) malloc(listsize*sizeof(catptr)+4);
            }
            if(listsize == current)  {
                listsize+=LIST_SIZE;
                ans = (catlist) realloc(ans, listsize*sizeof(catptr)+4);
            }
            entry=new_catstruct();
            entry->category_id = strdup(data);
            entry->category_desc = strdup(div);
            ans[current++]=entry;
            ans[current]=NULL;
        }
        else if(!strncmp(line, OPTION, strlen(OPTION)))  {
            tmp=strchr(line, '\n');
            if(tmp) *tmp='\0';
            tmp=strchr(line, '\r');
            if(tmp) *tmp='\0';
 
            data=strchr(line, ':');
            if(!data) continue; /* huh?! */
            data++;
 
            if(!entry->optionlist)  {
                numoptions=LIST_SIZE;
                curopt = 0;
                entry->optionlist=(char **) malloc(numoptions*sizeof(char *)+4);
            }
            if(curopt == numoptions)  {
                numoptions+=LIST_SIZE;
                entry->optionlist=(char **)realloc(entry->optionlist,
                                                   numoptions*sizeof(char *)+4);
            }
            entry->optionlist[curopt++]=strdup(data);
            entry->optionlist[curopt]=NULL;
        }
        else if(!strncmp(line, INCLUDE, strlen(INCLUDE))) {
            tmp=strchr(line, '\n');
            if(tmp) *tmp='\0';
            tmp=strchr(line, '\r');
            if(tmp) *tmp='\0';

            data=strchr(line, ' ');
            if(!data) continue; /* huh?! */
            data++;
           
            sprintf(path, INCLUDE_PATH, root, data);
            GetFileForLanguage(path,GetClientLanguage(),existingpath);
            if (!(flst = fopen(existingpath, "r"))) {
              fprintf(stdout,
                      XP_GetClientStr(DBT_errorCouldNotOpenSServerListFile_),
                      path);
              exit(1);
            }
            else 
            {
              while(fgets(opt, 128, flst) != (char *) NULL)
              { 
                if(!strncmp(opt, CATEGORY, strlen(CATEGORY)))  {
                  tmp=strchr(opt, '\n');
                  if(tmp) *tmp='\0';
                  tmp=strchr(opt, '\r');
                  if(tmp) *tmp='\0';

                  data=strchr(opt, ':');
                  if(!data) continue; /* huh?! */
                  data++;
                  div=strchr(data, ',');
                  if(!div) continue; /* huh?! */
                  *div++ = '\0';

                  if(!ans)  {
                    ans = (catlist) malloc(listsize*sizeof(catptr)+4);
                  }
                  if(listsize == current)  {
                    listsize+=LIST_SIZE;
                  ans = (catlist) realloc(ans, listsize*sizeof(catptr)+4);
                  }
                  entry=new_catstruct();
                  entry->category_id = strdup(data);
                  entry->category_desc = strdup(div);
                  ans[current++]=entry;
                  ans[current]=NULL;
                }
                else if(!strncmp(opt, OPTION, strlen(OPTION)))  {
                       tmp=strchr(opt, '\n');
                       if(tmp) *tmp='\0';
                       tmp=strchr(opt, '\r');
                       if(tmp) *tmp='\0';
 
                       data=strchr(opt, ':');
                       if(!data) continue; /* huh?! */
                       data++;
 
                       if(!entry->optionlist)  {
                         numoptions=LIST_SIZE;
                         curopt = 0;
                         entry->optionlist=(char **) malloc(numoptions*sizeof(char *)+4);
                       }
                       if(curopt == numoptions)  {
                         numoptions+=LIST_SIZE;
                         entry->optionlist=(char **)realloc(entry->optionlist,
                                                     numoptions*sizeof(char *)+4);
                       }
                       entry->optionlist[curopt++]=strdup(data);
                       entry->optionlist[curopt]=NULL;
                }
              }
              fclose(flst);
            }
        }
    }
    return ans;
}

char *get_partial_url(catlist cl, char *id)
{
    register int x;
    char *ans = NULL;

    for(x=0; cl[x]; x++)  {
        if(strcmp(cl[x]->category_id, id))
            continue;
        if(cl[x]->optionlist)  {
            char *comma=strchr((cl[x]->optionlist)[0], ',');
            if(comma)  {
                ans=strdup((cl[x]->optionlist)[0]);
                comma=strchr(ans, ',');
                *comma++ = '\0';
            }
        }
    }
    return ans;
}

char *get_id_bypgm(catlist cl, char *pgm)
{
    register int x, y;
    char *ans = NULL;
 
    for(x=0; cl[x]; x++)  {
        if(cl[x]->optionlist)  {
            for(y=0; (cl[x]->optionlist)[y]; y++)  {
                char *comma=strchr((cl[x]->optionlist)[y], ',');
                if(comma)  {
                    *comma = '\0';
                    if(!strcmp((cl[x]->optionlist)[y], pgm))  {
                        ans=strdup(cl[x]->category_id);
                    }
                    *comma = ',';
                }
            }
        }
    }
    return ans;
}

void return_main_index()
{
    char *user = getenv("REMOTE_USER");
    char existingpath[256];

    fprintf(stdout, "<head><title>%s</title></head>\n",
                    XP_GetClientStr(DBT_netscapeServerAccount_));
    fprintf(stdout, "<SCRIPT language=JavaScript>\n");
    fprintf(stdout, "function output_top_frame()  {\n");
	fprintf(stdout, "   top.title.document.writeln(\"<BODY TEXT=#000000 BGCOLOR=#006666>\");\n");
    fprintf(stdout, "   top.title.document.writeln(\"<table border=0 "
                                                "width=100%% "
                                                "height=100%%>\");\n");
    fprintf(stdout, "   top.title.document.writeln(\"<tr><td width=100%% "
                                                "align=center>\");\n");
    fprintf(stdout, "   top.title.document.writeln(\"<B><font size=+2 COLOR=#FFFFFF>" );
    fprintf(stdout, XP_GetClientStr( user ? DBT_serverAccountManagementFor_
	    : DBT_serverAccountManagement_ ), user );
    fprintf(stdout, "</font></B>\");\n" );
    fprintf(stdout, "   top.title.document.writeln(\"</td></tr></table>\");\n");
    fprintf(stdout, "}\n");

    fprintf(stdout, "function output_bottom_frames()  {\n");
    fprintf(stdout, "    top.bottom.document.writeln(\"<frameset cols='20%%,*' "
                                "border=1>\");\n");
    fprintf(stdout, "    top.bottom.document.writeln(\"<frame src='%s?list' "
                                "scrolling=no marginwidth=0 marginheight=0 "
                                "name='%s'>\");\n", SCRIPT_NAME, TOP_NAME);
    GetFileForLanguage(HTML_FILE,GetClientLanguage(),existingpath);
    fprintf(stdout, "    top.bottom.document.writeln(\"<frame "
                                "src='%s' "
                                "scrolling=yes marginwidth=4 "
                                "marginheight=4 name='%s'>\");\n",
                                existingpath,
                                CONTENT_NAME);
    fprintf(stdout, "    top.bottom.document.writeln(\"</frameset>\");\n");
    fprintf(stdout, "}\n");
    fprintf(stdout, "</script>\n\n");

    fprintf(stdout, "<frameset rows=\"50,*\" border=1 "
		    "framespacing=0 frameborder=0 framepadding=0 "
                    "marginwidth=0 marginheight=0>\n");
    fprintf(stdout, "<frame src=\"javascript:top.output_top_frame();\" "
		    "marginheight=0 marginwidth=0 scrolling=\"no\" noresize "
                    "name=title>\n");
    fprintf(stdout, "<frame src=\"javascript:top.output_bottom_frames();\" "
		    "marginheight=5 marginwidth=5 scrolling=\"no\" "
                    "name=bottom>\n");
    fprintf(stdout, "</frameset>\n");
    exit(0);
}

void return_list()
{
    catlist cl = read_catlist();
    char  **ol = NULL;
    char *desc = NULL;
    int x = 0, y = 0;

    fprintf(stdout, "<BODY TEXT=#000000 BGCOLOR=#FFFFFF LINK=#006666 "
		    " VLINK=#006666 ALINK=#666666>\n" );

    fprintf(stdout, "<table cellspacing=0 cellpadding=0 "
                    "width=100%% height=100%% bgcolor=#FFFFFF border=0>\n");
    fprintf(stdout, "<tr><td valign=top>");

    fprintf(stdout, "<table cellspacing=2 cellpadding=4 "
                    "width=100%% border=0>\n");

    for(x=0; cl[x]; x++)  {
        fprintf(stdout, "<tr>\n");
        fprintf(stdout, "<td></td>\n");
        fprintf(stdout, "</tr>\n");

        fprintf(stdout, "<tr>\n");
        fprintf(stdout, "<td bgcolor=#006666><b><font color=#FFFFFF size=+1>%s</font></b></td>\n", 
                        cl[x]->category_desc);
        fprintf(stdout, "</tr>\n");

        ol = cl[x]->optionlist;
        if(!ol) continue;

        for(y=0; ol[y]; y++)  {
            desc = strchr(ol[y], ',');
            if(!desc) continue;
            *desc++ = '\0';
            fprintf(stdout, "<tr>\n");
            fprintf(stdout, "<td bgcolor=#F0F0F0><b>"
                            "<font color=#000080 size=-1 face=\"Arial,Helvetica,lucidasans\">"
                            "<a href=%s target=%s>%s</a>"
                            "</font>"
                            "</b></td>\n", 
                            ol[y], CONTENT_NAME, desc);
            fprintf(stdout, "</tr>\n");
        }
    }
    fprintf(stdout, "</table>\n");

    fprintf(stdout, "</td></tr></table>\n");

    fprintf(stdout, "</BODY>\n");
    exit(0);
}

int main(int argc, char *argv[])
{
    char *qs = getenv("QUERY_STRING");

    /* Get *Language from Environment */
    char *AcceptLang  = getenv("HTTP_ACCEPT_LANGUAGE");
    char *ClientLang  = getenv("ClientLanguage");
    char *AdminLang   = getenv("AdminLanguage");
    char *DefaultLang = getenv("DefaultLanguage");

    ADM_Init();

    /* initialize the string database */
    XP_InitStringDatabase("../../../admin",DATABASE_NAME);

    /* Set *Language from environment if found */
    if (AcceptLang) {
      SetLanguage(CLIENT_LANGUAGE,AcceptLang);
    }
    else if (ClientLang) {
      SetLanguage(CLIENT_LANGUAGE,ClientLang);
    }
    if (AdminLang) {
      SetLanguage(ADMIN_LANGUAGE,AdminLang);
    }
    if (DefaultLang) {
      SetLanguage(DEFAULT_LANGUAGE,DefaultLang);
    }

    fprintf(stdout, "Content-type: text/html\n\n");

    if((!qs) || (qs[0]=='\0'))  {
        return_main_index();
    }  
    else if(!strcmp(qs, "list"))  {
        return_list();
    }
    return 0;
}
