#
# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
#
#
# This makefile is used to grab all the components needed to build.
#
#
#

include $(NSROOT)/nsperl.mk

COMMA := ,
NULLSTRING :=
SPACE := $(NULLSTRING) # the space is between the ) and the #

RELTOOLS = $(ABS_ROOT)/reltools
 
#Temporary integration area components
INT_NMCSDK = 0
INT_ICU = 0
INT_ADMSDK = 0
INT_SETUPSDK = 0
INT_LDAPSDK = 0
INT_NESCORE = 0
INT_ADMDOC = 0

#To control external build vs. internal build
BUILD_MODE = ext

#############################################
# NSPR Library
############################################

NSPR_SUF =	20
NSPR_RELDATE =  v4.4.1

NSPR_NSOBJDIR=$(NSOBJDIR_NAME)

ifeq ($(INT_NSPR), 1)
BASE_NSPR = $(INT_DIR)/nspr20/$(NSPR_RELDATE)/$(NSPR_NSOBJDIR)
else
BASE_NSPR = $(COMPONENTS_DIR)/nspr20/$(NSPR_RELDATE)/$(NSPR_NSOBJDIR)
endif

$(LIBNSPR): 

ifneq ($(ARCH), WINNT)
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/nspr -componentdir $(BASE_NSPR) -files mdbinary.jar -unzip $(NSCP_DISTDIR)
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/nspr -componentdir $(BASE_NSPR) -files mdheader.jar -unzip $(NSCP_DISTDIR)/include
else
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/nspr -componentdir $(BASE_NSPR) -files mdbinary.jar -unzip $(NSCP_DISTDIR)
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/nspr -componentdir $(BASE_NSPR) -files mdheader.jar -unzip $(NSCP_DISTDIR)/include
endif

###############################################
# DBM Library
##############################################

DBM_RELDATE = DBM_1_61_RTM

ifeq ($(INT_DBM), 1)
BASE_DBM = $(INT_DIR)/dbm/$(DBM_RELDATE)
else
BASE_DBM = $(COMPONENTS_DIR)/dbm/$(DBM_RELDATE)
endif

$(LIBDBM):

ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/dbm -componentdir $(BASE_DBM) -files xpheader.jar -unzip $(NSCP_DIST)/public/dbm
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/dbm -componentdir $(BASE_DBM)/$(NSOBJDIR_NAME) -files mdbinary.jar -unzip $(NSCP_DISTDIR)
else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/dbm -componentdir $(BASE_DBM) -files xpheader.jar -unzip $(NSCP_DIST)/public/dbm
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/dbm -componentdir $(BASE_DBM)/$(NSOBJDIR_NAME) -files mdbinary.jar -unzip $(NSCP_DISTDIR)
endif

################################################
# SECURITY LIBRARY
################################################

SECURITY_RELDATE = NSS_3_9_3_RTM

ifeq ($(INT_NSS), 1)
BASE_NSS = $(INT_DIR)/nss/$(SECURITY_RELDATE)
else
BASE_NSS = $(COMPONENTS_DIR)/nss/$(SECURITY_RELDATE)
endif

$(LIBSECURITY):

ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/nss -componentdir $(BASE_NSS) -files xpheader.jar -unzip $(NSCP_DIST)/public/security
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NSCP_DISTDIR)/nss -componentdir $(BASE_NSS)/$(NSOBJDIR_NAME) -files mdbinary.jar -unzip $(NSCP_DISTDIR)

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/nss -componentdir $(BASE_NSS) -files xpheader.jar -unzip $(NSCP_DIST)/public/security
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(NSCP_DISTDIR)/nss -componentdir $(BASE_NSS)/$(NSOBJDIR_NAME) -files mdbinary.jar -unzip $(NSCP_DISTDIR)

endif

##################################################
# ICU Library
#################################################

ICU_RELDATE = libicu_2_4/20040820
ICU_SUF = 24

ICU_ROOT = $(NSCP_COMPDIR)/libicu
ICU_OBJDIR = $(NSOBJDIR_NAME)

ifeq ($(INT_ICU), 1)
BASE_ICU = $(INT_DIR)/libicu/$(ICU_RELDATE)/$(ICU_OBJDIR)
else
BASE_ICU = $(COMPONENTS_DIR)/libicu/$(ICU_RELDATE)/$(ICU_OBJDIR)
endif

$(LIBICU): 
ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(ICU_ROOT)/$(ICU_OBJDIR) -componentdir $(BASE_ICU) -files include,lib,bin

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(ICU_ROOT)/$(ICU_OBJDIR) -componentdir $(BASE_ICU) -files include,lib,bin

endif

##############################################################
# SETUPSDK
##############################################################

SETUPSDK_SUF = 70$(BUILD_MODE)
SETUPSDK_RELDATE = 20050426
SETUPSDK_FILE = setupsdk.tar.gz
SETUPSDK_COMPNAME = setupsdk/setupsdk$(SETUPSDK_SUF)

SETUPSDK_ROOT = $(NSCP_COMPDIR)/setupsdk

SETUPSDK_OBJDIR  = $(NSOBJDIR_NAME)

ifeq ($(INT_SETUPSDK), 1)
BASE_SETUPSDK = $(INT_DIR)/$(SETUPSDK_COMPNAME)/$(SETUPSDK_RELDATE)/$(SETUPSDK_OBJDIR)
else
BASE_SETUPSDK = $(COMPONENTS_DIR)/$(SETUPSDK_COMPNAME)/$(SETUPSDK_RELDATE)/$(SETUPSDK_OBJDIR)
endif

SETUPSDK_DEST = $(SETUPSDK_ROOT)/$(SETUPSDK_OBJDIR)

$(SETUPSDK): 
ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(SETUPSDK_ROOT)/$(SETUPSDK_OBJDIR) -componentdir $(BASE_SETUPSDK) -files bin,include,lib
else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(SETUPSDK_DEST)/temp -componentdir $(BASE_SETUPSDK) -files setupsdk.tar.gz -unzip $(SETUPSDK_DEST)
endif

################################################################
# ADMSDK Library
###############################################################

ADMSDK_SUF     = 70$(BUILD_MODE)
ADMSDK_RELDATE = 20050330
ADMSDK_VERSION = $(ADMSDK_RELDATE)
ADMSDK_ROOT = $(NSCP_COMPDIR)/adminsdk
ADMSDK_COMPNAME = adminsdk/adminsdk$(ADMSDK_SUF)

ADMSDKOBJDIR = $(NSOBJDIR_NAME)

ifeq ($(INT_ADMSDK), 1)
BASE_ADMSDK = $(INT_DIR)/$(ADMSDK_COMPNAME)/$(ADMSDK_VERSION)/$(ADMSDKOBJDIR)
else
BASE_ADMSDK = $(COMPONENTS_DIR)/$(ADMSDK_COMPNAME)/$(ADMSDK_VERSION)/$(ADMSDKOBJDIR)
endif

$(LIBADMSDK): 

ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(ADMSDK_ROOT)/$(ADMSDKOBJDIR) -componentdir $(BASE_ADMSDK) -files include,lib

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(ADMSDK_ROOT)/$(ADMSDKOBJDIR) -componentdir $(BASE_ADMSDK) -files include,lib

endif

################################################################
# DOCS
################################################################

ADMDOC_SUF     = 7.0$(BUILD_MODE)
ADMDOC_RELDATE = 20050309
ADMDOC_VERSION = $(ADMDOC_RELDATE)
ADMDOC_PATH = $(NSCP_COMPDIR)/admservdoc
ADMDOC_ABSPATH = $(ABS_ROOT)/components/admservdoc
ADMDOC_COMPNAME = adminservdoc/$(ADMDOC_SUF)
ADMDOC_ADMONLINEHELP = admserv_onlinehelp.zip
ADMDOC_CONSOLEONLINEHELP = console_onlinehelp.zip

ADMDOC_FILES = $(ADMDOC_ADMONLINEHELP),$(ADMDOC_CONSOLEONLINEHELP)

ADMDOC = $(addprefix $(ADMDOC_PATH)/, $(ADMDOC_FILES))

ifeq ($(INT_ADMDOC), 1)
BASE_ADMDOC = $(INT_DIR)/$(ADMDOC_COMPNAME)/$(ADMDOC_VERSION)
else
BASE_ADMDOC = $(COMPONENTS_DIR)/$(ADMDOC_COMPNAME)/$(ADMDOC_VERSION)
endif

ifeq ($(ARCH), WINNT)
ADMDOC_METHOD = FTP
else
ADMDOC_METHOD = SYMLINK
endif

$(ADMDOC): 
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method $(ADMDOC_METHOD) -objdir $(ADMDOC_PATH) -componentdir $(BASE_ADMDOC) -files $(ADMDOC_FILES)


#############################################################
# LDAP C SDK Library
#############################################################

LDAP_RELDATE = v5.15
LDAP_SUF = 50

LDAP_VERSION = $(LDAP_RELDATE)
LDAP_ROOT = $(NSCP_COMPDIR)/ldapsdk
				 
LDAPOBJDIR = $(NSOBJDIR_NAME)

ifeq ($(INT_LDAPSDK), 1)
BASE_LDAPSDK = $(INT_DIR)/ldapsdk$(LDAP_SUF)/$(LDAP_VERSION)/$(LDAPOBJDIR)
else
BASE_LDAPSDK = $(COMPONENTS_DIR)/ldapsdk$(LDAP_SUF)/$(LDAP_VERSION)/$(LDAPOBJDIR)
endif

$(LIBLDAP):
ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(LDAP_ROOT)/$(LDAPOBJDIR) -componentdir $(BASE_LDAPSDK) -files lib,tools,include

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(LDAP_ROOT)/$(LDAPOBJDIR) -componentdir $(BASE_LDAPSDK) -files lib,tools,include

endif

###############################################################
# LDAP java classes 
##############################################################

LDAPJDK_VERSION = v4.17
LDAPJDK = ldapjdk.jar
LDAPJDK_COMP = ldapjdk41

ifeq ($(INT_LDAPJDK), 1)
BASE_LDAPJDK = $(INT_DIR)/$(LDAPJDK_COMP)/$(LDAPJDK_VERSION)
else
BASE_LDAPJDK = $(COMPONENTS_DIR)/$(LDAPJDK_COMP)/$(LDAPJDK_VERSION)
endif

ldapjdk:

	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(CLASS_DEST)/. -componentdir $(BASE_LDAPJDK)/$(NSOBJDIR_NAME) -files $(LDAPJDK)

##########################################################
# JRE
##########################################################

JRE_DIR=$(COMPONENTS_DIR)/admin-jre

ifeq ($(ARCH), HPUX)
JRE_VERSION=jre1.4.2_04
else
ifeq ($(ARCH), Linux)
JRE_VERSION=1.4.2_SR1a
else
JRE_VERSION=jre1.4.2_05
endif
endif

ifeq ($(ARCH), WINNT)
JRE_VERSION=jre1.4.2_05z
JRE_SRC=$(JRE_DIR)/WINNT4.0/$(JRE_VERSION)
JRE_ROOT = $(NSCP_COMPDIR)/jre/$(NSOBJDIR_NAME)
endif

ifneq ($(ARCH), WINNT)
ifeq ($(ARCH), Linux)
JRE_PATH=$(COMPONENTS_DIR)/ibmjre/$(JRE_VERSION)/$(NSOBJDIR_NAME)/jre
else
JRE_PATH=$(JRE_DIR)/$(NSCONFIG)/$(JRE_VERSION)
endif
endif

jre:

ifeq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(JRE_ROOT) -componentdir $(JRE_SRC) -files jre.z
endif


#############################################################
# Console java classes 
#############################################################

NMCJDK_SUF =  70
NMCJDK_RELDATE = 20050426

NMCJDK_COMP = consolesdk/consolesdk$(NMCJDK_SUF)$(BUILD_MODE)

NMCJDK_VERSION = $(NMCJDK_RELDATE)

ifeq ($(INT_NMCSDK), 1)
BASE_NMCSDK = $(INT_DIR)/$(NMCJDK_COMP)/$(NMCJDK_VERSION)
else
BASE_NMCSDK = $(COMPONENTS_DIR)/$(NMCJDK_COMP)/$(NMCJDK_VERSION)
endif

NMCJDK_DIR = $(BASE_NMCSDK)/jars

# since the jar files are packaged as is, they should not be symlink'ed.
NMCJDK_METHOD = FTP

nmcjdk:

	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method $(NMCJDK_METHOD) -objdir $(CLASS_DEST) -componentdir $(NMCJDK_DIR) -files base.jar,mcc$(NMCJDK_SUF).jar,mcc$(NMCJDK_SUF)_en.jar,nmclf$(NMCJDK_SUF).jar,nmclf$(NMCJDK_SUF)_en.jar,caplugin

#############################################################
# JSS java classes 
#############################################################

JSS_SDK_VERSION = JSS_3_5_1_RTM
JSSSDK = jss3.jar
XPCLASS = xpclass.jar

ifeq ($(INT_JSS), 1)
BASE_JSS = $(INT_DIR)/jss/$(JSS_SDK_VERSION)
else
BASE_JSS = $(COMPONENTS_DIR)/jss/$(JSS_SDK_VERSION)
endif

jsssdk:
	mkdir -p $(CLASS_DEST)
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(CLASS_DEST)/. -componentdir $(BASE_JSS) -files $(XPCLASS)
	(cd $(CLASS_DEST); mv $(XPCLASS) $(JSSSDK))



#############################################################
# JSS Support Library
#############################################################

JSSLIB = mdbinary.jar

BASE_JSSLIB = $(NSCP_COMPDIR)/jss/$(NSOBJDIR_NAME)

jsslib:

ifneq ($(ARCH), WINNT)
ifneq ($(ARCH), SOLARISx86)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(BASE_JSSLIB) -componentdir $(BASE_JSS)/${NSOBJDIR_NAME} -files ${JSSLIB} -unzip $(BASE_JSSLIB)
endif

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(BASE_JSSLIB) -componentdir $(BASE_JSS)/${NSOBJDIR_NAME} -files ${JSSLIB} -unzip $(BASE_JSSLIB)

endif

##########################################################
# NES Core Admin
##########################################################

NESCORE_SUF = 70
NESCORE_RELDATE = 20050418

NESCORE_ROOT = $(NSCP_COMPDIR)/nescore

NESCOREOBJDIR = $(NSOBJDIR_NAME)
ifeq ($(INT_NESCORE), 1)
    BASE_NESCORE = $(INT_DIR)/admserv$(NESCORE_SUF)-nescore/$(NESCORE_RELDATE)/$(NESCOREOBJDIR)
else
    BASE_NESCORE = $(COMPONENTS_DIR)/admserv$(NESCORE_SUF)-nescore/$(NESCORE_RELDATE)/$(NESCOREOBJDIR)
endif


nescore:

ifneq ($(ARCH), WINNT)
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method SYMLINK -objdir $(NESCORE_ROOT)/$(NESCOREOBJDIR) -componentdir $(BASE_NESCORE) -files nescore.zip,java.zip -unzip $(NESCORE_ROOT)/$(NESCOREOBJDIR)

else
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP     -objdir $(NESCORE_ROOT)/$(NESCOREOBJDIR) -componentdir $(BASE_NESCORE) -files nescore.zip,java.zip -unzip $(NESCORE_ROOT)/$(NESCOREOBJDIR)
endif

# ANT java classes #######################################
#  (we use ant for building some Java code)
ifndef ANT_VERSION
  ANT_VERSION = 1.6.2
endif
ifndef ANT_COMP
  ANT_COMP = ant
endif
ANTJAR = ant.jar
ANTLAUNCHERJAR = ant-launcher.jar
ANT_FILES = $(ANTJAR) $(ANTLAUNCHERJAR)
ANT_RELEASE = $(COMPONENTS_DIR)
ANT_HOME = $(ANT_RELEASE)/$(ANT_COMP)/$(ANT_VERSION)
ANT_DIR = $(ANT_HOME)/lib
ANT_DEP = $(addprefix $(CLASS_DEST)/, $(ANT_FILES))
ANT_CP = $(subst $(SPACE),$(PATH_SEP),$(ANT_DEP))
ANT_PULL = $(subst $(SPACE),$(COMMA),$(ANT_FILES))

ifndef ANT_PULL_METHOD
ANT_PULL_METHOD = FTP
endif

$(ANT_DEP): $(CLASS_DEST) 
	echo "Inside ftppull"
	$(PERL5) $(RELTOOLS)/ftp_puller.pl -method FTP -objdir $(CLASS_DEST) \
		-componentdir $(ANT_DIR) -files $(ANT_PULL)
	-@if [ ! -f $@ ] ; \
	then echo "Error: could not get component ant files $@" ; \
	fi
###########################################################

# INFOZIP #################################################
ifndef INFOZIP_RELDATE
INFOZIP_RELDATE = CMSTOOLS_7_x
endif
ifndef INFOZIP_PULL_METHOD
INFOZIP_PULL_METHOD = FTP
endif

INFOZIP_PATH=$(ABS_ROOT)/dist/$(NSOBJDIR_NAME)/$(NS_BUILD_FLAVOR)/tools
INFOZIP=$(INFOZIP_PATH)/infozip.zip

$(INFOZIP): 
	-rm -rf $(INFOZIP_PATH)
	mkdir -p $(INFOZIP_PATH)
	$(PERL5) -I$(RELTOOLS) $(RELTOOLS)/ftp_puller.pl \
		-method $(INFOZIP_PULL_METHOD) \
		-objdir $(INFOZIP_PATH) \
		-componentdir $(COMPONENTS_DIR)/infozip/$(INFOZIP_RELDATE)/$(NSOBJDIR_NAME) \
		-files infozip.zip \
		-unzip $(INFOZIP_PATH)
	@if [ ! -f $@ ] ; \
		then echo "Error: could not get component INFOZIP file $@" ; \
		exit 1 ; \
	fi
	-rm -rf $(INFOZIP_PATH)/infozip.zip

###########################################################
