/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_CINFO_H
#define BASE_CINFO_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

/*
 * cinfo.h: Content Information for a file, i.e. its type, etc.
 * 
 * See cinfo.c for dependency information. 
 * 
 * Rob McCool
 */

#ifndef NETSITE_H
#include "../netsite.h"
#endif /* !NETSITE_H */

/* ------------------------------ Constants ------------------------------- */

/* The hash function for the database. Hashed on extension. */
#include <ctype.h>
#define CINFO_HASH(s) (isalpha(s[0]) ? tolower(s[0]) - 'a' : 26)

/* The hash table size for that function */
#define CINFO_HASHSIZE 27

#ifndef PUBLIC_BASE_CINFO_H
#include "public/base/cinfo.h"
#endif /* !PUBLIC_BASE_CINFO_H */

/* --- Begin function prototypes --- */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

NSAPI_PUBLIC void INTcinfo_init(void);
NSAPI_PUBLIC void INTcinfo_terminate(void);
NSAPI_PUBLIC char *INTcinfo_merge(char *fn);
NSAPI_PUBLIC cinfo *INTcinfo_find(char *uri);
NSAPI_PUBLIC cinfo *INTcinfo_lookup(char *type);
NSAPI_PUBLIC void INTcinfo_dump_database(FILE *dump);

NSPR_END_EXTERN_C

/* --- End function prototypes --- */

#define cinfo_init INTcinfo_init
#define cinfo_terminate INTcinfo_terminate
#define cinfo_merge INTcinfo_merge
#define cinfo_find INTcinfo_find
#define cinfo_lookup INTcinfo_lookup
#define cinfo_dump_database INTcinfo_dump_database

#endif /* INTNSAPI */

#endif /* !BASE_CINFO_H */

