/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_DAEMON_H
#define BASE_DAEMON_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

#ifndef NETSITE_H
#include "netsite.h"
#endif /* !NETSITE_H */

#ifndef HTTPDAEMON_HTTPDAEMON_H
#include "../httpdaemon/httpdaemon.h"
#endif /* !HTTPDAEMON_HTTPDAEMON_H */

#ifndef PUBLIC_BASE_DAEMON_H
#include "public/base/daemon.h"
#endif /* !PUBLIC_BASE_DAEMON_H */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

#ifdef XP_UNIX
/* FUNCTION: child_fork
** DESCRIPTION:
** child_fork is a thread-safe wrapper for the system's fork function. 
**/
NSAPI_PUBLIC pid_t INTchild_fork(void);
#endif

/* In lib/base/restart.cpp */
NSAPI_PUBLIC void INTdaemon_dorestart(void);

/*
 * daemon_atrestart registers a function to be called fn, with the given
 * void pointer as an argument, when the server is restarted.
 */
NSAPI_PUBLIC void INTdaemon_atrestart(void (*fn)(void *), void *data);

NSAPI_PUBLIC int INTservssl_certinit(char *certfn, void **pcert, int read_server_cert);

/* Random number generation */

NSAPI_PUBLIC void *nsapi_random_create(void);
NSAPI_PUBLIC
void nsapi_random_update(void *rctx, unsigned char *inbuf, int length);
NSAPI_PUBLIC
void nsapi_random_generate(void *rctx, unsigned char *outbuf, int length);
NSAPI_PUBLIC void nsapi_random_destroy(void *rctx);

/* MD5 hashing */

NSAPI_PUBLIC void *nsapi_md5hash_create(void);
NSAPI_PUBLIC void *nsapi_md5hash_copy(void *hctx);
NSAPI_PUBLIC void nsapi_md5hash_begin(void *hctx);
NSAPI_PUBLIC
void nsapi_md5hash_update(void *hctx, unsigned char *inbuf, int length);
NSAPI_PUBLIC void nsapi_md5hash_end(void *hctx, unsigned char *outbuf);
NSAPI_PUBLIC void nsapi_md5hash_destroy(void *hctx);
NSAPI_PUBLIC void
nsapi_md5hash_data(unsigned char *outbuf, unsigned char *inbuf, int length);

NSPR_END_EXTERN_C

#ifdef XP_UNIX
#define child_fork INTchild_fork
#endif /* XP_UNIX */
#define daemon_dorestart INTdaemon_dorestart
#define daemon_atrestart INTdaemon_atrestart
#define servssl_certinit INTservssl_certinit

#endif /* INTNSAPI */

#endif /* !BASE_DAEMON_H */
