/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

/* A slighly unconventional ifdef here.
 * The minissl.h file is intended to avoid including all of the ssl.h
 * include file.  So if the real ssl.h has been included already (__ssl_h_),
 * then don't include this one because we'll just get redefinitions.
 */
#if !defined(_MINISSL_H_) && !defined(__ssl_h_)
#define _MINISSL_H_

typedef int (*SSLAcceptFunc)(int fd, struct sockaddr *a, int *ap);

#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN extern
#endif

/* Prototypes for SSL I/O functions */
EXTERN int SSL_Connect(int, const void *, int);
EXTERN int SSL_Ioctl(int, int, void*);
EXTERN int SSL_Close(int);
EXTERN int SSL_Socket(int, int, int);
EXTERN int SSL_GetSockOpt(int, int, int, void *, int *);
EXTERN int SSL_SetSockOpt(int, int, int, const void *, int);
EXTERN int SSL_Bind(int, const void *, int);
EXTERN int SSL_Listen(int, int);
EXTERN int SSL_Accept(int, void *, int *);
EXTERN int SSL_Read(int, void *, int);
EXTERN int SSL_Write(int, const void *, int);
EXTERN int SSL_GetPeerName(int, void *, int *);
EXTERN void SSL_AcceptHook(SSLAcceptFunc func);
EXTERN int SSL_DataPendingHack(int);
EXTERN int SSL_ForceHandshake(SYS_NETFD);
EXTERN int SSL_SecurityStatus(SYS_NETFD, int *, char **, int *, int *,
                char **, char **);
EXTERN int SSL_Import(SYS_NETFD);

#endif /* _MINISSL_H_ */
