/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * nsassert.h
 *
 * Handler for Asserts
 *
 */

#ifndef BASE_NSASSERT_H
#define BASE_NSASSERT_H

#if defined(_DEBUG) || defined(DEBUG)

#ifndef BASE_EREPORT_H
#include "ereport.h"
#endif /* !BASE_EREPORT_H */

NSPR_BEGIN_EXTERN_C

#define NS_ASSERT(x)   (x)?0:ereport(0, "assert failed! %s (%d, %s)", \
                    #x, __LINE__, __FILE__)
NSPR_END_EXTERN_C

#else

#define NS_ASSERT(x) 

#endif

#endif /* !BASE_NSASSERT_H */

