/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_REGEXP_H
#define BASE_REGEXP_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

/*
 * regexp.h: Wrapper for system's regular expression handlers
 *
 *
 *
 *
 *
 *
 * Ari Luotonen
 * Copyright (c) 1995 Netscape Communcations Corporation
 *
 */

#ifndef NETSITE_H
#include "../netsite.h"
#endif /* !NETSITE_H */

/* See public/base/regexp.h or public/base/shexp.h concerning USE_REGEX */

/*
 * This little bit of nonsense is because USE_REGEX is currently
 * supposed to be recognized only by the proxy.  If that's the
 * case, only the proxy should define USE_REGEX, but I'm playing
 * it safe.  XXXHEP 12/96
 */
#ifndef MCC_PROXY
#ifdef USE_REGEX
#define SAVED_USE_REGEX USE_REGEX
#undef USE_REGEX
#endif /* USE_REGEX */
#endif /* !MCC_PROXY */

#ifndef PUBLIC_BASE_REGEXP_H
#include "public/base/regexp.h"
#endif /* !PUBLIC_BASE_REGEXP_H */

/* --- Begin function prototypes --- */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

NSAPI_PUBLIC int INTregexp_valid(char *exp);

NSAPI_PUBLIC int INTregexp_match(char *str, char *exp);

NSAPI_PUBLIC int INTregexp_cmp(char *str, char *exp);

NSAPI_PUBLIC int INTregexp_casecmp(char *str, char *exp);

NSPR_END_EXTERN_C

#define regexp_valid INTregexp_valid
#define regexp_match INTregexp_match
#define regexp_cmp INTregexp_cmp
#define regexp_casecmp INTregexp_casecmp

#endif /* INTNSAPI */

/* Restore USE_REGEX definition for non-proxy.  See above. */
#ifdef SAVED_USE_REGEX
#define USE_REGEX SAVED_USE_REGEX
#undef SAVED_USE_REGEX
#endif /* SAVED_USE_REGEX */

#endif /* !BASE_REGEXP_H */
