/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_SEM_H
#define BASE_SEM_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

/*
 * sem.h: Attempt to provide multi-process semaphores across platforms
 * 
 * Rob McCool
 */

#ifndef BASE_SYSTEMS_H
#include "systems.h"
#endif /* !BASE_SYSTEMS_H */

/* All of the implementations currently use int as the semaphore type */

#ifndef PUBLIC_BASE_SEM_H
#include "public/base/sem.h"
#endif /* !PUBLIC_BASE_SEM_H */

/* --- Begin function prototypes --- */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

NSAPI_PUBLIC SEMAPHORE INTsem_init(char *name, int number);

NSAPI_PUBLIC void INTsem_terminate(SEMAPHORE id);

NSAPI_PUBLIC int INTsem_grab(SEMAPHORE id);

NSAPI_PUBLIC int INTsem_tgrab(SEMAPHORE id);

NSAPI_PUBLIC int INTsem_release(SEMAPHORE id);

NSPR_END_EXTERN_C

#define sem_init INTsem_init
#define sem_terminate INTsem_terminate
#define sem_grab INTsem_grab
#define sem_tgrab INTsem_tgrab
#define sem_release INTsem_release

#endif /* INTNSAPI */

#endif /* !BASE_SEM_H */

