/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_SESSION_H
#define BASE_SESSION_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

/*
 * session.h: Deals with virtual sessions
 *
 * A session is the time between when a client connects and when it
 * disconnects. Several requests may be handled in one session.
 *
 * Rob McCool
 */

#ifndef NETSITE_H
#include "netsite.h"  /* MALLOC etc */
#endif /* !NETSITE_H */

#ifndef BASE_NET_H
#include "net.h"          /* dns-related stuff */
#endif /* !BASE_NET_H */

#ifndef BASE_BUFFER_H
#include "buffer.h"       /* netbuf */
#endif /* !BASE_BUFFER_H */

#ifndef PUBLIC_BASE_SESSION_H
#include "public/base/session.h"
#endif /* !PUBLIC_BASE_SESSION_H */

/* --- Begin function prototypes --- */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

NSAPI_PUBLIC
Session *INTsession_alloc(SYS_NETFD csd, struct sockaddr_in *sac); /* internal */

NSAPI_PUBLIC Session *INTsession_fill(Session *sn); /* internal */

NSAPI_PUBLIC
Session *INTsession_create(SYS_NETFD csd, struct sockaddr_in *sac);

NSAPI_PUBLIC void INTsession_free(Session *sn);

NSAPI_PUBLIC char *INTsession_dns_lookup(Session *sn, int verify);

NSPR_END_EXTERN_C

/* --- End function prototypes --- */

#define session_alloc INTsession_alloc
#define session_fill INTsession_fill
#define session_create INTsession_create
#define session_free INTsession_free
#define session_dns_lookup INTsession_dns_lookup

#endif /* INTNSAPI */

#endif /* !BASE_SESSION_H */
