/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef BASE_SHMEM_H
#define BASE_SHMEM_H

#ifndef NOINTNSAPI
#define INTNSAPI
#endif /* !NOINTNSAPI */

/*
 * shmem.h: Portable abstraction for memory shared among a server's workers
 * 
 * Rob McCool
 */


#ifndef NETSITE_H
#include "../netsite.h"
#endif /* !NETSITE_H */

#if defined (SHMEM_UNIX_MMAP) || defined (SHMEM_WIN32_MMAP)

#ifndef BASE_FILE_H
#include "file.h" /* SYS_FILE */
#endif /* !BASE_FILE_H */

#ifndef PUBLIC_BASE_SHMEM_H
#include "public/base/shmem.h"
#endif /* !PUBLIC_BASE_SHMEM_H */

/* --- Begin function prototypes --- */

#ifdef INTNSAPI

NSPR_BEGIN_EXTERN_C

NSAPI_PUBLIC shmem_s *INTshmem_alloc(char *name, int size, int expose);

NSAPI_PUBLIC void INTshmem_free(shmem_s *region);

NSPR_END_EXTERN_C

#define shmem_alloc INTshmem_alloc
#define shmem_free INTshmem_free

#endif /* INTNSAPI */

#endif  /* SHMEM_UNIX_MMAP || SHMEM_WIN32_MMAP */

#endif /* !BASE_SHMEM_H */
