/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * subsystem.h: SubSystem Loading data structure 
 * 
 * Romy Ramil
 */

#include "frame/func.h"
#include "corba.h"

#ifndef _SUBSYSTEM_H
#define _SUBSYSTEM_H
  
/* --------------------------- Data Structure ----------------------------- */
typedef struct {
	char *  fname;	
	FuncPtr	fptr;
} sub_methods_t;
	
struct  subsystem_element {
	char * sub_name;
	char * obj_name;
} ;

class subsystem_list {
	private:
#define MAX_SUBSYSTEM 100
	short _sub_count;
	subsystem_element * _sub_array[MAX_SUBSYSTEM];

	public:
	~subsystem_list() {
		for (int i=0;i<_sub_count;i++)
			if (_sub_array[i])
				delete _sub_array[i]->sub_name;
				delete _sub_array[i]->obj_name;
				delete _sub_array[i];
		_sub_count = 0;
	}
	
	add_to_list( char * s_name, char * o_name ) {
		if (_sub_count >=MAX_SUBSYSTEM) {
			return 0;
		}
		else {
			_sub_array[_sub_count] = new subsystem_element;
			_sub_array[_sub_count]->sub_name = strdup(s_name);
			_sub_array[_sub_count]->obj_name = strdup(o_name);
			_sub_count++;
			return 1;
		}
	}
	char * _sname( short idx ) {
		return _sub_array[idx]->sub_name;
	}
	char * _oname( short idx ) {
		return _sub_array[idx]->obj_name;
	}
	short _scount( void) {
		return _sub_count;
	}
} ;

/* ------------------------------ Prototypes ------------------------------ */
int reg_subsystem(pblock *pb, Session *sn, Request *rq);
NSAPI_PUBLIC void  unreg_subsystems(void * param);
NSAPI_PUBLIC int init_subsystem( pblock * pb, Session *sn, Request *rq);
NSAPI_PUBLIC void load_subsystem(sub_methods_t *sublist);

#endif
