/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * cgi-util.h: Various form processing functions
 * 
 * Rob McCool
 */


/* AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAGH STDIO */
#include <stdio.h>    /* various atrocities */

#define LF 10
#define CR 13


/* 
 * The maximum size of a form submission. Your name and value buffers should
 * be this length.
 */

#define MAX_CONTENT_LEN 102400

/*
 * Initializes a post form handler.
 */

void post_init(FILE *f);

/*
 * Gets the next name value pair from the form. name and value should be 
 * MAX_CONTENT_LENGTH bytes. Returns 1 on EOF or error and 0 on no error.
 * Be sure to check name[0] and value when 1 is returned.
 */

int post_next(char *name, char *value, FILE *f);

/*
 * Makes a string array of all the files in a directory.
 * If dashA is set, include . files that are not . and ..
 */
char **list_directory(char *path, int dashA);

/*
 * Script jumps ship. Content type should have been printed prior to calling
 * this. fmt is a printf formatting string, followed by any parameters.
 */

void die(char *fmt, ...);

/*
 * Compress whitespace from a string, replace commas with an or symbol (|)
 * Returns a newly malloced string.
 *
 * Also adds parentheses around the string, which may not be needed.
 */

char *compress_and_replace(char *source);

/* Does the following to a string:
 * 1. Compresses spaces, replaces , with |
 * 2. Negates the expression
 * 3. Checks the host restriction to make sure it is a valid expression
 */
char *fix_hn_exp(char *exp);

