/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * Prototypes for functions which deal with httpd config files.
 * 
 * Rob McCool
 */

#include "frame/objset.h"
#include "frame/req.h"


#define OBJ_DATABASE "../config/obj.conf"

/* Writes the given object set as the current database */
void dump_database(httpd_objset *os);

/* Scans the current database and returns its object set. */
httpd_objset *read_config(void);


/* Inserts a new pfx2dir name translation into the object, making sure there
   are no name conflicts. Name conflict resolution is simple: Keep the longest
   from fields first in the file. */

/* Theory: If we keep the list sorted from the start, we don't
   have to re-sort it. So this doesn't check that. */

void insert_ntrans(pblock *p, pblock *c, httpd_object *obj);

/* Inserts a new alias in the database (before all other entries) */
void insert_alias(pblock *p, pblock *c, httpd_object *obj);

/* Scans a file and puts all of its lines into a char * array. Strips 
   trailing whitespace */
char **scan_tech(char *fn);

/* Writes the lines to the given file */
int write_tech(char *fn, char **lines);

/* Find an object given a query string (qs should start with t or p) */
httpd_object *qs2obj(char *qs, httpd_objset *os);

/* Like objset_findbyppath, but does not treat qs as a pattern. qs should
   not start with p. */
httpd_object *findliteralppath(char *qs, httpd_objset *os);
