/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * accel.h
 *
 * Defines the httpd accelerator routines.
 * 
 * Mike Belshe
 * 12-21-95
 * 
 */

#ifndef _ACCEL_H_
#define _ACCEL_H_

#include "base/multiplex.h"
#include "frame/req.h"

/* "front-end" functions */
NSAPI_PUBLIC int accel_accept_connection(mr_pool_t *mrp, int sock);
NSAPI_PUBLIC int accel_read_request(Session *session);
NSAPI_PUBLIC int accel_async_scan_headers(Request *req);
NSAPI_PUBLIC int accel_send_plain_file(Request *req);

/* "back-end" callback functions */
NSAPI_PUBLIC int acb_accept_connection(overlapped_io_t *olp);
NSAPI_PUBLIC int acb_read_request(overlapped_io_t *olp);
NSAPI_PUBLIC int acb_async_scan_headers(overlapped_io_t *olp);
NSAPI_PUBLIC int acb_send_plain_file(overlapped_io_t *olp);
NSAPI_PUBLIC int acb_close_connection(overlapped_io_t *olp);

/* misc functions */
/*int accel_pass_to_worker(Request *request);*/

#endif
