/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#define LIBRARY_NAME "frame"

static char dbtframeid[] = "$DBT: frame referenced v1 $";

#include "i18n.h"

BEGIN_STR(frame)

	ResDef( DBT_LibraryID_, -1, dbtframeid )/* extracted from dbtframe.h*/
	ResDef(DBT_CheckMsg_,1,"<TITLE>Not Found</TITLE><H1>Not Found</H1> The requested object does not exist on this server. The link you followed is either outdated, inaccurate, or the server has been instructed not to let you have it. ")/*extracted from error.cpp*/
	ResDef(DBT_RefererMsg_,2,"Please inform the site administrator of the <A HREF=\"%s\">referring page</A>.")/*extracted from error.cpp*/

/* #ifdef MCC_PROXY */

	ResDef(DBT_ProtocolBadRequestMsg_,3,"Your browser sent a request that this proxy could not understand.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolUnauthorizedMsg_,4,"Proper authorization is required for the administration of this proxy.\nEither your browser does not perform authorization, or your authorization\nhas failed.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolProxyUnauthorizedMsg_,5,"Username authentication is required for using this proxy.\nEither your browser does not perform proxy authorization, or your\nauthorization has failed.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolForbiddenMsg_,6,"The proxy's access control configuration denies access to\nthe requested object through this proxy.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolServerErrorMsg_,7,"The proxy has encountered an internal error which prevents it from\nfulfilling your request. The most likely cause is a misconfiguration.\nPlease ask the administrator to look for messages in the proxy's error log.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolNotImplementedMsg_,8,"This proxy server does not implement the requested method.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolDefaultErrorMsg_,9,"An error has occurred on the proxy server.")/*extracted from error.cpp*/

/* #else */

	ResDef(DBT_ProtocolBadRequestMsg_2,10,"Your browser sent a query this server could not understand.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolUnauthorizedMsg_2,11,"Proper authorization is required for this area. Either your browser does not perform authorization, or your authorization has failed.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolForbiddenMsg_2,12,"Your client is not allowed to access the requested object.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolServerErrorMsg_2,13,"This server has encountered an internal error which prevents it from fulfilling your request. The most likely cause is a misconfiguration. Please ask the administrator to look for messages in the server's error log.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolNotImplementedMsg_2,14,"This server does not implement the requested method.")/*extracted from error.cpp*/
	ResDef(DBT_ProtocolDefaultErrorMsg_2,15,"An error has occurred.")/*extracted from error.cpp*/

/* #endif */

	ResDef(DBT_Http10400BadRequestCCserverSCCCC_,16,"Your browser sent a message this server could not understand.")/*extracted from error.cpp*/
	ResDef(DBT_HtmlHeadTitleSTitleHeadBodyH1SH1_,17,"<HTML><HEAD><TITLE>%s</TITLE></HEAD><BODY><H1>%s</H1>\nThis document has moved to a new <a href=\"%s\">location</a>. Please update your documents and hotlists accordingly.</BODY></HTML>")/*extracted from error.cpp*/
	ResDef(DBT_HtmlHeadTitleSTitleHeadNBodyH1SH_,18,"<HTML><HEAD><TITLE>%s</TITLE></HEAD>\n<BODY><H1>%s</H1>\n%s\n</BODY></HTML>")/*extracted from error.cpp*/

	ResDef( DBT_processUriObjects_, 19, "process-uri-objects" )/*extracted from httpact.cpp*/
	ResDef( DBT_cannotFindTemplateS_, 20, "cannot find template %s" )/*extracted from httpact.cpp*/
	ResDef( DBT_processUriObjects_1, 21, "process-uri-objects" )/*extracted from httpact.cpp*/
	ResDef( DBT_noPartialPathAfterObjectProcessi_, 22, "no partial path after object processing" )/*extracted from httpact.cpp*/
	ResDef( DBT_findService_, 23, "find-service" )/*extracted from httpact.cpp*/
	ResDef( DBT_invalidShexpS_, 24, "invalid shexp %s" )/*extracted from httpact.cpp*/
	ResDef( DBT_findService_1, 25, "find-service" )/*extracted from httpact.cpp*/
	ResDef( DBT_invalidShexpS_1, 26, "invalid shexp %s" )/*extracted from httpact.cpp*/
	ResDef( DBT_handleProcessed_, 27, "handle-processed" )/*extracted from httpact.cpp*/
	ResDef( DBT_noWayToServiceRequestForS_, 28, "no way to service request for %s" )/*extracted from httpact.cpp*/
	ResDef( DBT_finishSocksRequest_, 29, "finish-socks-request" )/*extracted from httpact.cpp*/
	ResDef( DBT_closeFailedSCsdD_, 30, "close failed (%s), csd=%d" )/*extracted from httpact.cpp*/
	ResDef( DBT_thisBetaSoftwareHasExpiredN_, 31, "This beta software has expired.\n" )/*extracted from httpact.cpp*/
	ResDef( DBT_mrAcceptD_, 32, "mr_accept(%d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorIssuingReadOnAcceptSocket_, 33, "Error issuing read on accept socket" )/*extracted from accel.cpp*/
	ResDef( DBT_acbAcceptConnectionD_, 34, "acb_accept_connection(%d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorGettingAcceptSocketD_, 35, "Error getting accept socket (%d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorInAcceptDS_, 36, "Error in accept! (%d, %s)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorCreatingNewAcceptRequest_, 37, "Error creating new accept request" )/*extracted from accel.cpp*/
	ResDef( DBT_acceptedConnectionDNsprD_, 38, "accepted connection: %d (NSPR %d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorCreatingNewSessionStructure_, 39, "Error creating new session structure" )/*extracted from accel.cpp*/
	ResDef( DBT_accelReadRequest_, 40, "accel_read_request()" )/*extracted from accel.cpp*/
	ResDef( DBT_errorAllocatingRequestReadBuffer_, 41, "Error allocating request read buffer" )/*extracted from accel.cpp*/
	ResDef( DBT_errorIssuingAsyncReadRequest_, 42, "Error issuing async read request" )/*extracted from accel.cpp*/
	ResDef( DBT_acbReadRequestDBytesD_, 43, "acb_read_request(%d, bytes %d)" )/*extracted from accel.cpp*/
	ResDef( DBT_acbReadReq1SessionD_, 44, "acb_read_req(1 session = %d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorReadingRequestDS_, 45, "Error reading request (%d, %s)" )/*extracted from accel.cpp*/
	ResDef( DBT_clientAbortedConnection_, 46, "Client aborted connection" )/*extracted from accel.cpp*/
	ResDef( DBT_errorReadingRequest_, 47, "Error reading request" )/*extracted from accel.cpp*/
	ResDef( DBT_errorCreatingNewRequest_, 48, "Error creating new request" )/*extracted from accel.cpp*/
	ResDef( DBT_errorOccurredClosingDIoWasForD_, 49, "error occurred, closing %d, io was for %d" )/*extracted from accel.cpp*/
	ResDef( DBT_accelAsyncScanHeaders_, 50, "accel_async_scan_headers()" )/*extracted from accel.cpp*/
	ResDef( DBT_outOfMemoryAccelAsyncScanHeaders_, 51, "out of memory: accel_async_scan_headers" )/*extracted from accel.cpp*/
	ResDef( DBT_outOfMemoryAccelAsyncScanHeaders_1, 52, "out of memory: accel_async_scan_headers" )/*extracted from accel.cpp*/
	ResDef( DBT_errorDuringAsyncReadDS_, 53, "Error during async read (%d, %s)" )/*extracted from accel.cpp*/
	ResDef( DBT_scanHeadersReportsLineTooLong_, 54, "scan-headers reports: line too long" )/*extracted from accel.cpp*/
	ResDef( DBT_scanHeadersReportsTooManyHeaders_, 55, "scan-headers reports: too many headers" )/*extracted from accel.cpp*/
	ResDef( DBT_errorReadingHeaders_, 56, "Error reading headers" )/*extracted from accel.cpp*/
	ResDef( DBT_scanHeadersReportsHeaderMissingT_, 57, "scan-headers reports: header missing terminator (an empty line)" )/*extracted from accel.cpp*/
	ResDef( DBT_scanHeadersReportsHeaderWasEmpty_, 58, "scan-headers reports: header was empty" )/*extracted from accel.cpp*/
	ResDef( DBT_nameWithoutValueGotLineS_, 59, "name without value: got line \"%s\"" )/*extracted from accel.cpp*/
	ResDef( DBT_accelSendPlainFile_, 60, "accel_send_plain_file()" )/*extracted from accel.cpp*/
	ResDef( DBT_accelSendPlainFileFoundRequestD_, 61, "accel_send_plain_file() - found request %d" )/*extracted from accel.cpp*/
	ResDef( DBT_parseHeadersLostTheUri_, 62, "Parse headers lost the URI!" )/*extracted from accel.cpp*/
	ResDef( DBT_accelSendPlainFileFoundUriS_, 63, "accel_send_plain_file() - found uri %s" )/*extracted from accel.cpp*/
	ResDef( DBT_accelSendPlainFileFoundInCache_, 64, "accel_send_plain_file() - found in cache?" )/*extracted from accel.cpp*/
	ResDef( DBT_mallocDied_, 65, "malloc died!" )/*extracted from accel.cpp*/
	ResDef( DBT_errorWritingBackFileN_, 66, "Error writing back file\n" )/*extracted from accel.cpp*/
	ResDef( DBT_acbSendPlainFileD_, 67, "acb_send_plain_file(%d)" )/*extracted from accel.cpp*/
	ResDef( DBT_errorWritingInAcbSendPlainFileDS_, 68, "Error writing in acb_send_plain_file (%d, %s)" )/*extracted from accel.cpp*/
	ResDef( DBT_acbCloseConnectionD_, 69, "acb_close_connection(%d)" )/*extracted from accel.cpp*/
	ResDef( DBT_erroredIoInAcbCloseConnectionDS_, 70, "Errored IO in acb_close_connection (%d, %s)" )/*extracted from accel.cpp*/
	ResDef( DBT_unableToCloseSocketD_, 71, "Unable to close socket %d" )/*extracted from accel.cpp*/
	ResDef( DBT_accelCacheInsertErrorAllocatingE_, 72, "accel-cache-insert: Error allocating entry" )/*extracted from accel_cache.cpp*/
	ResDef( DBT_cacheInitServerCacheDisabled_, 73, "cache-init: server cache disabled" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheErrorInitializingF_, 74, "accel_file_cache: Error initializing file cache" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheErrorCreatingCache_, 75, "accel_file_cache: Error creating cache" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitHashSizeDUsing_, 76, "accel_file_cache_init: CacheHashSize < %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitHashSizeDUsing_1, 77, "accel_file_cache_init: CacheHashSize > %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitCacheSizeDUsin_, 78, "accel_file_cache_init: MaxNumberOfCachedFiles < %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitCacheSizeDUsin_1, 79, "accel_file_cache_init: MaxNumberOfCachedFiles > %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitMaxFilesDUsing_, 80, "accel_file_cache_init: MaxNumberOfOpenCachedFiles < %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheInitMaxFilesDUsing_1, 81, "accel_file_cache_init: MaxNumberOfOpenCachedFiles > %d, using %d" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheErrorInitializingF_1, 82, "accel_file_cache: Error initializing file cache" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_fileCacheEnabledS_, 83, "file-cache: enabled = %s " )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_on_, 84, "on" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_off_, 85, "off" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_fileCacheCacheSizeD0xX_, 86, "file-cache: MaxNumberOfCachedFiles %d (0x%x)" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_fileCacheHashSizeD0xX_, 87, "file-cache: CacheHashSize %d (0x%x)" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_fileCacheMaxFilesD0xX_, 88, "file-cache: MaxNumberOfOpenCachedFiles %d (0x%x)" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelCacheInsertErrorAllocatingE_1, 89, "accel-cache-insert: Error allocating entry" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_fileCacheCleanupMunmapFailedS_, 90, "file-cache-cleanup: munmap failed (%s)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCleanupFoundMmappedFile_, 91, "file-cache-cleanup: found mmapped file \non system without mmap" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInitMmapMaxDUsingD_, 92, "file_cache_init: MaxTotalCachedFileSize < %d, using %d" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInitMmapMaxDUsingD_1, 93, "file_cache_init: MaxTotalCachedFileSize > %d, using %d" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUsingMmapFlags0xX_, 94, "file cache using mmap flags 0x%x" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUsingMmapProts0xX_, 95, "file cache using mmap prots 0x%x" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInitCouldNotCreateLock_, 96, "file-cache-init: could not create lock" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUnableToCreateTemporary_, 97, "file-cache: unable to create temporary directory %s.\n" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUnableToCreateTemporary_1, 98, "file-cache: unable to create temporary directory %s.\n" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheGettemppathCannotFindTe_, 99, "file-cache: GetTempPath() Cannot find temp directory to store file!" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInitSetMaxCachedFileSiz_, 100, "file-cache-init: set max cached file size to %d" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInitCouldNotCreateLock_1, 101, "file-cache-init: could not create lock" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheDestroy_, 102, "file_cache_destroy()" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUnableToGetTempFileName_, 103, "file-cache: Unable to get temp file name. Error %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheUnableToGetTempFileName_1, 104, "file-cache: Unable to get temp file name. Error %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheInsertErrorAllocatingEn_, 105, "file-cache-insert: Error allocating entry" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCreateErrorOpeningFileS_, 106, "file-cache-create: Error opening file %s (%s)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCreateErrorStatIngFileS_, 107, "file-cache-create: Error stat()ing file %s (%s)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCreateErrorMmapIngFileS_, 108, "file-cache-create: Error mmap()ing file %s (%s)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCreateMallocFailure_, 109, "file-cache-create: malloc failure" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheCreateErrorCaseFailedTo_, 110, "file-cache-create: error case failed to munmap(%d, %d) (%s)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheValidCannotStatS_, 111, "file-cache-valid: cannot stat %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_dirChangeInvalidatingSD_, 112, "dir change: invalidating %s (%d)" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheAsynchronousFileChangeN_, 113, "file-cache:  asynchronous file change notification failed." )/*extracted from file_cache.cpp*/
	ResDef( DBT_dirChangeOffsetDActionDLenDNameS_, 114, "dir change: offset %d, action %d, len %d, name %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_unableToCheckAsyncFileStatus_, 115, "unable to check async file status" )/*extracted from file_cache.cpp*/
	ResDef( DBT_readdirectorychangeswFailureUnab_, 116, "ReadDirectoryChangesW failure- unable to continue watching %s. Error is %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_fileCacheAddWatchFailureUnableTo_, 117, "file-cache-add-watch failure- unable to open directory %s.  Error %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_readdirectorychangeswFailureUnab_1, 118, "ReadDirectoryChangesW failure- unable to start watching %s.  Error %s" )/*extracted from file_cache.cpp*/
	ResDef( DBT_funcExec_, 119, "func_exec" )/*extracted from func.cpp*/
	ResDef( DBT_noHandlerFunctionGivenForDirecti_, 120, "no handler function given for directive" )/*extracted from func.cpp*/
	ResDef( DBT_funcExec_1, 121, "func_exec" )/*extracted from func.cpp*/
	ResDef( DBT_cannotFindFunctionNamedS_, 122, "cannot find function named %s" )/*extracted from func.cpp*/
	ResDef( DBT_handleRequest_, 123, "handle-request" )/*extracted from http.cpp*/
	ResDef( DBT_methodWithoutUri_, 124, "method without URI" )/*extracted from http.cpp*/
	ResDef( DBT_httpParseRequest_, 125, "http-parse-request" )/*extracted from http.cpp*/
	ResDef( DBT_whileScanningHttpHeadersS_, 126, "while scanning HTTP headers, %s" )/*extracted from http.cpp*/
	ResDef( DBT_handleRequest_1, 127, "handle-request" )/*extracted from http.cpp*/
	ResDef( DBT_readFromSFailedErrorIsS_, 128, "read from %s failed, error is %s" )/*extracted from http.cpp*/
	ResDef( DBT_handleRequest_2, 129, "handle-request" )/*extracted from http.cpp*/
	ResDef( DBT_requestTooLong_, 130, "request too long" )/*extracted from http.cpp*/
	ResDef( DBT_startHttpResponse_, 131, "start-http-response" )/*extracted from http.cpp*/
	ResDef( DBT_writeFailedS_, 132, "write failed (%s)" )/*extracted from http.cpp*/
	ResDef( DBT_startHttpResponse_1, 133, "start-http-response" )/*extracted from http.cpp*/
	ResDef( DBT_writeFailedS_1, 134, "write failed (%s)" )/*extracted from http.cpp*/
	ResDef( DBT_httpStatus_, 135, "http-status" )/*extracted from http.cpp*/
	ResDef( DBT_DIsNotAValidHttpStatusCode_, 136, "%d is not a valid HTTP status code" )/*extracted from http.cpp*/
	ResDef( DBT_finishRequest_, 137, "finish-request" )/*extracted from http.cpp*/
	ResDef( DBT_closeFailedS_, 138, "close failed (%s)" )/*extracted from http.cpp*/
	ResDef( DBT_unableToCloseSocketForWriting_, 139, "Unable to close socket for writing" )/*extracted from http.cpp*/
	ResDef( DBT_osHasDObjects_, 140, "os has %d objects" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_objDHasNoHashTableAtD_, 141, "obj %d has no hash table at %d" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_objDHasNoParam_, 142, "obj %d has no param" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_objDNameSValueS_, 143, "obj %d name %s  value %s" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_DirectivesD_, 144, ".....directives %d......." )/*extracted from ntobjset.cpp*/
	ResDef( DBT_DirectiveD_, 145, ".....directive %d" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_InstanceD_, 146, ".......instance %d" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_ParamNameSValueS_, 147, "...........param name %s value %s" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_clearconfigurationparametersRegc_, 148, "ClearConfigurationParameters:RegCreateKey %s" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_clearconfigurationparametersRege_, 149, "ClearConfigurationParameters:RegEnumKey %s failed" )/*extracted from ntobjset.cpp*/
	ResDef( DBT_objConfLineDErrorInFilterFileSAt_, 150, "obj.conf line %d: error in filter file \"%s\" at line %d: %s" )/*extracted from objset.cpp*/
	ResDef( DBT_objConfLineDErrorInFilterFileSAt_1, 151, "obj.conf line %d: error in filter file \"%s\" at line %d: %s" )/*extracted from objset.cpp*/
	ResDef( DBT_unableToAllocateSubjectPropertyL_, 152, "Unable to allocate Subject property list.\n" )/*extracted from acl.cpp*/
	ResDef( DBT_unableToSetSessionPtrInSubjectPr_, 153, "Unable to set session ptr in Subject property list - error=%d\n" )/*extracted from acl.cpp*/
	ResDef( DBT_unableToSetRequestPtrInSubjectPr_, 154, "Unable to set request ptr in Subject property list - error=%d\n" )/*extracted from acl.cpp*/
	ResDef( DBT_accelFileCacheValidCannotStatS_, 155, "file-cache-valid: cannot stat %s" )/*extracted from accel_file_cache.cpp*/
	ResDef( DBT_accelFileCacheCreateErrorStatIngFileS_, 156, "file-cache-create: Error stat()ing file %s (%s)" )/*extracted from file_cache.cpp*/
END_STR(frame)
