/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef __ipfilter_h
#define __ipfilter_h

/* Define error codes */
#define IPFERR_MAX	(-1)	/* maximum error code value */
#define IPFERR_MALLOC	(-1)	/* insufficient memory */
#define IPFERR_FOPEN	(-2)	/* file open error */
#define IPFERR_FILEIO	(-3)	/* file I/O error */
#define IPFERR_DUPSPEC	(-4)	/* duplicate filter specification */
#define IPFERR_INTERR	(-5)	/* internal error (bug) */
#define IPFERR_SYNTAX	(-6)	/* syntax error in filter file */
#define IPFERR_CNFLICT	(-7)	/* conflicting filter specification */
#define IPFERR_MIN	(-7)	/* minimum error code value */

/* Define a scalar IP address value */
#ifndef __IPADDR_T_
#define __IPADDR_T_
typedef unsigned long IPAddr_t;
#endif /* __IPADDR_T_ */


/* Define structure for returning error information */
typedef struct IPFilterErr_s IPFilterErr_t;
struct IPFilterErr_s {
    int errNo;			/* IPFERR_xxxx error code */
    int lineno;			/* file line number, if applicable */
    char * filename;		/* filename, if applicable */
    char * errstr;		/* error text, if any */
};

/* Data and functions in ipfilter.c */
extern void * ipf_objndx;
NSAPI_PUBLIC extern void ip_filter_destroy(void * ipfptr);
NSAPI_PUBLIC 
extern int ip_filter_setup(pblock * client, IPFilterErr_t * reterr);
NSAPI_PUBLIC extern int ip_filter_check(pblock * client, IPAddr_t cip);

#endif /* __ipfilter_h */
