/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#define LIBRARY_NAME "httpdaemon"

static char dbthttpdaemonid[] = "$DBT: httpdaemon referenced v1 $";

#include "i18n.h"

BEGIN_STR(httpdaemon)
	ResDef( DBT_LibraryID_, -1, dbthttpdaemonid )/* extracted from dbthttpdaemon.h*/
	ResDef( DBT_errorInConvertthreadtofiber_, 1, "Error in ConvertThreadToFiber" )/*extracted from fiber.c*/
	ResDef( DBT_errorInConvertthreadtofiber_1, 2, "Error in ConvertThreadToFiber" )/*extracted from fiber.c*/
	ResDef( DBT_errorInMdStartSystem_, 3, "Error in md_start_system" )/*extracted from fiber.c*/
	ResDef( DBT_errorInCreatefiberIdlefiber_, 4, "Error in CreateFiber - idlefiber" )/*extracted from fiber.c*/
	ResDef( DBT_errorInGetqueuedcompletionstatus_, 5, "Error in GetQueuedCompletionStatus" )/*extracted from fiber_nt_md.c*/
	ResDef( DBT_errorCreatingCompletionPort_, 6, "Error creating completion port" )/*extracted from fiber_nt_md.c*/
	ResDef( DBT_couldNotSethandlenoninheritableS_, 7, "Could not SetHandleNonInheritable (%s)" )/*extracted from daemon.cpp*/
	ResDef( DBT_errorAcceptReadNewConn_, 8, "Error accept/read new conn" )/*extracted from daemonsession.cpp*/
	ResDef( DBT_errorInRespond_, 9, "Error in Respond()" )/*extracted from daemonsession.cpp*/
	ResDef( DBT_errorInRespondcompleted_, 10, "Error in RespondCompleted()" )/*extracted from daemonsession.cpp*/
	ResDef( DBT_daemonUnableToForkNewProcessSN_, 11, "daemon: unable to fork new process (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_daemonSetsidFailedSN_, 12, "daemon: setsid failed (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_daemonCanTLogPidToSSN_, 13, "daemon: can't log pid to %s (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_warningCouldNotSetGroupIdToDSN_, 14, "warning: could not set group id to %d (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_warningCouldNotSetUserIdToDSN_, 15, "warning: could not set user id to %d (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_warningDaemonIsRunningAsSuperUse_, 16, "warning: daemon is running as super-user\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_couldNotDetermineCurrentUserName_, 17, "could not determine current user name\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_errorChrootToSFailedSN_, 18, "error: chroot to %s failed (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_warningNetscapeExecutableAndLibr_, 19, "WARNING! Fedora executable and library have different versions.\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_startupListeningToSPortDAsSN_, 20, "startup: listening to %s://%s, port %d as %s\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_startupListeningToPortDAsSN_, 21, "startup: listening to %s://%s, port %d as %s\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_seminitFailedSN_, 22, "seminit failed (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_usingSingleThreadedAccepts_, 23, "Using single threaded accepts." )/*extracted from daemon.cpp*/
	ResDef( DBT_usingMultiThreadedAccepts_, 24, "Using multi threaded accepts." )/*extracted from daemon.cpp*/
	ResDef( DBT_usingPartialSingleThreadedAccept_, 25, "Using partial single threaded accepts." )/*extracted from daemon.cpp*/
	ResDef( DBT_thisMachineHasDProcessors_, 26, "This machine has %d processors." )/*extracted from daemon.cpp*/
	ResDef( DBT_errorCallingThrSeconcurrencyDS_, 27, "Error calling thr_seconcurrency(%d)- (%s)" )/*extracted from daemon.cpp*/
	ResDef( DBT_setConncurrencyToD_, 28, "Set conncurrency to %d." )/*extracted from daemon.cpp*/
	ResDef( DBT_canTForkNewProcessS_, 29, "can't fork new process (%s)" )/*extracted from daemon.cpp*/
	ResDef( DBT_thisBetaSoftwareHasExpiredN_, 30, "This beta software has expired.\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_canTCreateIpcPipeS_, 31, "can't create IPC pipe (%s)" )/*extracted from thrconn.cpp*/
	ResDef( DBT_writeToWakeupPipeFailedS_, 32, "write to wakeup pipe failed (%s)" )/*extracted from thrconn.cpp*/
	ResDef( DBT_selectThreadMiss_, 33, "select thread miss" )/*extracted from daemon.cpp*/
	ResDef( DBT_couldNotBindToPortD_, 34, "startup failure: could not bind to port %d (%s)\n" )/*extracted from daemon.cpp*/
	ResDef( DBT_couldNotBindToPortDH_, 35, "startup failure: could not bind to port %d, IP address %s (%s)\n" )/*extracted from daemon.cpp*/
END_STR(httpdaemon)
