/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
//
// Name:    nsirutil.h
// Contact: mjb<barbarin@netscape.com>
// -------------------------------------------------------------------------------

#ifndef __NSIRUTIL_H
#define __NSIRUTIL_H 1

#include <iostream.h>
#include "nsirinc.h"
#include "libnscore/nsavpair.h"
#include "libnscore/nsmfile.h"

// Name: ChangeChar
// Notes:
//    Change one character to another in the source string.

void 
ChangeChar(Str src, char from, char to);

int

// Name: CompareStrToLower
// Notes:
//    Compare a string (of mixed case) to a lower-case string and decide if they 
//    are the same.  This is useful when matching input strings against a fixed
//    target.

CompareStrToLower(Str anyString, Str lowerCaseString, int len=0);


// Name: HTMLescape
// Notes:
//    Convert a string to display in HTML, changing any special HTML characters
//    with the proper "escaped" versions.  For example, '<' goes to '&lt;'.

void
HTMLescape(Str input, ostream& output, int appendEnds=1);


// Name: NormalizePathSlashes
// Notes:
//    NT (and users) sometimes use a native file path notation that will include
//    a backslash every once in awhile.  Sometimes code has the path already 
//    normalized and this makes it hard to compare.  So we need to normalize
//    sometimes.

void
NormalizePathSlashes(Str fname);


// Name: StrArgCopy
// Notes:
//    Copy the source string into a target string, deleting the target and
//    replacing it with an appropriately sized one.

NSbool 
StrArgCopy(Str& target, CStr source);


Str
URIescape(Str dest, Str src);


// Name: StreamURIescape
// Notes:
//    Convert a string to display in HTML, changing any special HTML characters
//    with the proper "escaped" versions.  For example, ' ' to %20.

void
StreamURIescape(Str input, ostrstream& output);


// Name: UnescapeArg
// Notes:
//    Convert special characters (those %nn things) and '+' in arguments passed
//    to a CGI or SAF to the appropriate characters -- the ASCII equivalent of
//    the hex value nn or a blank in the case of a '+'.

void 
UnescapeArg(Str val);


int
NSutil_itoa(int i, char *a);

#endif
