/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef TIMERSERVICEPROVIDER_H
#define TIMERSERVICEPROVIDER_H
#include <time.h>
#include <rw/tislist.h>
#include <base/systhr.h>
#include <base/crit.h>
#include <libmsgdisp/msgchnel.h>


#if HAS_TIMER  

NSPR_BEGIN_EXTERN_C

struct TriggerInfoStruct : public RWIsvSlink
{
  unsigned long timeToTrigger;
  long (*fnToCall) (short msdID, long objID, 
		void *supplierData, void *consumerData );
  void* clntData;
};



class TimerServiceProvider {
  public :
    TimerServiceProvider(int minDelta = 5);
    ~TimerServiceProvider();
    int IsValid() { return _valid; }
    int TimerServiceProvider::AddTimeObject(void* timerServiceObj,
                        unsigned long timeToTrigger,
                        long (*fnPtr)(short msdID, long objID,
                                      void *supplierData, void *consumerData ),
                         void* clntData);

    static int DeleteTimeObject(void* timerServiceObj,
				unsigned long timeToTrigger);
    static void MyTimeOutHandler();

  private :
    //static RWTIsvSlist<TriggerInfoStruct> _list;
    static int _minDelta;
    static int _fd[2];
    static SYS_THREAD _myTimerThread;
    static CRITICAL   _timerCriticalSecVar;
    static timeval* _myTimeOutStruct;
    int    _valid;
    

    static RWBoolean myTesterFunc(const TriggerInfoStruct* currListElement,
				  void* newElement);
    static RWBoolean deleteTestFn(const TriggerInfoStruct* lstElement, 
                                   void* ptr);
    static void serviceTimerThread(void* clntData);
    int InsertInOrder(unsigned long timeToTrigger, 
		      long (*fnPtr)(short msdID, long objID,
                                      void *supplierData, void *consumerData ),
		       void* clntData);
    int DeleteFromList(unsigned long timeToTrigger);
};

NSPR_END_EXTERN_C

#endif /*  HAS_TIMER   */

#endif TIMERSERVICEPROVIDER_H
