/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef  _H_IBASE
#define  _H_IBASE

#include "netsite.h"
#include "objid.h"
#include "prtypes.h"

NSPR_BEGIN_EXTERN_C

typedef enum {
	CM_DOCUMENT_OBJECT          = 0x1,
	CM_CONTENT_STORE_OBJECT     = 0x2,
	CM_CONTANER_OBJECT          = 0x4,
	CM_CONTENT_MANAGER_OBJECT   = 0x8
} CMFlags;


typedef void (*CMMethod)();

/* Base Interface */
typedef struct IBaseVtbl IBaseVtbl ; 


typedef struct _t_IBase { 
	IBaseVtbl  *method; 
} IBase; 


struct IBaseVtbl { 
	long (*QueryInterface)( IBase * ics, long GUID, void **iPtr );
	void (*AddRef)( IBase * ics );
	long (*Release)( IBase * ics );
	long (*GetType)( IBase *idoc );
    char *(*GetPPath)( IBase *idoc );
	long (*GetID)( IBase *idoc );
};  

#define IBASE(a) a->method

NSPR_END_EXTERN_C

#endif  /*  _H_IBASE */

