/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef  _H_IMSG
#define  _H_IMSG

#include "netsite.h"
#include "ibase.h"
#include "nsarray.h"
#include "msgchnel.h"


NSPR_BEGIN_EXTERN_C


/* Base Interface */
typedef struct IMessageVtbl IMessageVtbl ; 


typedef struct _t_IMessage { 
	IMessageVtbl       *method; 
	IBase              *owner; 
	short              refCnt;         /* reference count */
	NSObjArray         *msgHook;       /* Array of event monitors */
} IMessage; 


struct IMessageVtbl { 
	long  (*QueryInterface)( IMessage * imsg, long GUID, void **iPtr );
	void  (*AddRef)( IMessage * imsg );
	long  (*Release)( IMessage * imsg );
	long  (*GetType)( IMessage *imsg );
    char  (*GetName)( IMessage *imsg );
	long (*GetID)( IBase *idoc );

	int   (*MsgAddMonitor)( IMessage *imsg, PushConsumer monitor );
	int   (*MsgDeleteMonitor)( IMessage *imsg, PushConsumer monitor );
    void  (*ProcessMonitor)( IMessage *imsg, short message, void *supplierData );
    IBase *(*GetOwner)( IMessage *imsg );
	int   (*MsgDeleteMessage)( IMessage *imsg, short msgID );
    void  (*DeleteMonitors)( IMessage *imsg, short message );
};  



NSAPI_PUBLIC int IMessageInit();
NSAPI_PUBLIC IMessage *IMessageNew();

#define IMSG(a) a->method

NSPR_END_EXTERN_C

#endif  /*  _H_IMSG  */
