/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef _H_UTIL
#define _H_UTIL

#include <stdlib.h>

#include "netsite.h"
#include "prtypes.h"

NSPR_BEGIN_EXTERN_C

typedef struct _CMStrObj {
	char          *buffer;
	unsigned long size;           /* current size of the table */
	int           used;           /* number of bytes used */
} CMStrObj;

NSAPI_PUBLIC CMStrObj *NewCMStrObj( int size );
NSAPI_PUBLIC char * CMStrObjAdd( CMStrObj *obj, char *str );
NSAPI_PUBLIC void CMStrObjRelease( CMStrObj *obj );
NSAPI_PUBLIC void CMStrObjFree( CMStrObj *obj );
NSAPI_PUBLIC char * CMStrObjGetString( CMStrObj *obj );
NSAPI_PUBLIC int CMStrObjGetSize( CMStrObj *obj );
NSAPI_PUBLIC char * CMStrObjAddBytes( CMStrObj *obj, char *str, int len );


NSAPI_PUBLIC long MakeUID( char *name );
NSAPI_PUBLIC int CMCopyString( char **dest, char *src );


NSPR_END_EXTERN_C

#endif /* _H_UTIL */
