/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef _H_MESSAGE_CHANNEL
#define _H_MESSAGE_CHANNEL

#include "mdtypes.h"
#include "mdbtree.h"
#include "pub_cons.h"


#include "timer_srvc.h"
#include "nsarray.h"

#include "netsite.h"

NSPR_BEGIN_EXTERN_C


typedef struct _t_PushConsumer {
	short          msgID;    /*  message to watch */
	long           objID;    /* Object that the consumer is interested in */
	char           *objName;
	void           *consumerData;
	NotifyProc     PushNotify;
	MD_DeleteProc  PushDelete;
} NSMonitor;



typedef struct _t_MsgNode {
	short    msgID;    /*  message to watch */
	BTree *consumerTree;
} MsgNode;



typedef struct _t_MsgChannel {
	NSObjArray *msgList;
	TIMERSERVICEPROVIDER timer;
} MsgChannel;

extern MsgChannel gChannel;
	
NSAPI_PUBLIC int MCInsertConsumerPush( PushConsumer pc );
NSAPI_PUBLIC int MsgChannelInit();
NSAPI_PUBLIC int MCInsertConsumerPush( PushConsumer pc );
NSAPI_PUBLIC int MCDeleteConsumerPush( PushConsumer pc );
NSAPI_PUBLIC PushConsumer MCFindConsumerPush( short msgID, long objID );
NSAPI_PUBLIC BTree *MCFindMsgTree( short msgID );
NSAPI_PUBLIC void MCDumpMessageChannel( char *output );



NSPR_END_EXTERN_C


#endif /*  _H_MESSAGE_CHANNEL */
