/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef NS_ARRAY_H
#define NS_ARRAY_H

#include "memory.h"

#include "netsite.h"


NSPR_BEGIN_EXTERN_C


#ifndef WIN
typedef void * NSHugePtr;
#else
typedef char _huge * NSHugePtr; 
#endif

typedef struct _NSObjArray {
        NSHugePtr    objects;         /* pointer to the objects */
        unsigned long size;           /* current size of the table */
        int           numObj;         /* number of objects */
        int           objSize;        /* object's size */
} NSObjArray;

typedef NSObjArray NSBuf;

NSAPI_PUBLIC NSObjArray *NSObjArrayNew(unsigned long ObjArraySize,int  objSize);
NSAPI_PUBLIC void NSObjArrayFree(NSObjArray *ObjArray);
NSAPI_PUBLIC void *NSObjArrayGetObj(NSObjArray  *ObjArray,int objNum);
NSAPI_PUBLIC void *NSObjArrayGetLastObj(NSObjArray  *ObjArray);
NSAPI_PUBLIC void *NSObjArrayNewObj(NSObjArray *ObjArray);
NSAPI_PUBLIC int NSObjArrayGetNumObj(NSObjArray  *ObjArray);
NSAPI_PUBLIC void NSObjArrayReset(NSObjArray  *ObjArray);
NSAPI_PUBLIC int NSObjArrayRemoveObj( NSObjArray *ObjArray, int objNum );
NSAPI_PUBLIC void *NSObjArrayGetObjNum( NSObjArray *objArray, int elemNum );

NSPR_END_EXTERN_C

#endif   /* FU_P_HEADER */

