/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * This package is responsible for all of the mechanisms required to find an
 * object implementation for the request, to prepare the object implementation to
 * receive the request, and communicate the data making up the request.
 * 
 * Daryoush Paknad
*/

/*
 * A set of predefined globaly unique Interface IDs.
*/
#ifndef _H_ORB
#define _H_ORB


#include "netsite.h"
#include "base/systems.h"
#include "mdtypes.h"
#include "ibase.h"
#include "iobjstore.h"
#include "nsarray.h"
#include "objid.h"

NSPR_BEGIN_EXTERN_C

/* Server Types */
#define DLL_SERVER  0
#define EXEC_SERVER 1




typedef IBase *(*ClassFactory)( void *cfData );    /* Create an instance */

typedef struct _t_NSInterface {
	long          guid;            /* GUID for the interface */
	short         serverType;      /* DLL_SERVER or EXEC_SERVER */
	char          *iName;          /* Interface name */
	char          *objServer;      /* Path to the object server ie. /etc/bin/xx.so */
	void          *cfData;         /* client data */
	ClassFactory  InterfaceProc;   /* Create an instance */
} NSInterface;


extern NSObjArray *NSOrb;   /* An array of registered interfaces */

NSAPI_PUBLIC long NSORB_InstanceID( long guid, char *objName );
NSAPI_PUBLIC IBase *NSORB_GetInterface( long guid );
NSAPI_PUBLIC int NSORB_RegisterInterface( long guid, short serverType, char *objName, char *objServer, ClassFactory InterfaceProc, void *cfData  );
NSAPI_PUBLIC int NSORB_Init();
NSAPI_PUBLIC IBase *NSORB_FindObject( long guid, long objID ); 
#ifdef __cplusplus
NSAPI_PUBLIC IBase *NSORB_GetInstance( long guid, char *objName, void *transaction = (void *)NULL );
#else
NSAPI_PUBLIC IBase *NSORB_GetInstance( long guid, char *objName, void *transaction);
#endif

NSPR_END_EXTERN_C

#endif /* _H_ORB */
