/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef _H_CONSUMER
#define _H_CONSUMER

#include "netsite.h"

NSPR_BEGIN_EXTERN_C

typedef struct _t_PushConsumer *PushConsumer;
typedef long (*NotifyProc)(short msdID, long objID, void *supplierData, void *consumerData );
typedef long (*MD_DeleteProc)(void *consumerData, long guid, short msdID, long objid, void *supplierData );



NSAPI_PUBLIC PushConsumer ConsumerNewPush( short msgID );
NSAPI_PUBLIC int ConsumerSetPushObj( PushConsumer pc, long objID );
NSAPI_PUBLIC long ConsumerGetPushObj( PushConsumer pc );
NSAPI_PUBLIC int ConsumerSetPushData( PushConsumer pc, void *consumerData );
NSAPI_PUBLIC void *ConsumerGetPushData( PushConsumer pc );
NSAPI_PUBLIC int ConsumerSetPushNotifyProc( PushConsumer pc, NotifyProc PushNotify );
NSAPI_PUBLIC short ConsumerGetPushMsg( PushConsumer pc );
NSAPI_PUBLIC int ConsumerDisconnectPush( PushConsumer pc );
NSAPI_PUBLIC PushConsumer ConsumerCreatePush( short msgID, long guid, long objID, 
							  void *consumerData, NotifyProc PushNotify, 
							  MD_DeleteProc PushDelete );

NSAPI_PUBLIC int ConsumerConnectPush( PushConsumer pc );
NSAPI_PUBLIC int ConsumerDeleteResPush(  char *res, short msgID );


NSPR_END_EXTERN_C

#endif /* _H_CONSUMER */


