/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef _TIMER_LIST_H
#define _TIMER_LIST_H


typedef struct _t_TriggerInfoStruct 
{
  unsigned long timeToTrigger;
  long (*fnToCall) (short msdID, long objID,
                void *supplierData, void *consumerData );
  void* clntData;
  struct _t_TriggerInfoStruct* next;
} TriggerInfoStruct;

typedef struct {
  TriggerInfoStruct *_head;
} _timerList;

typedef _timerList* TIMERLIST ;

#define NOT_FOUND          -2
#define TIMERLIST_SUCCESS   0

TIMERLIST TimerListInit();
void TimerListDelete(TIMERLIST me);
TriggerInfoStruct* TimerListFirst(TIMERLIST me);
void TimerListInsertInOrder(TIMERLIST me, TriggerInfoStruct *newNode);
int  TimerListDeleteElementGivenTriggerTime(TIMERLIST me, time_t secs);
TriggerInfoStruct* TimerListGet(TIMERLIST me);
void  TimerListPrintList(TIMERLIST me);
int  TimerListIsEmpty(TIMERLIST me);
size_t TimerListEntries(TIMERLIST me);

#endif 
