/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef TIMERSERVICEPROVIDER_H
#define TIMERSERVICEPROVIDER_H
#include <time.h>
#include <base/systhr.h>
#include <base/crit.h>
//#include <libmsgdisp/msgchnel.h>
#include <libmsgdisp/timer_list.h>
#include <prio.h>
#ifdef XP_WIN32
#include <io.h>
#endif

#define TIMER_FAILURE 0
#define TIMER_SUCCESS 1
#define TIMER_DELTA_FAILED 2
#define	TIMER_INVALID_TIME 3
#define	TIMER_WRITE_EVENT_FAILED 4
#define TIMER_DATA_NOT_FOUND 5

typedef struct {
  int        _gResultCopy;
  TIMERLIST  _list;
  int        _valid;
  int        _terminate;
  time_t     _minDelta;
  SYS_THREAD _myTimerThread;
  CRITICAL   _crit1;
  CRITICAL   _critPC;
  CONDVAR    _dataAvailable;
  CONDVAR    _dataConsumed;
  CONDVAR    _threadKilled;
  int 	     _gResult;
  time_t     _timeToTrigger;
  long (*_fptr)(short, long, void*, void*);
  void*  _clntData;
} _timerServiceProvider;

typedef _timerServiceProvider* TIMERSERVICEPROVIDER;

NSAPI_PUBLIC TIMERSERVICEPROVIDER TimerServiceProviderInit(time_t minDelta);
NSAPI_PUBLIC void TimerServiceProviderDelete(TIMERSERVICEPROVIDER me);
NSAPI_PUBLIC int TimerServiceProviderIsValid(TIMERSERVICEPROVIDER me); 
NSAPI_PUBLIC int TimerServiceProviderAddTimeObject(TIMERSERVICEPROVIDER me,
                        time_t timeToTrigger,
                        long (*fnPtr)(short msdID, long objID,
                                      void *supplierData, void *consumerData ),
                         void* clntData);

NSAPI_PUBLIC void TimerServiceProviderTimeOutHandler(TIMERSERVICEPROVIDER me);



#endif /* TIMERSERVICEPROVIDER_H */
