/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef nsliterl_h
#define nsliterl_h

/***********************************************************************
** Literal Defines
***********************************************************************/
#define ASCII          "ascii"
#define HTML           "html"  
#define DIALOGB        "dialogb"  
#define ACTIVE         "active"  
#define FILEFORMAT     "file_format"  
#define NSLOADER       "nsloader"  
#define NSRTAGENT      "nsrtagent"
#define IDXTYPE        "idx_type"  
#define DBLIST         "dblist_ini"  
#define DEBUGLEVEL     "debug_level"  
#define ROOTPATH       "root_path"  
#define DOCPATH        "doc_path"  
#define IDXPATH        "idx_path"  
#define LOGTARGET      "log_target"  
#define SEQUENCENO     "sequence_no"  
#define VDKHOME        "cfg_path"  
#define BULKINSERT     "bulk_insert"  
#define DELETEFILE     "delete_file"  
#define CONTROLFILE    "cntl_file"  
#define ATTRCOUNT      "attr_count"
#define PUBCOUNT       "pub_count"
#define BTROOT         "brtree_root"
#define BTROOTDOC      "brtee_rootdoc"
#define STATUS         "status"  
#define MSRVINIFILE    "dbproxy_ini"  
#define MSRVSECTION    "dbproxy/client"  
#define MSRVHOST       "NS-ms-host"  
#define MSRVPORT       "NS-ms-port"  
#define TOCSTART       "NS-tocstart-pat"  
#define TOCREC         "NS-tocrec-pat"  
#define TOCEND         "NS-tocend-pat"  
#define RECORD         "NS-doc-pat"  
#define FRAMETOCSTART  "NS-frame-tocstart-pat"  
#define FRAMETOCREC    "NS-frame-tocrec-pat"  
#define FRAMETOCEND    "NS-frame-tocend-pat"  
#define FRAMERECORD    "NS-frame-doc-pat"  
#define ADVTOCSTART    "NS-adv-tocstart-pat"  
#define FRAMEADVTOCSTART  "NS-frame-adv-tocstart-pat"  
#define NSQUERY        "nsquery"  
#define NSRECORD       "nsrecord"  
#define TARGET         "target"  
#define IRSINIFILE     "NS-irs-file"  
#define ATTRIBUTEPATH  "attr_file" 
#define STDOUT         "stdout" 
#define CONSOLE        "console" 
#define DEVNULL        "devnull"
#define NOTAVAILABLE   "notavailable"
#define PIDFILE        "pid_file"
#define ENGINETYPE     "engine_type"
#define PORT           "port"
#define IPADDRESS      "ip_address"
#define DBLISTINI      "dblist_ini"
#define RTAGENTINI     "rtagent_ini"
#define VERITY         "verity"
#define PLS            "pls"
#define GENERAL        "general"
#define NSLAPI         "nslapi"
#define SHAREDIDX      "shared"
#define UNSHAREDIDX    "unshared"
#define PUBDOC         "doc"
#define IDX            "idx"
#define NNTP           "nntp"
#define TAGFILE        "tag_file"
#define DOCDIR         "doc_dir"
#define DOCPREFIX      "doc_prfx"
#define DOCSUFFIX      "doc_sfx"
#define LIBPATH        "lib_path"
#define META           "meta"
#define BROWSETREE     "browsetree"
#define PATTERNFILE    "pattern_file"
#define TAGOFFSET      "tag_offset"
#define TAGLEN         "tag_len"
#define STAGEINTERVAL  "stage_interval"
#define PROCESSCOUNT   "process_count"
#define PROCESS        "process"
#define PROCESSINTVL   "interval"
#define SECTION        "section"
#define STAGERINI      "stager_ini"
#define NSSTAGER       "nsstager"
#define EXPINTERVAL    "exp_interval"
#define UPDATEFILE     "update_file"
#define PUBNAME        "pub_name"
#define PUBDESC        "pub_desc"
#define LOCALTAGFILE   "local_tag_file"
#define GLOBALTAGFILE  "global_tag_file"
#define UIDIR          "NS-ui-dir"
#define HEADERPATTERN  "NS-bt-header"
#define BODYPATTERN    "NS-bt-body"
#define TRAILERPATTERN "NS-bt-trailer"
#define HISTORYPATTERN "NS-bt-history"
#define DOCPATTERN     "NS-bt-doc"
#define FRAMEPATTERN   "NS-bt-frame"
#define BRTREEINI      "NS-bt-ini"
#define SEARCHSET      "NS-searchset-dir"
#define ROOTHEADERPATTERN  "NS-btroot-header"
#define ROOTBODYPATTERN    "NS-btroot-body"
#define ROOTTRAILERPATTERN "NS-btroot-trailer"
#define TARGETDIR      "target_dir"
#define DESC           "desc"
#define LASTSTAT       "last_stat"
#define PROFILER       "profiler"
#define VALUE          "value"
#define TAG            "tag"
#define URLROOT        "url_root" /* old 1.0 name */
#define DOCROOT        "doc_root" /* old 1.0 name */
#define SRCCOUNT       "src_count"
#define SRCNAME	       "src_name"
#define SRCPATH	       "src_path"
#define SRCURL	       "src_url"
#define SRCNAME	       "src_name"
#define SRCTEMPLATE    "src_template"
#define SRCRECURSE     "src_recurse"
#define SRCPRESERVE    "src_preserve"
#define ENGDEBUG       "eng_debug"
#define TTYCOUNT       "tty_count"
#define TTYPARITY      "tty_parity"
#define TTYBAUDRATE    "tty_baudrate"
#define TTYSTOPBITS    "tty_stopbits"
#define DEVICETYPE     "device_type"
#define DEVICENAME     "device_name"
#define DEVICEFILE     "file"
#define DEVICETTY      "tty"
#define RTAGENTCOUNT   "rtagent_count"
#define TAGMODULE      "tag_module_name"
#define FMTMODULE      "fmt_module_name"
#define SLUG           "slug"
#define PROCESSTYPE    "process_type"
#define PERL           "perl"
#define HDRMODULE      "hdr_module_name"
#define DELETEANPA     "delete_anpa"
#define DUMPDEVICE     "dump_device"
#define CONVERTLIB     "convert_lib"
#define CONVERTTARGET  "convert_target"
#define GSSERVER       "gsserver"
#define CLIENTPORT     "client_port"
#define ADMINPORT      "admin_port"
#define SERVICELEVEL   "service_level"
#define HOSTNAME       "host_name"
#define TEMPLATE	"template"
#define RECURSE		"recurse"
#define INDEX_IN_PLACE	"index_in_place"
#define PRESERVE_DIRECTORY	"preserve_directory"
#define THREADMODEL    "thread_model"
#define DELETEROOT     "delete_root"
#define LANGUAGE       "language"

#define RC0_CREATEDB   "<SR><SI>102</SI><RC>0</RC></SR>"
#define RC0_UPDATEDB   "<SR><SI>104</SI><RC>0</RC></SR>"
#define RC0_DELETEDO   "<SR><SI>110</SI><RC>0</RC></SR>"
#define RC1_DELETEDO   "<SR><SI>110</SI><RC>1</RC></SR>"
#define RC0_DELETEDB   "<SR><SI>108</SI><RC>0</RC></SR>"
#define RC0_OPTIMIZEDB "<SR><SI>112</SI><RC>0</RC></SR>"
#define RC0_SHUTDOWN   "<SR><SI>204</SI><RC>0</RC></SR>"
#define RC0_EDITATTR   "<SR><SI>106</SI><RC>0</RC></SR>"
#define RC0_EDITDSLIST "<SR><SI>114</SI><RC>0</RC></SR>"
#define RC1_MSG01      "Error: reference log for message"
#define BC_MSG         "<BC></BC>"
#define EC_MSG         "<EC></EC>"
#define STARTLOG       "<SR><BL></BL></SR>"
#define ENDLOG         "<SR><EL></EL></SR>"

#define PN             "PN"	/* Publication Name */
#define PD             "PD"	/* Publication Description */
#define SI             "SI"	/* Service Identifier */
#define ET             "ET"	/* Engine Type */
#define PP             "PP"	/* Publication Path */
#define FF             "FF"	/* File Format */
#define P0             "P0"	/* Pattern 0 -- TOCSTART */
#define P1             "P1"	/* Pattern 1 -- TOCREC */
#define P2             "P2"	/* Pattern 2 -- TOCEND */
#define P3             "P3"	/* Pattern 3 -- RECORD */
#define P4             "P4"	/* Pattern 4 -- FRAMETOCSTART */
#define P5             "P5"	/* Pattern 5 -- FRAMETOCREC */
#define P6             "P6"	/* Pattern 6 -- FRAMETOCEND */
#define P7             "P7"	/* Pattern 7 -- FRAMERECORD */
#define P8             "P8"	/* Pattern 8 -- ADVTOCSTART */
#define P9             "P9"	/* Pattern 9 -- FRAMEADVTOCSTART */
#define IX             "IX"	/* existing IndeX */
#define FN             "FN"	/* File Name */
#define DP             "DP"	/* source Document Path */
#define CF             "CF"	/* Control File */
#define EF             "EF"	/* Erase control File */
#define NC             "NC"	/* No Copy */
#define WA             "WA"	/* WAit */
#define AN             "AN"	/* Attribute Name */
#define DI             "DI"	/* Document Identifier */
#define SL             "SL"	/* Start Log */
#define NL             "NL"	/* No Log */
#define AR             "AR"	/* Attribute wRapper */
#define AD             "AD"	/* Attribute Description */
#define RD             "RD"	/* Recurse from root Directory */
#define AV             "AV"	/* Attribute Value */
#define AT             "AT"	/* Attribute Tag */
#define AH             "AH"	/* Attribute Header */
#define AB             "AB"	/* Attribute Body */
#define DF             "DF"	/* Documents Found */
#define T0             "T0"	/* Old 1.0 Tag for URLROOT -- do not use */
#define T1             "T1"	/* Old 1.0 Tag for DOCROOT -- do not use */
#define RS             "RS"	/* Replicate Source directory */
#define DR	       "DR"	/* Document source wRapper */
#define UR	       "UR"	/* URL */
#define DN	       "DN"	/* Document source Name */
#define HS             "HS"	/* HiStory pattern file */
#define IF             "IF"	/* Import Format */
#define CT             "CT"	/* Convert Target */
#define SN	       "SN"	/* Server Name */
#define RM	       "RM"	/* ReMove */
#define DO             "DO"	/* Document Offset */
#define LA	       "LA"	/* LAnguage */

#ifdef UNUSED_TAGS
#define NW             "NW"	/* No Wait ?? */
#define WL             "WL"	/* ?? */
#define WT             "WT"	/* ?? */
#endif

#define UNKNOWN        "unknown"

#endif /* nsliterl_h */
