/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef __NSLOCKF_H
#define __NSLOCKF_H 1

#include "prio.h"
#include "private/pprio.h"
#include "prsystem.h"
#include "string.h"
#ifdef _WINDOWS
#include <strstrea.h>
#else
#include <strstream.h>
#include <sys/types.h>
#include <unistd.h>
#endif

class NSlockfile {
public:
   NSlockfile(const char* lockfilename = 0);    
  ~NSlockfile();

   int    Init(const char* lockfilename, const char* msg=0);
   int    Good() {return(_initialized == 1);}
   int    Bad() {return(!Good());}

private:
   int         _initialized;
   char        _fname[512];
   PRFileDesc* _fd;
   };

inline
NSlockfile::NSlockfile(const char* filename) 
:  _initialized(0) {
   _fname[0] = '\0';
   if (filename)
      Init(filename);
   }

inline
NSlockfile::~NSlockfile() {
   if (_fname[0] != '\0') {
      PR_Delete(_fname);
      }
   }


#endif
