/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef nsmisc_h
#define nsmisc_h

/***********************************************************************
** Includes
***********************************************************************/
#include "nscore.h"
#include "nsavpair.h"


/***********************************************************************
** Global Functions and Typedefs
***********************************************************************/
typedef NSbool  (*CGIparseCB)(CStr attr, CStr val, NSavpair& opts);

// concatenate paths cleanly
extern
void  ns_catpath(NSbool  slashterm, char *dstp, ...);

// Convert special characters in a string into valid CGI escape chars
extern 
void CGIescape(Str arg, ostream& o);

// parse a delimited CGI string (e.g. '=' and '&') into the AV pair object
extern 
NSbool  CGIparse(Str args, NSavpair&, char delim='&', CGIparseCB=0);


// Convert escaped characters in a CGI string back into the valid chars
extern 
void CGIunescape(Str val);


// Do a hexadecimal dump of a buffer
extern 
void Hexdump(ostream& o, PGen buf, s32 len);


// remove trailing blanks from a string. This procedure overwrites the
// string, so that it should not be called on a string you want to keep
// whole.
extern 
Str RTrim(Str);


// translate one character to another in a string
extern 
void Translate(Str src, char from, char to);


#endif /* nsmisc_h */
