/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef NS_SNMP_CONF_H
#define NS_SNMP_CONF_H

#include <sys/types.h>
#include <time.h>


typedef struct _SubagtConfig {

/* id */
    char * root;	/* which server is this for */

/* from magnus.conf */
    char * snmp_host;
    char * snmp_addr;	/* IP address to bind to */
    int    snmp_port;
    int    snmp_secure;
    int    snmp_max_procs;
    int    snmp_min_procs;
    int    snmp_max_threads;
    int    snmp_min_threads;

/* from snmp.conf */
    char * snmp_master_host;
    int    snmp_index;
    char * snmp_description;
    char * snmp_organization;
    char * snmp_location;
    char * snmp_contact;

/* also from snmp.conf */
    int    snmp_on;
    char * snmp_poll_url;
    time_t snmp_poll_timeout;
    time_t snmp_poll_interval;

} SubagtConfig;


/*
 * Loads SNMP subagent configuration (both magnus.conf and snmp.conf).
 *
 * Returns the config struct, or NULL on error, in which case sets
 * *err to point to the error message.
 *
 */
SubagtConfig *subagt_conf_load(char *root, char **err);

#endif

