/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * httpif.h - interface to http entity
 *
 * George Dong - 12/04/95
 *
 */

#ifndef HTTPIF
#define HTTPIF

#include "httpagt.h"

/*
 * these are prototypes for each mib we support 
 *    input: a pointer to struct httprow
 *    function: change values in httprow structure
 *    return code:  zero - no error
 *                  non-zero - error 
 */


/* index */
int GetEntityIndex(struct httpEntity *);

/* description */
int GetEntityDescr(struct httpEntity *);

/* object identifier */
int GetEntityObjId(struct httpEntity *);

/* protocol */
int GetEntityProtocol(struct httpEntity *);

/* version */
int GetEntityVersion(struct httpEntity *);

/* organization */
int GetEntityOrg(struct httpEntity *);

/* location */
int GetEntityLoc(struct httpEntity *);

/* contact */
int GetEntityContact(struct httpEntity *);

/* physical address */
int GetEntityAddr(struct httpEntity *);

/* port */
int GetEntityPort(struct httpEntity *);

/* Name */
int GetEntityName(struct httpEntity *);

/* type */
int GetEntityType(struct httpEntity *);

/* support method */
int GetEntityMethods(struct httpEntity *);

int GetEntityMacProc(struct httpEntity *);
int GetEntityMinProc(struct httpEntity *);
int GetEntityMaxThread(struct httpEntity *);
int GetEntityMinThread(struct httpEntity *);

int    GetStatisIndex(struct httpStatistics *);
int    GetStatisStatus(struct httpStatistics *);
int    GetStatisUptime(struct httpStatistics *);
int    GetStatisNumPIdle(struct httpStatistics *);
int    GetStatisNumPProc(struct httpStatistics *);
int    GetStatisNumPDns(struct httpStatistics *);
int    GetStatisRequests(struct httpStatistics *);
int    GetStatisRequestErr(struct httpStatistics *);
int    GetStatisNumProc(struct httpStatistics *);
int    GetStatisNumThread(struct httpStatistics *);

#endif
