/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * log.h: Records transactions, reports errors to administrators, etc.
 * 
 * Rob McCool
 */


#ifndef LOG_H
#define LOG_H


#include "nsapi20/netsite.h"
#include "nsapi20/base/session.h"   /* Session structure */
#include "nsapi20/frame/req.h"      /* Request struct */
#include "nsapi20/base/ereport.h"   /* Error reporting, degrees */


#define ERROR_CUTOFF 128


/* ------------------------------ Prototypes ------------------------------ */


/*
 * log_error logs an error of the given degree from the function func
 * and formats the arguments with the printf() style fmt. Returns whether the
 * log was successful. Records the current date.
 *
 * sn and rq are optional parameters. If given, information about the client
 * will be reported.
 */

NSAPI_PUBLIC int log_error(int degree, char *func, Session *sn, Request *rq, 
                           char *fmt, ...);

/*
 *  Internal use only 
 */
NSAPI_PUBLIC int log_ereport(int degree, char *fmt, ...);

#endif
