/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
//--------------------------------------------------------------------------//
//                                                                          //
//  Name: magnus.h                                                          //
//	Platforms: WIN32                                                        //
//  ......................................................................  //
//  This file contains the declarations of the server initialization        //
//  and control functions.                                                  //
//  ......................................................................  //
//  Revision History:                                                       //
//  01-12-95  Initial Version, Aruna Victor (aruna@netscape.com)            //
//  12-30-96  3.0 registry changes, cleanup, Andy Hakim (ahakim)            // 
//--------------------------------------------------------------------------//



//--------------------------------------------------------------------------//
// macros                                                                   //
//--------------------------------------------------------------------------//
#define CLOSEHANDLE(X) \
{ \
	if(X) \
	{ \
		CloseHandle(X); \
		X = 0; \
	} \
}


//--------------------------------------------------------------------------//
// function prototypes                                                      //
//--------------------------------------------------------------------------//

// functions in ntinit.c 
BOOL InitializeService();

// functions in ntmagnus.c 
NSAPI_PUBLIC int magnus_init();
NSAPI_PUBLIC void magnus_restart(int fs);
NSAPI_PUBLIC int threads_init();
NSAPI_PUBLIC VOID SuspendHttpdService();

