/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * Default directive declarations
 */

#ifndef _AUTH_H
#define _AUTH_H

#include "frame/func.h"
#include <base/plist.h>
#include <libaccess/nserror.h>
#include <libaccess/las.h>

NSPR_BEGIN_EXTERN_C

void auth_init_crits(void);

Func auth_basic;
Func auth_basic1;
Func dbm_user;
Func simple_user;
Func simple_group;

extern int parse_basic_user_login (const char *user_login, char **user,
				   char **password);

extern int get_user_login_basic (NSErr_t *errp, PList_t subject,
				 PList_t resource, PList_t auth_info,
				 PList_t global_auth, void *arg);
extern int get_auth_user_basic (NSErr_t *errp, PList_t subject, 
				PList_t resource, PList_t auth_info,
				PList_t global_auth, void *arg);
extern int get_authorization_basic (NSErr_t *errp, PList_t subject, 
				    PList_t resource, PList_t auth_info,
				    PList_t global_auth, void *arg);

#if defined(CLIENT_AUTH)
extern int auth_get_sslid(pblock *param, Session *sn, Request *rq);
#endif /* defined(CLIENT_AUTH) */

NSPR_END_EXTERN_C

#endif /* _AUTH_H */
