/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * Default directive declarations
 */

#ifndef _CGI_H
#define _CGI_H

#include "frame/func.h"

NSPR_BEGIN_EXTERN_C

typedef struct _cgi_info {
    pid_t pid;
    Session *sn;
    Request *rq;
    struct _cgi_info *next;
} cgi_info;

void add_poll_desc(PRFileDesc *fd, PRPollDesc **poll_desc);
void remove_poll_desc(PRFileDesc *fd, PRPollDesc **poll_desc);
void clear_poll_desc(PRPollDesc *poll_desc);
int exists_poll_desc(PRFileDesc *fd, PRPollDesc *poll_desc);

void cgiwatch_add_client(Session *sn, Request *rq, pid_t pid);
void cgiwatch_remove_client(Session *sn, Request *rq, pid_t pid);
void cgiwatch_internal_init(void);
#ifdef XP_UNIX
void cgi_grabstds(void);
#endif
char **cgi_common_vars(Session *sn, Request *rq, char **env);

Func cgi_init;
Func cgi_send;
#ifdef XP_WIN32
Func wincgi_send;
Func shellcgi_send;
#endif /* XP_WIN32 */
#ifdef FORTEZZA
Func service_preencrypted;
#endif
Func cgi_query;

NSPR_END_EXTERN_C

/* MLM - admin server / libadmin need to define some strings */
#define ADM_NO_VALUE_STRING "NS-value-is-null"
#define ADM_USER_STRING "User: "
#define ADM_PASS_STRING "Password: "
#define ADM_AUTH_STRING "Authorization: "
#define ADM_USERDN_STRING "UserDN: "
#define ADM_SIEPWD_STRING "SIEPWD: "

#ifdef FORTEZZA
#define ADM_PIN_STRING "Pin: "
#endif /* FORTEZZA */

#endif /* _CGI_H */
