/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#ifndef SAFS_INIT_H
#define SAFS_INIT_H

#include <base/pool.h>
#include <base/pblock.h>
#include <base/session.h>
#include <libaccess/nserror.h>
#include <libaccess/las.h>
#include <frame/req.h>

#define ACL_ATTR_POSITION	    "position"

#define ACL_AUTHTYPE_BASIC	    "basic"
#define ACL_AUTHTYPE_SSL	    "ssl"


NSPR_BEGIN_EXTERN_C

extern int register_attribute_getter(pblock *pb, Session *sn, Request *rq);
extern int register_method(pblock *pb, Session *sn, Request *rq);
extern int register_module(pblock *pb, Session *sn, Request *rq);

extern int register_database_type(pblock *pb, Session *sn, Request *rq);
extern int register_database_name(pblock *pb, Session *sn, Request *rq);

extern int set_default_method (pblock *pb, Session *sn, Request *rq);
extern int set_default_database (pblock *pb, Session *sn, Request *rq);

extern int init_acl_modules(NSErr_t *errp);

extern ACLMethod_t ACL_MethodBasic;
extern ACLMethod_t ACL_MethodSSL;

NSPR_END_EXTERN_C


#endif /* SAFS_INIT_H */

