/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/* 
 * Generate a  avaedit screen to handle the GrpupOfcertificates
 */

#include "dsgw.h"
#include "dbtdsgw.h"

void send_form(char *header, char *edn, int addmembeR, int addObjectclass);

main(argc, argv, env )
	int 	argc;
	char	*argv[];
#ifdef DSGW_DEBUG
	char	*env[];
#endif
{
    char	*qs, *dn, *s, *p;
    char	*attrdesc = NULL;
    char	*s_head = NULL;
    char 	*header = NULL;
    char        *m = getenv("REQUEST_METHOD");
    int		addmember = 0;
    int		addObjectclass = 0;

    (void)dsgw_init( argc, argv, DSGW_METHOD_GET );
    dsgw_send_header();

#ifdef DSGW_DEBUG
   dsgw_logstringarray( "env", env );
#endif

    /*
     * The URL used to invoke this CGI looks like:
     *  If we are adding a new member
     *      http://host/avaedit/DN?TEMPLATE=tmplname&ATTR=attrname&DESC=description
     *      where description is "Add GroupofCertificate"  when a new memeber is
     *	    is being added the first time and "Modify GroupofCertificate" otherwise"
     *
     *  else we are changing/deleteing an old member
     *      http://host/avaedit/EntryDN/membercertificatedescription
     *
     */

    if (( dn = getenv( "PATH_INFO" )) == NULL ) {
	dsgw_error( DSGW_ERR_MISSINGINPUT, NULL, DSGW_ERROPT_EXIT, 0 );
    }

    if ( *dn == '/' ) {
	++dn;   /* skip past leading slash */
    }	


    if (( qs = getenv( "QUERY_STRING" )) != NULL ) {

	addmember = 1;
    	s_head = header = strdup( dn );
    	if ((s = strstr(header, "cn")) != NULL) {
		char	*t = NULL;;
		while (*s && *s != '=') s++;
		s++;
		while (*s && *s == ' ') s++;
		header = s;
		/* remove the suffix, if we have them */
		t = strchr(s, ',');
		if (t) *t = '\0';
    	} else {
		dsgw_error( DSGW_ERR_MISSINGINPUT, "dn", DSGW_ERROPT_EXIT, 0 );
	} 
	
    	/* Get attribute description */
    	if (( p = strrchr( qs, '&' )) == NULL ) {
		dsgw_error( DSGW_ERR_MISSINGINPUT, "desc" , DSGW_ERROPT_EXIT, 0 );
    	}
    	*p++ = '\0';
    	if (strncasecmp( p, "desc=", 5 )) {
		dsgw_error( DSGW_ERR_MISSINGINPUT, "desc", DSGW_ERROPT_EXIT, 0 );
    	}
    	attrdesc = dsgw_ch_strdup( p + 5 );

	addObjectclass = 1;
	if (strncmp(attrdesc, "Modify", 5) == 0)
		addObjectclass= 0;
    
    }

    send_form(header, dn, addmember, addObjectclass);
    if (s_head)	free(s_head);

}

struct avainfo {
	char	*o_val;
	char	*ou_vals[10];
	int	num_ou;
	char	*cn_val;
	char	*mail_val;
	char	*st_val;
	char	*l_val;
	char	*c_val;
};

void
extract_vals_from_dn(char *edn, struct avainfo *ava_info)
{
	char	*val, *val2;
	char	**xdn1, **xdn2;
	char	*s_dn = NULL;
	char	*dn = NULL;
	char	*dn2 = NULL;
	char	*s_dn2 = NULL;
	int	len, i;
	int	numval;

	/* get the dn values */
	while (*edn && *edn == ' ') edn++;
	s_dn = dn = strdup (edn);
	xdn1 = ldap_explode_dn( dn, 1 );

	/* get the left side of "=" values in a bad way */
	s_dn2 = dn2 = strdup (s_dn);
	len = strlen (s_dn) -1;
	while (len >=0 ) {
	   *dn2 = *(s_dn+len);
	   len--;
	   dn2++;
	}
	xdn2 = ldap_explode_dn( s_dn2, 1 );

	i = 0;
	numval = 0;
	while (xdn1[numval]) {
		numval++;
	}
	if (numval > 0) numval--;

	while (xdn1[i]) {
		val = xdn2[i];
		while (*val && *val == ' ') val++;
		val2 = xdn1[numval-i];
		while (*val2 && *val2 == ' ') val2++;
		if (strncmp(val, "o", 1) == 0) {
			ava_info->o_val = strdup (val2);
		} else if (strncmp(val, "uo", 2) == 0) {
			ava_info->ou_vals[ava_info->num_ou++] = 
						strdup (val2);
		} else if (strncmp(val, "liam", 4) == 0) {
			ava_info->mail_val = strdup (val2);
		} else if (strncmp(val, "l", 1) == 0) {
			ava_info->l_val = strdup (val2);
		} else if (strncmp(val, "nc", 2) == 0) {
			ava_info->cn_val = strdup (val2);
		} else if (strncmp(val, "c", 1) == 0) {
			if (ava_info->c_val == NULL)
				ava_info->c_val = strdup (val2);
		} else if (strncmp(val, "ts", 2) == 0) {
			ava_info->st_val = strdup (val2);
		} else if (strncmp(val, "liam", 4) == 0) {
			ava_info->mail_val = strdup (val2);
		}
		
		i++;
	}
		
	ldap_value_free( xdn1 );
	ldap_value_free( xdn2 );
	if (s_dn) free (s_dn);
	if (s_dn2) free (s_dn2);
}

void
free_avainfo( struct avainfo *a)
{
	int	i;

	if ( a->o_val) free (a->o_val);
	if ( a->cn_val) free (a->cn_val);
	if ( a->mail_val) free (a->mail_val);
	if ( a->st_val) free (a->st_val);
	if ( a->l_val) free (a->l_val);
	if ( a->c_val) free (a->c_val);
	for (i=0; i <= a->num_ou; i++)
		if (a->ou_vals[i]) free (a->ou_vals[i]);

}
void
send_form( char *header, char *dn, int addMember, int addObjectclass)
{

	struct avainfo 	ava;
	int		i;
	char		*entrydn = NULL;
	char		*edn= NULL;
	char		*prevmember = NULL;
	char		*ufn = NULL;


	memset (&ava, 0, sizeof (struct avainfo));
 	if (!addMember) {
		char	*s, *t;
		/* The DN consists of the ENTRY DN and the URL of the member */
		s = strchr (dn, '/');
		t = ++s;
		s = strchr (s, '/');
		dn = s;
		dn++;
		*s = '\0';
		entrydn = strdup (t);
		
		/* Then we need to extract the various pieces */
		extract_vals_from_dn(dn, &ava);
		edn = dsgw_strdup_escaped( entrydn );
		prevmember = dn;
		while (*prevmember && *prevmember == ' ') prevmember++;
	} else {
		 edn = dsgw_strdup_escaped( dn );
	}
	if (header)
		ufn = ldap_dn2ufn(header);
	else if (dn)
		ufn = ldap_dn2ufn(dn);

    	/* Send the top-level document HTML */
	fputs(  "<HTML>\n"
		"<SCRIPT LANGUAGE=\"JavaScript\">\n", stdout );
	fputs (
		"   var cn = \"\";\n"
		"   var email = \"\";\n"
		"   var org = \"\";\n"
		"   var orgu = \"\";\n"
		"   var local = \"\";\n"
		"   var state = \"\";\n"
		"   var country = \"\";\n",
		stdout);

	fputs(
		"function avaChg(val)"
		"{"
		"	if (val== 1) {"
		"	  document.avaform.elements['rep_cn'].checked = \"true\";\n"
		"	  cn = document.avaform.elements['rep_cn'].value;\n"
		"	} else if (val == 2) {"
		"	  document.avaform.elements['rep_email'].checked = \"true\";\n"
		"	  email = document.avaform.elements['rep_email'].value;\n"
		"	} else if (val == 3) {"
		"	  document.avaform.elements['rep_org'].checked = \"true\";\n"
		"	  org = document.avaform.elements['rep_org'].value;\n"
		"	} else if (val == 4) {"
		"	  document.avaform.elements['rep_orgu'].checked = \"true\";\n"
		"	  orgu = document.avaform.elements['rep_orgu'].value;\n"
		"	} else if (val == 5) {"
		"	  document.avaform.elements['rep_local'].checked = \"true\";\n"
		"	  local = document.avaform.elements['rep_local'].value;\n"
		"	} else if (val == 6) {"
		"	  document.avaform.elements['rep_state'].checked = \"true\";\n"
		"	  state = document.avaform.elements['rep_state'].value;\n"
		"	} else if (val == 7) {"
		"	  document.avaform.elements['rep_country'].checked = \"true\";\n"
		"	  country = document.avaform.elements['rep_country'].value;\n"
		"       }"
		"}\n",
		stdout);

	fputs (
		"function avaDelete ()"
		" {"
		       "document.avasubmit.submit();\n"
		"}\n",
		stdout);	



	/* SUBMIT function */
	/* PKB: multiple OU's */
	fputs (
		"function avaSubmit() "
		"{"
		"   var tcn = \"\";\n"
		"   var temail = \"\";\n"
		"   var torg = \"\";\n"
		"   var torgu = \"\";\n"
		"   var tlocal = \"\";\n"
		"   var tstate = \"\";\n"
		"   var tcountry = \"\";\n"
		"\n"
		"   if (cn )  tcn = \"cn = \" + cn + \", \";\n"
		"   if (email )  temail = \"email = \" + email+ \", \";\n"
		"   else tcn = cn;\n"
		"   if (org )  torg = \"o = \" + org + \", \";\n"
		"   if (orgu ) {\n"
			"while ((cut = orgu.indexOf ('\\n')) >0) {\n"
			"    torgu = torgu + \"ou = \" + orgu.substring(0,cut) + \", \";\n"
			"    orgu = orgu.substring(cut+1, orgu.length);\n"
			" }\n"
			"if (orgu) torgu = torgu + \"ou = \" + orgu +\",\";\n"
		"}\n"
		"   if (local )  tlocal = \"l = \" + local + \", \";\n"
		"   if (state )  tstate = \"st = \" + state + \", \";\n"
		"   if (country )  tcountry = \"c = \" + country ;\n"
		"   var output = \"{\" + tcn + temail + torg + torgu + tlocal+ tstate+ tcountry\n"
		"var len = output.length;\n"
		"var str1 = output.substring (len-2, len);\n"
		"  if (str1.indexOf(\",\") >= 0) {"
		"    output = output.substring(0,len-2);\n"
		" }\n"
		"\n"
		"document.avasubmit.add_memberCertificateDescription.value = output;\n"
		"document.avasubmit.submit();\n"
		"}\n",
		stdout);

	if (!addMember ) {
	   fprintf ( stdout, 
		"function ava_init() "
		" {"
		"	document.avaform.elements['rep_cn'].checked=\"%s\";"
		"	document.avaform.elements['rep_email'].checked=\"%s\";"
		"	document.avaform.elements['rep_org'].checked=\"%s\";"
		"	document.avaform.elements['rep_orgu'].checked=\"%s\";"
		"	document.avaform.elements['rep_local'].checked=\"%s\";"
		"	document.avaform.elements['rep_state'].checked=\"%s\";"
		"	document.avaform.elements['rep_country'].checked=\"%s\";"
		"\n",
		ava.cn_val? "true":"false",
		ava.mail_val? "true":"false",
		ava.o_val? "true":"false",
		ava.num_ou? "true":"false",
		ava.l_val? "true":"false",
		ava.st_val? "true":"false",
		ava.c_val? "true":"false"
	       );  
	      fputs (
		"   cn = document.avaform.elements['rep_cn'].value;\n"
		"   email = document.avaform.elements['rep_email'].value;\n"
		"   org = document.avaform.elements['rep_org'].value;\n"
		"   orgu = document.avaform.elements['rep_orgu'].value;\n"
		"   local = document.avaform.elements['rep_local'].value;\n"
		"   state = document.avaform.elements['rep_state'].value;\n"
		"   country = document.avaform.elements['rep_country'].value;\n"
		"}\n",
		stdout);
	} else {
	   fprintf ( stdout, 
		"function ava_init() "
		" {"
		"	document.avaform.elements['rep_cn'].checked=\"false\";"
		"	document.avaform.elements['rep_email'].checked=\"false\";"
		"	document.avaform.elements['rep_org'].checked=\"false\";"
		"	document.avaform.elements['rep_orgu'].checked=\"false\";"
		"	document.avaform.elements['rep_local'].checked=\"false\";"
		"	document.avaform.elements['rep_state'].checked=\"false\";"
		"	document.avaform.elements['rep_country'].checked=\"false\";"
		"}\n");
	}
		
	fputs ( "</SCRIPT>\n", stdout);

    	fprintf( stdout, "<HTML><BODY %s onload= \"ava_init()\">\n", dsgw_html_body_colors);

	fputs	("<FORM name = \"avaform\">\n", stdout);
	fputs ("<table align = \"left\" border=0>",stdout);
	/*
	fprintf(stdout, "<tr><td align=\"left\"><FONT=\"+4\">Edit group members:%s</td></tr>", header? header: dn);
	*/
	fprintf(stdout, "<tr><td align=\"left\"><FONT=\"+4\">Edit group members:%s</td></tr>", ufn? ufn: header);
	fputs("<tr></tr>\n", stdout);
	fputs("<tr></tr>\n", stdout);
	fputs ("<tr>", stdout);
	fputs ("<td>", stdout);
	fputs ("<table cellspacing= \"5\" >",stdout);


	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Common name:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_cn\" VALUE=\"false\">\n", stdout);
	fprintf (stdout, "<input type=\"text\" name=\"rep_cn\" VALUE= \"%s\" size=35  onChange=\"avaChg(1)\"  >", ava.cn_val? ava.cn_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Email Address:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_email\" VALUE=\"false\">\n", stdout);
	fprintf (stdout, "<input type=\"text\" name=\"rep_email\" VALUE= \"%s\" size=35  onChange=\"avaChg(2)\"  >", ava.mail_val? ava.mail_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Organization:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_org\" VALUE=\"false\">\n", stdout);
	fprintf (stdout, "<input type=\"text\" name=\"rep_org\" VALUE= \"%s\" size=35  onChange=\"avaChg(3)\"  >", ava.o_val? ava.o_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Organization Unit(s):<br>(one per line)</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_orgu\" VALUE=\"false\">\n", stdout);
	fputs ("<textarea name=\"rep_orgu\" WARP=\"virtual\" VALUE= \"\" ROWS=10 COLS=35  onChange=\"avaChg(4)\"  >", stdout);
	for (i=ava.num_ou-1; i>= 0; i--)
		fprintf(stdout, "%s\n", ava.ou_vals[i]);
	fputs("</textarea>\n", stdout);
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Locality:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_local\" VALUE=\"false\">\n", stdout);
	fprintf (stdout, "<input type=\"text\" name=\"rep_local\" VALUE= \"%s\" size=35  onChange=\"avaChg(5)\"  >", ava.l_val? ava.l_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>State or Province:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_state\" VALUE=\"false\">\n", stdout);
	fprintf (stdout, "<input type=\"text\" name=\"rep_state\" VALUE= \"%s\" size=35  onChange=\"avaChg(6)\"  >", ava.st_val? ava.st_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("<tr><td VALIGN = \"top\" align=\"Right\" NOWRAP><B>Country:</B></td>", stdout);
	fputs("<TD VALIGN=\"top\" NOWRAP>\n", stdout);
	fputs("<input type=\"hidden\" name=\"change_coun\" VALUE=\"false\">\n", stdout);
	fprintf (stdout,"<input type=\"text\" name=\"rep_country\" VALUE= \"%s\" size=35  onChange=\"avaChg(7)\"  >", ava.c_val? ava.c_val: "");
	fputs ("</TD></tr>", stdout);

	fputs ("</table>", stdout);
	fputs ("</td>", stdout);
	fputs ("</tr>\n", stdout);
	fputs ("<tr><td>\n", stdout);
	fputs ("<TABLE BORDER=2 WIDTH=100%><TR><TD WIDTH=25% ALIGN=\"center\">", stdout);
	fputs("<INPUT TYPE=\"button\" VALUE=\"Save Changes\" onClick=\"avaSubmit()\">", stdout);
	fputs("</TD><TD WIDTH=25% ALIGN=\"center\">\n", stdout);
	if (!addMember) {
		fputs ("<INPUT TYPE=\"button\" VALUE=\"  delete  \" onClick=\"avaDelete()\">\n", stdout);
		fputs("</TD><TD WIDTH=25% ALIGN=\"center\">\n", stdout);
	}
	dsgw_emit_helpbutton ( "avagroup");
	fputs ("</TD></TR></TABLE>", stdout);
	fputs ("</td></tr></table>", stdout);
	fputs ("</FORM>\n", stdout);

	/* Submit FORM */
	fprintf (stdout, "<FORM name=\"avasubmit\"  action= \"%s\" method=POST>\n", 
		  dsgw_getvp( DSGW_CGINUM_DOMODIFY));
	fputs ("<INPUT TYPE= \"hidden\" NAME=\"changetype\" VALUE= \"modify\">\n", 
		stdout);

	fprintf (stdout,"<INPUT TYPE= \"hidden\" NAME=\"dn\" VALUE= \"%s\">\n", edn);
	if ( addObjectclass) {
	   fputs ("<INPUT TYPE= \"hidden\" NAME=\"add_objectclass\" VALUE= \"groupofCertificates\">\n", stdout);
	}

	if (!addMember ) { 
	   fprintf (stdout, "<INPUT TYPE= \"hidden\" NAME=\"delete_membercertificatedescription\" VALUE=\"{%s\">\n", prevmember ? prevmember : "");
	}
	fputs ("<INPUT TYPE= \"hidden\" NAME=\"add_memberCertificateDescription\">\n", stdout);
	fputs("<INPUT TYPE=\"hidden\" NAME=\"quiet\" VALUE=\"true\">\n", stdout);
	fputs ("<INPUT TYPE= \"hidden\" NAME=\"completion_javascript\" VALUE= \"if (dsmodify_dn.length== 0) document.location.href=\\'genscreen?dslsgroups&info=\\' + escape(dsmodify_info); else document.location.href=\\'edit/\\' + dsmodify_dn + \\'?&info=\\' + escape(dsmodify_info);\">\n", stdout);
	fputs ("</FORM>\n", stdout);

	fputs ("</BODY></HTML>", stdout);

	if (!addMember)
		free_avainfo (&ava);
	if (edn) free (edn);
	if (ufn) free (ufn);
}

