/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#include "dsgw.h"
 
extern char *Version;   /* from Versiongw.c */
 
static void get_request();
static void post_request();
 
static void create_findnadd( char *groupdn, char *attrname, char *attrdesc );
 
main( argc, argv, env )
    int         argc;
    char        *argv[];
#ifdef DSGW_DEBUG
    char        *env[];
#endif
{
    int         reqmethod;
    char	*groupdn = NULL;
    char	*qs, *attrname, *attrdesc;

    reqmethod = dsgw_init( argc, argv,  DSGW_METHOD_GET );
    dsgw_send_header();
 
#ifdef DSGW_DEBUG
   dsgw_logstringarray( "env", env );
#endif

    if (( qs = getenv( "QUERY_STRING" )) == NULL || strlen( qs ) == 0 ) {
	dsgw_error( DSGW_ERR_MISSINGINPUT, NULL, DSGW_ERROPT_EXIT, 0 );
    }
    qs = dsgw_ch_strdup( qs );
    /*
     * The query string should be of the form edn&attrname&attrdesc
     */
    if (( attrdesc = strrchr( qs, '&' )) == NULL ) {
	dsgw_error( DSGW_ERR_MISSINGINPUT, NULL, DSGW_ERROPT_EXIT, 0 );
    }
    *attrdesc++ = '\0';
    if (( attrname = strrchr( qs, '&' )) == NULL ) {
	dsgw_error( DSGW_ERR_MISSINGINPUT, NULL, DSGW_ERROPT_EXIT, 0 );
    }
    *attrname++ = '\0';
    dsgw_form_unescape( attrdesc );
    dsgw_form_unescape( attrname );
    groupdn = qs;
    dsgw_form_unescape( groupdn );
    
#ifdef DSGW_DEBUG
    dsgw_log( "processing group DN \"%s\", attrname %s, attrdesc %s\n",
	    groupdn, attrname, attrdesc );
#endif

    create_findnadd( groupdn, attrname, attrdesc );

    exit( 0 );
}



#define	MY_HTML_FILE	"dsfatop.html"
static void
create_findnadd( char *groupdn, char *attrname, char *attrdesc )
{
    char **xdn;
    FILE *html = dsgw_open_html_file( MY_HTML_FILE, DSGW_ERROPT_EXIT );
    char line[BIG_LINE];

    xdn = ldap_explode_dn( groupdn, 1 );
    while ( dsgw_next_html_line( html, line ))  {
	if ( directive_is( line, "DS_FA_ATTRNAME" )) {
	    fputs( attrname, stdout );
	    fputs( "\n" , stdout );
	} else if ( directive_is( line, "DS_FA_ATTRDESC" )) {
	    fputs( attrdesc, stdout );
	    fputs( "\n" , stdout );
	} else if ( directive_is( line, "DS_FA_GROUPRDN" )) {
	    fputs( xdn[ 0 ], stdout );
	    fputs( "\n" , stdout );
	} else if ( directive_is( line, "DS_FA_GROUPDN" )) {
	    fputs( groupdn, stdout );
	    fputs( "\n" , stdout );
	} else if ( directive_is( line, "DS_FA_ATTRFIELD" )) {
	    fprintf( stdout,
		    "<INPUT TYPE=\"hidden\" NAME=\"mod_attrlist\" VALUE=\"add_%s\">\n",
		    attrname );
	    fputs( "\n" , stdout );
	} else {
	    fputs( line, stdout );
	}
    }
    ldap_value_free( xdn );
}

