/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#include <ssl.h>
#include <sec.h>
#include <sys/types.h>
#include <limits.h>
#include <string.h>
#include <ldap.h>


#ifdef NOT_IN_SELGLUE /* these are now in admserv/cgi-src/secglue.c */
/*
 * These RC4 routines are called by libldap for dongle-file related stuff.
 * See ns/netsite/ldap/libraries/libldap/ldap_ssl.c
 */
void
RC4_DestroyContext( RC4Context *cx, DSBool freeit )
{
    return;
}

DSStatus
RC4_Encrypt( RC4Context *cx, unsigned char *output, unsigned int *outputLen,
	unsigned int maxOutputLen, const unsigned char *input,
	unsigned int inputLen )
{
    return( DSFailure );
}


/*
 * These RNG routines are called by dsgw_mkrndstr() which is only used
 * when constructing new cookies.  See cookie.c
 */
RNGContext *
RNG_CreateContext()
{
    return( (RNGContext *)0 );
}

void
RNG_DestroyContext( RNGContext *cx, DSBool freeit )
{
    return;
}

void
RNG_GenerateRandomBytes( RNGContext *cx, void *result, size_t numBytes )
{
    return;
}

#endif

/*
 * These two SEC_ routines are called by libldap when dealing with key
 * database passwords.  See ns/netsite/ldap/libraries/libldap/ldap_ssl.c
 */
DSStatus
SEC_CheckKeyDBPassword( SECKeyDBHandle *handle, SECItem *pwitem )
{
    return( DSFailure );
}

void
SEC_ZfreeItem( SECItem *zap, DSBool freeit )
{
    return;
}

#ifdef DO_NOT_DO
/*
 * These SSL routines are called by libldap when doing I/O.
 * See ns/netsite/ldap/libraries/libldap/ldap_ssl.c and also
 * ns/netsite/ldap/libraries/liblber/io.c
 */
int
SSL_Recv( int s, void *buf, int len, int flags )
{
    return( -1 );	/* like the recv() system call */
}

int
SSL_Send( int s, const void *buf, int len, int flags )
{
    return( -1 );	/* like the send() system call */
}
#endif /* DO_NOT_DO */

/*
 * XP_Cat() is called by libldap when constructing paths to dongle files
 * and key and certificate databases.
 * See ns/netsite/ldap/libraries/libldap/ldap_ssl.c
 */
char *
XP_Cat( char *a0, ... )
{
    return( (char *)0 );
}


/*
 * Something in ns-admin.so calls ldapssl_init()....
 */
LDAP *
ldapssl_init( const char *defhost, int defport, int defsecure )
{
    return( (LDAP *)0 );
}
