/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * language.cpp: interface with libsi18n
 * 
 * Tony Xue
 */


#include "base/util.h"
#include "base/language.h"

#include "i18n.h"

NSAPI_PUBLIC char *
lang_acceptlanguage(pblock *rqheaders)
{
    char *language;
    if (rqheaders && (language = pblock_findval("accept-language", rqheaders))) 
        return language;

    language = GetClientLanguage();
    if (language && *language)
        return language;
    else
        return NULL;
}


char * lang_acceptlang_file(char *path, pblock *rqheaders)
{
    char *pret = NULL;
    char *language;

    language = lang_acceptlanguage(rqheaders);

    if (language && *(path + strlen(path)-1) != '/') {
        char *langpath;
        char *p;
        char *tpath;  /*  temporary path to hold original path */

        tpath = (char *) MALLOC(strlen(path) + 1 + 20);
        strcpy(tpath, path);
        p = strrchr(tpath, '/');

        if (p && (p != tpath)) {
            char *filename;

            filename = STRDUP(p + 1);
            *p = '\0';

            strcat(tpath, "/$$LANGDIR/");
            strcat(tpath, filename);
            FREE(filename); 

            langpath = (char *) MALLOC(strlen(path) + 30);

            if (GetFileForLanguage(tpath, language, langpath) == -1) {
                /* Do nothing error occurs */
                pret = NULL;
            }
            else {
                pret = langpath;
            }
        }
        FREE(tpath);
    }

    return pret;
}


