/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * restart.c: Register callbacks that get executed when the server restarts.
 *
 * Rob McCool
 */

#include "netsite.h"
#include "base/daemon.h"

/* --------------------------- daemon_atrestart --------------------------- */


static struct rsf {
    void (*fn)(void *);
    void *data;
    struct rsf *next;
} *_rlist = NULL;

#if defined(OSF1)
extern "C"
#endif
/* Need to specify extern "C" with Forte 6 compiler */
#if defined (SOLARIS)
extern "C"
#endif
#if defined (SOLARISx86)
extern "C"
#endif
NSAPI_PUBLIC void daemon_atrestart(void (*fn)(void *), void *data)
{
    struct rsf *r;

    r = (struct rsf *) MALLOC(sizeof(struct rsf));
    r->fn = fn;
    r->data = data;
    r->next = _rlist;
    _rlist = r;
}

#if defined(OSF1)
extern "C"
#endif
/* Need to specify extern "C" with Forte 6 compiler */
#if defined (SOLARIS)
extern "C"
#endif
#if defined (SOLARISx86)
extern "C"
#endif
NSAPI_PUBLIC void daemon_dorestart(void)
{
    struct rsf *r = _rlist, *s;

    while(r) {
        (*r->fn)(r->data);
        s = r;
        r = r->next;
        FREE(s);
    }
    _rlist = NULL;
}

