/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * autil.c: Admin utilities, mainly cache manipulation routines
 *
 * This currently sucks quite a bit.  There a whole bunch of redundancy
 * and stuff, but life is short and I don't have time to fix it now. Later.
 *
 *
 * Ari Luotonen
 */

#include "cgiutils/autil.h"
#include "base/shexp.h"

void _damn(char *msg)
{
    puts("Content-type: text/html\n\n");
    die(msg);
}


char *au_croot(void)
{
    char *croot = NULL;
    register int x;
    char **magconf;
    char *p;
    struct stat st;

    magconf=scan_tech(MY_MAGCONF);
    if (!magconf)
        _damn("Could not read configuration file.");
    for(x=0;magconf[x];x++)  {
	if ((p = strstr(magconf[x], "cache-root="))) {
	    p += 11;
	    if (*p == '"') {
		croot = ++p;
		if ((p = strchr(croot, '"')) ||
		    (p = strchr(croot, ' '))) *p = '\0';
	    }
	    else {
		croot = p;
		if ((p = strchr(croot, ' '))) *p = '\0';
	    }
	}
    }
    if (!croot)
        _damn("Couldn't find cache-root parameter in config file");
    if (stat(croot,&st) == -1)
        _damn("Can't stat cache-root");

    return croot;
}


int au_csize(void)
{
    char *csize = NULL;
    register int x;
    char **magconf;
    char *p;

    magconf=scan_tech(MY_MAGCONF);
    if (!magconf)
        _damn("Could not read configuration file.");
    for(x=0;magconf[x];x++)  {
	if ((p = strstr(magconf[x], "cache-size="))) {
	    p += 11;
	    if (*p == '"') {
		csize = ++p;
		if ((p = strchr(csize, '"')) ||
		    (p = strchr(csize, ' '))) *p = '\0';
	    }
	    else {
		csize = p;
		if ((p = strchr(csize, ' '))) *p = '\0';
	    }
	}
    }
    if (!csize)
        return 0;
    else
	return atoi(csize);
}


int au_tdirs(void)
{
    register int x;
    char *tdirs = NULL;
    char *p;
    char **magconf;

    magconf=scan_tech(MY_MAGCONF);
    if (!magconf) exit(1);
    for(x=0;magconf[x];x++)  {
	if ((p = strstr(magconf[x], "top-dirs="))) {
	    p += 9;
	    if (*p == '"') {
		tdirs = ++p;
		if ((p = strchr(tdirs, '"')) ||
		    (p = strchr(tdirs, ' '))) *p = '\0';
	    }
	    else {
		tdirs = p;
		if ((p = strchr(tdirs, ' '))) *p = '\0';
	    }
	}
    }
    if (!tdirs)
	return 0;
    else
	return atoi(tdirs);
}


/*
 * Returns current time in GMT.
 */
time_t _now_gmt(void)
{
    struct tm *tms;
    long tz;
    time_t t = time(NULL);

    /*
     * Get time zone
     */
    tms = localtime(&t);
#ifdef BSD_TIME
    tz = tms->tm_gmtoff;
#else
    tz = -timezone;
    if (tms->tm_isdst)
        tz += 3600;
#endif

    return t - tz;
}


int expire_one(char *croot, char *cfile)
{
    char *cif    = NULL;
    char *entry  = NULL;
    FILE *cifp   = NULL;
    char *digest = NULL;
    int   diglen = 0;
    char *p;
    char line[FORM_MAXLINE];
    char ct[FORM_MAXLINE];
    char url[FORM_MAXLINE];
    int xfer;
    long lm, ex, lc, cl;

    cif = (char *)malloc(strlen(cfile) + 10);
    strcpy(cif, cfile);
    if (!(p = strrchr(cif, '/'))) return 0;
    strcpy(p, "/.mcom_cif");

    if (!(cifp = fopen(cif, "r"))) return 0;

    if (!(digest = strrchr(cfile, '/'))) return 0;
    digest++;
    diglen = strlen(digest);

    while ((fgets(line, FORM_MAXLINE, cifp))) {
	if (!strncmp(line, digest, diglen))
	    entry = strdup(line);
    }
    fclose(cifp);

    if (entry &&
	7 == sscanf(entry, "%*s %d %ld %ld %ld %ld %s %s",
		    &xfer,	/* 2 transfer time */
		    &lm,	/* 3 last-modified */
		    &ex,	/* 4 expires */
		    &lc,	/* 5 last-checked */
		    &cl,	/* 6 content-length */
		    ct,		/* 7 content-type */
		    url))	/* 8 url */
      {
	  ex = _now_gmt();
	  if (!(cifp = fopen(cif, "a"))) return 0;

	  fprintf(cifp, "%s\t%d\t%ld\t%ld\t%ld\t%ld\t%s\t%s\n",
		  digest,	/* 1 */
		  xfer,		/* 2 */
		  lm,		/* 3 */
		  ex,		/* 4 */
		  lc,		/* 5 */
		  cl,		/* 6 */
		  ct,		/* 7 */
		  url);		/* 8 */
	  fclose(cifp);
	  printf("Marked cache file \"%s\" expired\n", cfile);
	  return 1;
      }
    else
      {
	  printf("Couldn't find CIF entry for \"%s\"\n", cfile);
      }

    return 0;
}


/*
 * Expires an entire site, or if shexp!=NULL expires only URLs
 * matching that regexp from that site.
 */
int expire_site(char *croot, char *ufile, char *shexp)
{
    char *cfile = (char *)malloc(strlen(croot) + 100);
    FILE *ufp = fopen(ufile, "r");
    char *p, *cr;
    char line[FORM_MAXLINE];
    int total=0;
    int success=0;

    if (!ufp) return 0;

    sprintf(cfile, "%s/", croot);
    cr = cfile + strlen(cfile);

    while ((fgets(line, FORM_MAXLINE, ufp))) {
	if ((p = strchr(line, ' '))) {
	    *p++ = '\0';
	    if (*p && (!shexp || !shexp_cmp(line, shexp))) {
		strcpy(cr, p);
		if ((p = strchr(cr,'\n'))) *p = '\0';
		total++;
		if (expire_one(croot, cfile)) success++;
	    }
	}
    }
    fclose(ufp);

    if (success) {
	printf("Expired %d out of %d from %s\n", success, total, ufile);
    }

    return success;
}


/*
 * Calls expire_site() for each cached site.  Reads sites from
 * the global host db given as a param.
 */
int expire_all(char *croot, char *hfile, char *shexp)
{
    FILE *hfp = fopen(hfile, "r");
    char *ufile = (char *)malloc(strlen(croot) + 200);
    char *p, *hr;
    char line[FORM_MAXLINE];
    int total=0;
    int success=0;

    if (!hfp)
	die("Can't open site list file");

    sprintf(ufile, "%s/hosts/", croot);
    hr = ufile + strlen(ufile);

    while ((fgets(line, FORM_MAXLINE, hfp))) {
	if ((p = strchr(line, ' ')) && *(++p)) {
	    strcpy(hr, p);
	    if ((p = strchr(hr,'\n'))) *p = '\0';
	    total++;
	    success += expire_site(croot, ufile, shexp) ? 1 : 0;
	}
    }

    if (success) {
	printf("Actually expired files from %d sites out of %d\n",
	       success, total);
    }

    return success;
}


int remove_one(char *croot, char *cfile)
{
    char *cif    = NULL;
    char *entry  = NULL;
    FILE *cifp   = NULL;
    char *digest = NULL;
    int   diglen = 0;
    char *p;
    char line[FORM_MAXLINE];

    cif = (char *)malloc(strlen(cfile) + 10);
    strcpy(cif, cfile);
    if (!(p = strrchr(cif, '/'))) return 0;
    strcpy(p, "/.mcom_cif");

    if (!(cifp = fopen(cif, "r"))) {
	printf("Can't open CIF: \"%s\" - probably already removed.\n", cif);
        return 0;
    }

    if (!(digest = strrchr(cfile, '/'))) return 0;
    digest++;
    diglen = strlen(digest);

    while ((fgets(line, FORM_MAXLINE, cifp))) {
	if (!strncmp(line, digest, diglen))
	    entry = strdup(line);
    }
    fclose(cifp);

    if (entry)
      {
	  /*
	   * For security reasons we don't blindly remove files,
	   * but require that a CIF entry is found.  Otherwise we
	   * leave it for gc which can remove stuff more securely.
	   */
	  unlink(cfile);
	  printf("Removed cache file \"%s\"\n", cfile);
	  return 1;
      }
    else
      {
	  printf("Couldn't find CIF entry for \"%s\" - probably already removed\n", cfile);
      }

    return 0;
}


int remove_site(char *croot, char *ufile, char *shexp)
{
    FILE *ufp = fopen(ufile, "r");
    FILE *tfp = NULL;
    char *tfile = (char *)malloc(strlen(ufile) + 10);
    char *cfile = (char *)malloc(strlen(croot) + 100);
    char *p, *cr;
    char line[FORM_MAXLINE];
    int total=0;
    int success=0;

    if (!ufp) {
	printf("Can't open URL list file for site (probably already removed)\n");
	return 0;
    }
    sprintf(tfile, "%s.tmp", ufile);
    sprintf(cfile, "%s/", croot);
    cr = cfile + strlen(cfile);

    while ((fgets(line, FORM_MAXLINE, ufp))) {
	if ((p = strchr(line, ' '))) {
	    *p++ = '\0';
	    if (*p && (!shexp || !shexp_cmp(line, shexp))) {
		strcpy(cr, p);
		if ((p = strchr(cr,'\n'))) *p = '\0';
		total++;
		if (remove_one(croot, cfile)) success++;
#if 0
		/*
		 * Actually, on fail we just remove it also from the URL
		 * so it won't hang around because it was probably an
		 * invalid entry in the first place (that's why this code
		 * is commented out).
		 */
		else {
		    /*
		     * Failed -- write the remaining URL to catalog
		     */
		    if (tfp || (tfp = fopen(tfile, "w")))
		      fprintf(tfp, "%s %s\n", line, cr);
		}
#endif
	    }
	    else {
		if (tfp || (tfp = fopen(tfile, "w")))
		  fprintf(tfp, "%s %s", line, p);
	    }
	}
    }
    fclose(ufp);
    if (tfp) {
	fclose(tfp);
	rename(tfile, ufile);
    }
    else {
	unlink(ufile);
    }

    if (success) {
	printf("Removed %d out of %d from %s\n", success, total, ufile);
    }

    return success;
}


int remove_all(char *croot, char *hfile, char *shexp)
{
    FILE *hfp = fopen(hfile, "r");
    char *ufile = (char *)malloc(strlen(croot) + 200);
    char *p, *hr;
    char line[FORM_MAXLINE];
    int total=0;
    int success=0;

    if (!hfp)
	die("Can't open site list file");

    sprintf(ufile, "%s/hosts/", croot);
    hr = ufile + strlen(ufile);

    while ((fgets(line, FORM_MAXLINE, hfp))) {
	if ((p = strchr(line, ' ')) && *(++p)) {
	    strcpy(hr, p);
	    if ((p = strchr(hr,'\n'))) *p = '\0';
	    total++;
	    success += remove_site(croot, ufile, shexp) ? 1 : 0;
	}
    }

    if (success) {
	printf("Actually removed files from %d sites out of %d\n",
	       success, total);
    }

    return success;
}


void human_time_option(long t, long selval)
{
    long secs, mins, hours, days=t;

    secs = days % 60;
    mins = (days /= 60) % 60;
    hours = (days /= 60) % 24;
    days /= 24;
    printf("<OPTION%s>", t==selval ? " SELECTED" : "");
    if (days)	printf(" %ld day%s",  days,  days >1 ? "s" : "");
    if (hours)	printf(" %ld hour%s", hours, hours>1 ? "s" : "");
    if (mins)	printf(" %ld min%s",  mins,  mins >1 ? "s" : "");
    if (secs)	printf(" %ld sec%s",  secs,  secs >1 ? "s" : "");
    printf("\n");
}


long parse_human_time(char *str)
{
    char *p = str;
    long  t = 0L;
    long  n;

    while (p && *p && (n = atol(p)) && (p = strchr(p,' ')) && *(++p)) {
	if      (!strncmp(p,"day", 3))	t += n * 86400;
	else if (!strncmp(p,"hour",4))	t += n * 3600;
	else if (!strncmp(p,"min", 3))	t += n * 60;
	else                            t += n;

	p = strchr(p, ' ');
    }
    return t;
}

