/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * pw: Interfaces with the UNIX DES password encryption libs
 * 
 * Rob McCool
 */


#include "cgiutils/pw.h"

#ifdef ENCRYPT_PASSWORDS

#ifdef CRYPT_H
#include <crypt.h>
#else
char *crypt(const char *key, const char *salt);
#endif

#include <sys/types.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

static unsigned char itoa64[] =         /* 0 ... 63 => ascii - 64 */
        "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

char *pw_enc(char *pw)
{
    char *cpw, salt[3];
    long v;

    srand((int)time(NULL));
    v = rand();

    salt[0] = itoa64[v & 0x3f];
    v >>= 6;
    salt[1] = itoa64[v & 0x3f];
    cpw = crypt(pw, salt);
    return cpw;
}


int pw_cmp(char *pw, char *enc)
{
    char *cpw = crypt(pw, enc); /* use salt from enc */

    return strcmp(enc, cpw);
}

#else

char *pw_enc(char *pw)
{
    return pw;
}

int pw_cmp(char *pw, char *enc)
{
    return strcmp(pw, enc);
}

#endif
