/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * httpdir.c: Directives for HTTP and Proxy servers
 * 
 * Rob McCool
 */



#include "base/systems.h"
#include "base/util.h"

#include "frame/httpact.h"


/* ------------------------------------------------------------------------ */
/* ------------------- Lowest level: Define directives -------------------- */
/* ------------------------------------------------------------------------ */


struct dstruct {
    char *name;
    int len;
};

static struct dstruct dname[] = {
#ifdef MCC_BATMAN
    {"Setup", 5},
    {"MetaData", 8},
    {"Data", 4},
    {"Enumerate", 9},
    {"Generate", 8},
    {"Shutdown", 8}
#else
    {"AuthTrans", 9},
    {"NameTrans", 9},

    {"PathCheck", 9},

    {"ObjectType", 10},

    {"Service", 7},
    {"Error", 5},

    {"AddLog", 6}

#ifdef MCC_PROXY
    ,
    {"Route", 5},
    {"DNS", 3},
    {"Connect", 7},
    {"Filter", 6}
#endif
#endif
};


/* -------------------------- directive_name2num -------------------------- */


NSAPI_PUBLIC int directive_name2num(char *dir) 
{
    register int x;

    for(x = 0; x < NUM_DIRECTIVES; x++) {
        if(!strncasecmp(dir,dname[x].name,dname[x].len))
            return x;
    }
    return -1;
}

/* -------------------------- directive_num2name -------------------------- */


NSAPI_PUBLIC const char *directive_num2name(int num) 
{
    return dname[num].name;
}
