/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
** balancedlock.h
**
** Provide the illusion of a "safe" lock
*/

#include "prlock.h"

class BalancedLock {
 public:
    BalancedLock (PRLock *);    // acquire lock
    ~BalancedLock ();           // release lock
 private:
    PRLock * lock; 
};

inline BalancedLock::BalancedLock (PRLock * _lock) : lock(_lock)
{
    PR_Lock (lock);
}

inline BalancedLock::~BalancedLock ()
{
    PR_Unlock (lock);
}
