/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef _DAEMONPROCESSOR_UX_H
#define _DAEMONPROCESSOR_UX_H

#include "daemonprocessor.h"

#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <pwd.h>         /* getpwnam */
#include <grp.h>         /* initgroups */
#ifdef SOLARIS
#include <thread.h>     /* thr_setconcurrency() */
#endif


class DaemonSessionUX;

#define SINGLE_ACCEPT_NONE      -1      /* uninitialized state */
#define SINGLE_ACCEPT_OFF       0
#define SINGLE_ACCEPT_ON        1
#define SINGLE_ACCEPT_PARTIAL   2       /* do mutex but not file lock */

class DaemonProcessorUX: public DaemonProcessor
{
public:
    static PRBool      Initialize(daemon_s *pDaemon);
    static PRBool      LateInitialize(daemon_s *pDaemon);
                       DaemonProcessorUX();
                       ~DaemonProcessorUX();
    virtual DaemonSession     *NewAcceptSession(PRInt32 index);

private:
    void               _daemon_detach();
    void               _daemon_log_pid(char *file);
    void               _daemon_wait_for_child();
    static PRBool      _daemon_setup(daemon_s *d);
    static void        _daemon_set_uid(uid_t uid, struct passwd *pwd);
#ifdef SOLARIS
    static PRBool      _daemon_solaris_single_accept();
#endif

private:
    static PRInt32          num_processors;
    static PRBool           detach;
};

#endif /* _DAEMONPROCESSOR_H_ */
