/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

/*
 * Tools to build and maintain access control lists via CGI interfaces.
 */

#include <stdio.h>
#include <string.h>

#include <netsite.h>
#include <libaccess/acl.h>
#include "aclpriv.h"
#include <libaccess/aclproto.h>

NSAPI_PUBLIC int fubar(void)
{
	return 0;
}

NSAPI_PUBLIC void
ACL_OutputSelector(char *name, char **item)  
{
int		ii = 0;
int		num_items;
const int 	SELECT_OVERFLOW = 25;

    if (item == NULL || item[ii] == NULL)
        return;

    for (ii = 1; item[ii]; ii++) ;

    num_items = ii;
    
    if ( num_items > SELECT_OVERFLOW )
        fprintf(stdout, "<SELECT NAME=%s>\n", name);
    else
        fprintf(stdout, "<SELECT NAME=%s size=5>\n", name);

    fprintf(stdout, "<OPTION VALUE=\"%s\" SELECTED>%s\n", item[ii], item[ii]);
    for (ii = 1; ii < num_items; ii++) {
        fprintf(stdout, "<OPTION VALUE=\"%s\">%s\n", item[ii], item[ii]);
    }
    fprintf(stdout, "</SELECT>");
    return;
}

