/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#include "base/systems.h"
#include "netsite.h"
#include "nsadb.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

int main(int argc, char * argv[])
{
    char * dbname;
    void * authdb;
    int opt;
    int rv;
    extern char * optarg;
    extern int optind, opterr;

    opterr = 0;
    optind = 1;

    for (;;) {

	opt = getopt(argc, argv, "h");
	if (opt == EOF) break;
	switch (opt) {
	  case 'h':			/* help */
	    goto do_usage;

	  default:
	    fprintf(stderr, "%s: unknown option - %s\n",
		    argv[0], argv[optind-1]);
	    goto do_usage;
	}
    }

    if ((argc - optind) < 1) goto do_usage;

    dbname = argv[optind];

    rv = nsadbOpen(0, dbname, AIF_CREATE, &authdb);
    if (rv < 0) {
	fprintf(stderr, "%s: error %d from authDBOpen()\n", argv[0], rv);
	exit(1);
    }

    nsadbClose(authdb, 0);
    exit(0);

  do_usage:
    fprintf(stderr, "Usage: %s auth-db-dir\n", argv[0]);
    exit(1);
}
