/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * get_msg.c: Internationalization (get language from DBM if available.)
 *
 * All blame to Mike McCool
 */

/* We define MSG_RETURN so that the macros in the .i files create a function
 * which returns the correct phrase (instead of generating a DBM, or 
 * associating a name with a number.) */
#define MSG_RETURN
#include "libadmin/libadmin.h"
#ifndef XP_WIN32
/* dummy out for HCL 1.5
#include "mcom_ndbm.h"
*/
#endif /* !XP_WIN32 */
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#ifndef XP_WIN32
/* dummy out for HCL 1.5
static DBM *la_d = NULL;
static DBM *hadm_d = NULL;
*/

/* dummy out for HCL 1.5   */
char *_get_dbm(int id)
{

  return NULL;
/*
    datum msg_id, msg_val;
    char buf[255];
    DBM *d = NULL;
 
    if((id >= LA_BASE) && (id <= LA_BASE_END))  {
        if(la_d == NULL)  {
            d = dbm_open(LA_DBM_LOC, O_RDWR, 0644);
            if(!d) return NULL;
            la_d = d;
        }  else
            d = la_d;
    }  else if ((id >= HADM_BASE) && (id <= HADM_BASE_END))  {
        if(hadm_d == NULL)  {
            d = dbm_open(HADM_DBM_LOC, O_RDWR, 0644);
            if(!d) return NULL;
            hadm_d = d;
        }  else
            d = hadm_d;
    }

    sprintf(buf, "%d", id);
    msg_id.dptr = buf;
    msg_id.dsize = strlen(buf);
 
    msg_val = dbm_fetch(d, msg_id);
 
    if(msg_val.dptr)
        return(strdup(msg_val.dptr));
    else
        return NULL;
*/
}
 
#endif /* !XP_WIN32 */

char *_get_internal(int id)
{
    if((id >= LA_BASE) && (id <= LA_BASE_END))
        return libadmin_msg(id);
    else if ((id >= HADM_BASE) && (id <= HADM_BASE_END))
        return httpd_admsrc_msg(id);
/* SHUT UP GCC */
    return NULL;
}
 
NSAPI_PUBLIC char *get_msg(int msgid)
{
    char *ans = NULL;
 
#ifndef XP_WIN32
    ans = _get_dbm(msgid);
    if(!ans)
#endif
        ans = _get_internal(msgid); 
 
    return ans;
}
 
