/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
#ifndef ENCDEC_H
#define ENCDEC_H

#if 0
#ifndef _UINT32
#if defined(__alpha)
typedef int int32;
typedef unsigned int uint32;
#else /* __alpha */
typedef long int32;
typedef unsigned long uint32;
#endif /* __alpha */
#endif
#endif /* 0 */

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Number of bytes a SHA-1 hash produces
 */
#define SHA1_LENGTH	20

/*
** SHA-1 secure hash function
*/

/*
** Hash a null terminated character string "src" into "dest" using SHA-1
*/
static int SHA1_Hash(unsigned char *dest, const char *src);

/*
** Hash a non-null terminated string "src" into "dest" using SHA-1
*/
static int SHA1_HashBuf(unsigned char *dest, const unsigned char *src,
			     uint32 src_length);

#define BASE64_LEN(vlen)        (((vlen) * 4 / 3 ) + 3)

static int base64_decode( const char *src, unsigned char *dst );

static int base64_encode( const unsigned char *src, char *dst, int srclen, int lenused );

static char *sha1_pw_enc( const char *pwd );

static int sha1_pw_cmp( const char *userpwd, const char *dbpwd );

#ifdef __cplusplus
}
#endif

#endif
