/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * referer.c - Handle issues with going back from whence you came
 *
 * All blame to Mike McCool
 * Totally rewritten by Fred Cox, under guidance by above.
 */

#include "libadmin/libadmin.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define REFER_VAR "adminReferer"

static char *current_referer=NULL;

NSAPI_PUBLIC char *
get_referer( char **qqqq )
{
  return cookieValue( REFER_VAR, NULL );
}

static char *
fixAddition( char *url, char *addition )
{
  if ( addition ) {
    char	*result = (char *)MALLOC( strlen( url ) + strlen( addition ) + 1 );
    int		i;

    for ( i = 0 ; url[i] && url[i] != '?' ; ++i ) {
      result[i] = url[i];
    }
    result[i] = '?';
    result[i+1] = '\0';
    strcat( result, addition );

    return result;
  } else {
    return STRDUP( url );
  }
}

NSAPI_PUBLIC void
redirect_to_referer( char *addition )
{
  char	*url;
  char  *ref;

  ref = cookieValue( REFER_VAR, NULL );

  url = fixAddition(ref, addition );

  fprintf( stderr, "Content-type: text/html\n\n"
	   "<SCRIPT language="MOCHA_NAME">\n"
	   "window.location='%s';\n"
	   "</SCRIPT>\n", url );
  FREE( url );
}

NSAPI_PUBLIC void
js_open_referer( void )
{
    char *ref;

    ref = cookieValue( REFER_VAR, NULL );

    fprintf( stdout,
	     "<SCRIPT language="MOCHA_NAME">\n"
	     "window.location='%s'\n"
	     "</SCRIPT>\n", ref );
}

NSAPI_PUBLIC void
set_referer( char **qqq )
{
  char	*surl = getenv( "SERVER_URL" );
  char	*sn = getenv( "SCRIPT_NAME" );
  char	*referer = (char *)MALLOC( strlen( surl ) + strlen( sn ) + 4 );

  fprintf( stdout,
	   "<SCRIPT language="MOCHA_NAME">\n"
	   "document.cookie='"REFER_VAR"=' + window.location.href + "
	   "'; path=/%s/';\n"
	   "</SCRIPT>", get_srvname( 0 ) );
  /* Need to recalculate the referer for internal use */
  sprintf( referer, "%s%s", surl, sn );
  cookieValue( REFER_VAR, referer );
  FREE( referer );
}

NSAPI_PUBLIC void
set_fake_referer( char *new_ref )
{
  char *surl=getenv("SERVER_URL");
  char *sn=getenv("SCRIPT_NAME");
  char *referer = (char *)MALLOC(strlen(surl)+strlen(sn)+strlen(new_ref)+4);

  fprintf( stdout,
	   "<SCRIPT language="MOCHA_NAME">\n"
	   "document.cookie='"REFER_VAR"=%s; path=/%s/';\n"
	   "</SCRIPT>", new_ref, get_srvname( 0 ) );

  /* Need to recalculate the referer for internal use */
  sprintf(referer, "%s%s", surl, sn);
  strcpy(strrchr(referer, '/') + 1, new_ref);
  cookieValue( REFER_VAR, referer );
}

/* Blame Rob. */
NSAPI_PUBLIC void redirect_to_script(char *script)
{
    char urlbuf[BIG_LINE];


    sprintf(urlbuf, "%s%s", getenv("SERVER_URL"), getenv("SCRIPT_NAME"));
    strcpy(strrchr(urlbuf, '/') + 1, script);
    printf("Location: %s\n\n", urlbuf);
}
