/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
//#ifndef WIN32

#include <libmsgdisp/timer_srvc.h>
#include <stdio.h>

#include <libmsgdisp/msgchnel.h>

//#if HAS_TIMER  

extern "C" {
#include "timer_service.h"


TIMER_SERVICE init_timer_service(int minGranularityinSecs)
{
   TimerServiceProvider* ptr = new TimerServiceProvider(minGranularityinSecs);
   TIMER_SERVICE result = NULL;
   if (ptr->IsValid() == 1) 
	result = (TIMER_SERVICE*)ptr;
   return result;
}

int perform_timer_service(ServiceType serviceType, TIMER_SERVICE ptr,
			  unsigned long timeForAlarm,
			  long (*fnPtr)(short, long, void*, void*), 
			  void* clntData)
{
   TimerServiceProvider* myself = (TimerServiceProvider*) ptr;
   int result;
   
   switch (serviceType) {
   case eINSERT :
	result = myself->AddTimeObject(myself, timeForAlarm, fnPtr, clntData);
	break;
   case eDELETE :
	result = myself->DeleteTimeObject(myself, timeForAlarm);
	break;
   default :
	result = -1;
	break;
   }
   return result;
}

void terminate_timer_service(TIMER_SERVICE ptr)
{
   TimerServiceProvider* myself = (TimerServiceProvider*) ptr;
   //delete myself;
}
      
}


//#endif /* HAS_TIMER   */
//#endif /* WIN32   */
