/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

/***********************************************************************
** Includes
***********************************************************************/
#include "libnscore/nsavpair.h"


//********************************************************************
// MEMBER:	NSavpair
// DESCRIPTION:
//	Default constructor
//********************************************************************
NSavpair::NSavpair() {
   if (_dir.Bad()) 
      Errnum(outOfMem);
   }


//********************************************************************
// MEMBER:	~NSavpair
// DESCRIPTION:
//	Destructor
//********************************************************************
NSavpair::~NSavpair() {
   }


int  
NSavpair::Get(CStr attr, NSavpairCB cb, PGen parm) {
   Str  attrName = 0;
   PGen cookie = 0; 
   Str  val = 0;

   Get(attr, val, cookie);
   if (val == 0) 
      return(FALSE);
   while (val != 0) {
      Next(attrName, val, cookie);
      if (attrName == 0 || strcmp(attrName, attr) != 0)
         break;
      else {
         int rc = (*cb)(attr, val, parm);
         if (rc == 0)
            return(FALSE);
         }
      }
   return(TRUE);
   }


//********************************************************************
// MEMBER:	Dump
// DESCRIPTION:
//	Debugging aid to dump the contents of the current object.
//********************************************************************
void NSavpair::Dump(ostream& o) const {
   PGen cookie;
   Str attr = 0;
   Str val = 0;
   NSskiplist* pDir = (NSskiplist*)&_dir;
   pDir->First(attr, val, cookie);
   while (attr != 0) {
      o << "attr=" << attr << ", val=" << val << endl;
      pDir->Next(attr, val, cookie);         
      }
   }


//********************************************************************
// MEMBER:	Load
// DESCRIPTION:
//	@+@member description
//********************************************************************
NSavpair& NSavpair::Load(NSavpairCB cb, PGen parm) {
   Clear();

   PGen cookie;
   Str attr = 0;
   Str val = 0;
   NSskiplist* pDir = (NSskiplist*)&_dir;
   pDir->First(attr, val, cookie);
   while (attr != 0) {
      (cb)(attr, val, parm);
      pDir->Next(attr, val, cookie);         
      }
   return(*this);
   }


/***********************************************************************
** Protected Member Functions
***********************************************************************/

//********************************************************************
// MEMBER:	Name
// DESCRIPTION:
//	Returns the class name for the instance.
//********************************************************************
CStr NSavpair::Name() const {
   return("NSavpair");
   }
