/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

/***********************************************************************
** Includes
***********************************************************************/
#include "libnscore/nscore.h"
#include "libnscore/nsbase.h"


/***********************************************************************
** Static Globals
***********************************************************************/
s32 NSbase::_objcount = 0;


/***********************************************************************
** FUNCTION:	~NSbase
** DESCRIPTION:
**   Decrements the object count.
***********************************************************************/
NSbase::~NSbase() {
//   _objcount--;
   }

//********************************************************************
// MEMBER:	operator<<
// DESCRIPTION:
//	Friend function.  Outputs a "standard" header and invokes the
//	virtual Name and Dump functions in order to provide an easy-to-use
//	mechanism for dumping object contents for debugging purposes.
//********************************************************************
ostream& operator<< (ostream& o, const NSbase& x) {
   time_t     now = time(0);
   struct tm* t = localtime(&now);
   char       timestring[32];

   strftime(timestring, sizeof(timestring), "%m/%d/%y %H:%M:%S", t);
   
   o << timestring << "::" << x.Name() << endl
     << "Error = " << x._err 
     << ", source object causing error = " << x.Errsrc() << endl;
   x.Dump(o);
   return(o);
   }

