/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/

#include "libnscore/nslockf.h"

int
NSlockfile::Init(const char* filename, const char* msg) {
   if (!filename || _initialized || PR_Access(filename, PR_ACCESS_EXISTS) == PR_SUCCESS)
      return(0);
   else {
      strncpy(_fname, filename, sizeof(_fname));
      _fd = PR_Open(_fname, PR_WRONLY | PR_CREATE_FILE, 0644);
      if (!_fd)
         return(0);
      else {
         if (PR_TLockFile(_fd) != PR_SUCCESS) {
            PR_Close(_fd);
            return(0);
            }

#ifndef _WINDOWS
         ostrstream buf;
         char hostname[128];
         PR_GetSystemInfo(PR_SI_HOSTNAME, hostname, sizeof(hostname));
         buf << "Host=" << hostname << ", PID=" << getpid();
         if (msg != 0)
            buf << " msg=" << msg;
         buf << endl;
         char* bp = buf.str();
#else
         char* bp = "NT file lock\n";
#endif
         PR_Write(_fd, bp, strlen(bp));

#ifndef _WINDOWS
         delete[] bp;
#endif
         _initialized = 1;
         PR_Close(_fd);
         }
      }
   return(1);
   }
