/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * httpagt.c - main entry point of demo http subagent
 *
 * George Dong   11/29/95
 *
 */


#include "ame/machtype.h"
#include "ame/syspub.h"
#include "ame/errno.h"
#include "ame/smitypes.h"
#include "ode/mgmtpub.h"

#ifndef NS_SNMP
#include "ns_snmp.h"
#endif

#ifndef NS_SNMPIF
#include "ns_snmpif.h"
#endif

#include "httpagt.h"

#include "netscape.h"		/* SMI compiler output */



/*
 *	Our "identity" is 1.3.6.1.4.1.1450.1 (for http subtree)
 */
static ubyte  me[] = {0x2b, 0x06, 0x01, 0x04, 0x01, 0x8b, 0x2a, 0x01};

static ObjId_t	my_id = {sizeof(me),me,};

int
main(argc,argv)
int argc;
char **argv;
{
	struct snmp_contxt	*contxt;
	struct mib_contxt       *httpmib;
	struct timeval           wait;
	int                      status;
	int                      test = 3; /* force to send 3 traps */
	int                      fd_count;

	wait.tv_sec = 0;
	wait.tv_usec = 0;
	
	contxt = subagt_conn_init(&my_id);
	/* check return here */
	httpmib = 
	  (struct mib_contxt *)MALLOC(sizeof(struct mib_contxt));
	
	if (httpmib == NULL)
	  {
	    /* report error */
	    return(1);
	  }
	
	httpmib->entity = 
	  (struct httpEntity *)MALLOC(sizeof(struct httpEntity));
	httpmib->statistics = 
	  (struct httpStatistics *)MALLOC(sizeof(struct httpStatistics));

	if (httpmib->entity == NULL)
	  {
	    /* report error */
	    return(1);
	  }

	if (httpmib->statistics == NULL)
	  {
	    /* report error */
	    return(1);
	  }

	subagt_conn_magt(contxt, argv[1]);
	/* check return here */

	if((status=GetServerInfo(httpmib, ENTITYINFO)) != NO_ERR)
	  {
	    /* report error here */
	    return(1);
	  }

	subagt_register_mibrow(contxt,	&SMI_GROUP_httpEntityEntry, 
					(struct httpEntity *) httpmib->entity);

	subagt_register_mibrow(contxt,	&SMI_GROUP_httpStatisticsEntry, 
					(struct httpStatistics *) httpmib->statistics);

					
	/* check return here */
	
	fd_count = maxfiles();

	do
	{
	  if((status=GetServerInfo(httpmib, STATISINFO)) != NO_ERR)
	    {
	      /* report error here */
	      return(1);
	    }	  

	  subagt_poll(contxt, (struct timeval *)&wait);
	  /* check return here */

	  if (httpmib->statistics->status == 1 && test > 0)
	    {
	      test--;
	      
	      /* sending trap */
	      subagt_trap(contxt, &TRAP_httpEntityStatChg);
	      /* check return here */

	    }

	} while (status >= 0);

	FREE(httpmib->entity);
	FREE(httpmib->statistics);
	FREE(httpmib);
	subagt_conn_term(contxt);
	return(0);
}









