/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * httpagt.h - header of snmp subagent for http server
 *
 * George Dong   01/17/96
 *
 */

#ifndef HTTPAGT
#define HTTPAGT

#ifdef PEER_SNMP
#include "ame/smitypes.h"
#endif

#define ENTITYINFO  1
#define STATISINFO  2

struct mib_contxt
{
  struct httpEntity * entity;
  struct httpStatistics * statistics;
};

struct httpEntity
{
  INTEGER             index;    /* index of subagent */
  DisplayString       descr;
  OBJECTIDENTIFIER    svrobjid;
  DisplayString       protocol;
  DisplayString       vers;
  DisplayString       org;
  DisplayString       loc;
  DisplayString       contact;
  IpAddress           addr;
  DisplayString       port;
  DisplayString       name;
  DisplayString       svrtype;
  DisplayString       methods;
  INTEGER             maxprocess;
  INTEGER             minprocess;
  INTEGER             maxthread;
  INTEGER             minthread;
};

struct httpStatistics
{
  INTEGER             index;
  INTEGER             status;
  TimeTicks           uptime;
  INTEGER             numpidle;
  INTEGER             numpproc;
  INTEGER             numpdns;
  Counter             requests;
  Counter             requesterr;
  INTEGER             numprocess;
  INTEGER             numthread;
};



/* prototype */
int GetServerInfo(struct mib_contxt *, int);

#endif
  
