/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * END COPYRIGHT BLOCK **/
/*
 * httputil.c - interface to http server
 *
 * George Dong -- 12/04/95
 *
 */

#ifndef NS_SNMPIF
#include "ns_snmpif.h"
#endif

#include "httpagt.h"
#include "httpif.h"
 
int GetServerInfo(struct mib_contxt * contxt, int type)
{
  struct httpEntity *       econtxt = (struct httpEntity *)contxt->entity;
  struct httpStatistics *   scontxt = (struct httpStatistics *)contxt->statistics;
  int                       ret      = NO_ERR;

  switch(type){
  case STATISINFO:
    GetStatisIndex(scontxt);
    GetStatisStatus(scontxt);
    GetStatisUptime(scontxt);
    GetStatisNumPIdle(scontxt);
    GetStatisNumPProc(scontxt);
    GetStatisNumPDns(scontxt);
    GetStatisRequests(scontxt);
    GetStatisRequestErr(scontxt);
    GetStatisNumProc(scontxt);
    GetStatisNumThread(scontxt);
    break;
  case ENTITYINFO:
    GetEntityIndex(econtxt);
    GetEntityDescr(econtxt);
    GetEntityObjId(econtxt);
    GetEntityProtocol(econtxt);
    GetEntityVersion(econtxt);
    GetEntityOrg(econtxt);
    GetEntityLoc(econtxt);
    GetEntityContact(econtxt);
    GetEntityAddr(econtxt);
    GetEntityPort(econtxt);
    GetEntityName(econtxt);
    GetEntityType(econtxt);
    GetEntityMethods(econtxt);
    GetEntityMacProc(econtxt);
    GetEntityMinProc(econtxt);
    GetEntityMaxThread(econtxt);
    GetEntityMinThread(econtxt);
    break;
  default:
    ret = ERR_TYPE;
  }

  return(ret);
}


