#
# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK
#
#
# These are the default values 
#
# Individual modules may override them
#
# BUILD_BOMB=[-DPUMPKIN_HOUR=xxxxxxx or just leave it empty]
# BUILD_DEBUG=[full, optimize, purify]
# BUILD_MODULE=[HTTP_ADMIN, HTTP_PERSONAL, HTTP_ENTERPRISE, ...]
# BUILD_SECURITY=[none, export, domestic]

NSROOT=$(MCOM_ROOT)/adminserver


TMP_ARCH := $(shell uname -s)
ifeq ($(TMP_ARCH), Windows_NT)
	TMP_ARCH=WINNT
endif
RELEASE := $(shell uname -r)
ifeq ($(TMP_ARCH), WINNT)
BUILD_ARCH = $(TMP_ARCH)
else
BUILD_ARCH := $(shell $(MCOM_ROOT)/adminserver/nsarch)
endif

PKG_ARCH=$(BUILD_ARCH)

PUMPKIN_AGE := 90
BUILD_BOMB=
#BUILD_BOMB=-DPUMPKIN_HOUR=$(shell cat $(MCOM_ROOT)/adminserver/pumpkin.dat)
BUILD_CHECKER=no
BUILD_DEBUG=full
BUILD_MODULE=HTTP_ADMIN
BUILD_NSPR_THREADS=yes
BUILD_SECURITY=domestic
ifeq ($(USE_PTHREADS), 1)
  ifeq ($(USE_N32), 1)
     BUILD_PTHREADS=-n32-pth
  else
     BUILD_PTHREADS=-pth
  endif
else
  BUILD_PTHREADS=
endif
NSPR_SUF=20
ifdef FORTEZZA
BUILD_FORTEZZA=fortezza
else
BUILD_FORTEZZA=normal
endif

ifeq ($(USE_64), 1)
  64BIT_TAG = _64
endif

PRETTY_ARCH := $(shell uname -s)
 
NSOS_ARCH         := $(subst /,_,$(shell uname -s))

ifeq ($(TMP_ARCH), SunOS)
  NSOS_TEST1       := $(shell uname -m)
  ifeq ($(NSOS_TEST1), i86pc)
	ARCHTYPE= _i86pc
  else
	ARCHTYPE=
  endif
else
  ARCHTYPE=
endif

ifeq ($(NSOS_ARCH),WINNT)
LIB_SUFFIX = lib
else
LIB_SUFFIX = a
endif
    
ifeq ($(NSOS_ARCH), IRIX64)
NSOS_ARCH := IRIX
endif
       
ifeq ($(NSOS_ARCH), AIX)
NSOS_TEST        := $(shell uname -v)
ifeq ($(NSOS_TEST),3)
NSOS_RELEASE   := $(shell uname -r)
else
NSOS_RELEASE   := $(shell uname -v).$(shell uname -r)
endif
else
NSOS_RELEASE      := $(shell uname -r)
#
# Handle FreeBSD 2.2-STABLE and Linux 2.0.30-osfmach3 and 2.2.14-5.0smp
#

ifeq (,$(filter-out Linux FreeBSD,$(NSOS_ARCH)))
  NSOS_RELEASE  := $(shell echo $(NSOS_RELEASE) | sed 's/-.*//')
endif
ifeq ($(NSOS_ARCH), Linux)
NSOS_RELEASE      := $(basename $(NSOS_RELEASE))
endif
endif

# Catch NCR butchering of SVR4
ifeq ($(NSOS_ARCH),UNIX_SV)
ifneq ($(findstring NCR, $(shell grep NCR /etc/bcheckrc | head -1 )),)
NSOS_ARCH	:= NCR
PRETTY_ARCH     := NCR
else
# Make UnixWare something human readable
NSOS_ARCH	:= UNIXWARE
PRETTY_ARCH     := UNIXWARE
endif
# Get the OS release number, not 4.2
NSOS_RELEASE	:= $(shell uname -v)
endif

# Get OSF's OS revision number to figure out the OS release
ifeq ($(NSOS_ARCH),OSF1)
  NSOS_RELEASE1      := $(shell uname -r)
  NSOS_OSF1REV       := $(shell uname -v)
  ifeq ($(NSOS_OSF1REV),878)
    NSOS_RELEASE := $(NSOS_RELEASE1)D
  else
    ifeq ($(NSOS_OSF1REV),564)
      NSOS_RELEASE := $(NSOS_RELEASE1)B
    else
      ifeq ($(NSOS_OSF1REV),464)
        NSOS_RELEASE := $(NSOS_RELEASE1)A
      else
        NSOS_RELEASE := $(NSOS_RELEASE1)
      endif
    endif
  endif
endif

# Clean up SCO
ifeq ($(NSOS_ARCH),SCO_SV)
NSOS_ARCH	:= SCOOS
ifeq (5.0,$(findstring 5.0,$(shell ls /var/opt/K/SCO/Unix)))
NSOS_RELEASE	:= 5.0
else
NSOS_RELEASE	:= UNKNOWN
endif
endif

# Check if we're on RHEL
ifeq ($(NSOS_ARCH), Linux)
  NSOS_TEST := $(shell cat /etc/redhat-release)
  ifeq ($(findstring Taroon, $(NSOS_TEST)),Taroon)
    NSOS_ARCH = RHEL
    NSOS_RELEASE = 3
    # Always use gcc on RHEL
    GCC_VERSION = gcc$(word 1, $(shell gcc --version | sed 's/gcc.*GCC.\s//' | sed 's/\..*//'))
  else
    ifeq ($(findstring Nahant, $(NSOS_TEST)),Nahant)
      NSOS_ARCH = RHEL
      NSOS_RELEASE = 4
      # Always use gcc on RHEL
      GCC_VERSION = gcc$(word 1, $(shell gcc --version | sed 's/gcc.*GCC.\s//' | sed 's/\..*//'))
    endif
  endif
endif

ifdef BUILD_INTL
INTL_DEF=-intl
endif

NSPLATFORM_DIR=$(NSOS_ARCH)$(NSOS_RELEASE)$(ARCHTYPE)$(64BIT_TAG)
PLATFORM_DEST=$(NSPLATFORM_DIR)-$(SECURITY)$(INTL_DEF)-$(DEBUG)-$(B_FORTEZZA)$(BUILD_PTHREADS)
PLATFORM_OBJDIR=$(MCOM_ROOT)/adminserver/built/$(PLATFORM_DEST)
PLATFORM_PACKAGE_DIR=$(MCOM_ROOT)/adminserver/built/package/$(PLATFORM_DEST)
DEFAULT_OBJDIR=$(PLATFORM_OBJDIR)-$(DIR)

#NSPR_BASENAME=nspr4
NSPR_BASENAME=libnspr4

ifeq ($(BUILD_MODULE), CONSOLE)
PRODUCT="Fedora Management Console"
DIR=console
NO_BUILD_NUM=true
NOSTDCLEAN=true
endif

ifneq ($(NO_BUILD_NUM), true)
GET_BUILD_NUM := $(shell cat $(NSROOT)/$(NSPLATFORM_DIR)/buildnum.dat)
endif

ifdef REL_BUILD
INTGBUILD=0
else
INTGBUILD=1
endif

# Foreign language support
WEBSERVER_LANGS = ja fr de


ifeq ($(BUILD_ARCH), WINNT)
  BUILD_DLL_VERSION=yes
  BUILD_HTTPDLL_NAME=ns-httpd30
  BUILD_ADMIN_NAME=ns-admin40
  PERL_ARCH=$(shell uname -p)
  #PERL=$(MCOM_ROOT)/perl5/$(PERL_ARCH)/perl
  PERL=perl

#  ZIP_ROOT=$(ABS_ROOT)/infozip
#  PROCESSOR:=$(shell uname -p)
#  ifeq ($(PROCESSOR), I386)
#    ZIPDIR=$(ZIP_ROOT)/i386
#  else
#    ifeq ($(PROCESSOR), MIPS)
#      ZIPDIR=$(ZIP_ROOT)/mips
#    else
#      ifeq ($(PROCESSOR), ALPHA)
#        ZIPDIR=$(ZIP_ROOT)/alpha
#      else
#        ZIP_DIR=$(PROCESSOR)-is-not-supported-for-processor
#      endif
#    endif
#  endif

  ZIP=$(INFOZIP_PATH)/zip.exe
  UNZIP=$(INFOZIP_PATH)/unzip.exe -o

  ifeq ($(PROCESSOR_ARCHITECTURE), ALPHA)
    EXEBUILD=$(MCOM_ROOT)/exebuild/exebuild.exe
  else
# Nothing
  endif

else
  ifeq ($(BUILD_ARCH), Linux)
    #PERL=$(COMPONENTS_DIR)/perl5/$(PKG_ARCH)2.1-perl5/perl
    PERL=/usr/bin/perl
  else
    PERL=$(COMPONENTS_DIR)/perl5/$(PKG_ARCH)-perl5/perl
  endif
  ifeq ($(TMP_ARCH), SunOS)
    NSOS_TEST1       := $(shell uname -m)
    ifeq ($(NSOS_TEST1), i86pc)
      ZIP = /bin/zip
      UNZIP = /bin/unzip -o
    else
      ZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/zip
      UNZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/unzip -o
    endif
  else
    #ZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/zip
    #UNZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/unzip -o
    ZIP = zip
    UNZIP = unzip
  endif
  IZIP  = $(ZIP) -ry9uT
endif


define echo_build_parms
echo ==== Building with the following parameters ====
echo BUILD_ARCH=$(BUILD_ARCH) 
echo BUILD_MODULE=$(BUILD_MODULE)
echo BUILD_SECURITY=$(BUILD_SECURITY)
echo BUILD_DEBUG=$(BUILD_DEBUG)
echo BUILD_FORTEZZA=$(BUILD_FORTEZZA)
echo BUILD_NSPR_THREADS=$(BUILD_NSPR_THREADS)
echo BUILD_BOMB=$(BUILD_BOMB)
echo BUILD_DLL_VERSION=$(BUILD_DLL_VERSION)
echo BUILD_HTTPDLL_NAME=$(BUILD_HTTPDLL_NAME)
echo BUILD_ADMIN_NAME=$(BUILD_ADMIN_NAME)
echo BUILD_CHECKER=$(BUILD_CHECKER)
echo BUILD_IIOPLIB=$(BUILD_IIOPLIB)
endef

#
# Set up these names because most of the makefiles use them now.
#
ARCH=$(BUILD_ARCH)
SECURITY=$(BUILD_SECURITY)
DEBUG=$(BUILD_DEBUG)
B_FORTEZZA=$(BUILD_FORTEZZA)
BOMB=$(BUILD_BOMB)
NSPR_THREADS=$(BUILD_NSPR_THREADS)
BUILD_DLL=$(BUILD_DLL_VERSION)
ADMINDLL_NAME=$(BUILD_ADMIN_NAME)
HTTPDLL_NAME=$(BUILD_HTTPDLL_NAME)
BOUNDS_CHECKER=$(BUILD_CHECKER)
RESOLV_FLAG=
DO_SEARCH=
NODE_FLAG=-DNO_NODELOCK

MAJOR_VERSION:="6"
MINOR_VERSION:="2"

DIRVERDIR=$(COMMON_OBJDIR)/include
DIRVER_H=$(DIRVERDIR)/dirver.h

#
# -- General Server Section ---------------------------------------------------
#

ifeq ($(BUILD_MODULE), SetupSDK)
PRODUCT="Fedora Setup SDK"
DIR=installer
endif

#
# -- Web Server Section -------------------------------------------------------
#

ifeq ($(BUILD_MODULE), HTTP_ADMIN)
PRODUCT="Fedora Administration Server"
DIR=admin
DO_CLUSTER=yes
endif

ifeq ($(BUILD_MODULE), SETUP_ADMIN)
PRODUCT="Fedora Setup"
NS_PRODUCT=MCC_ADMSERV
endif

ifeq ($(BUILD_MODULE), SETUP_BASE)
PRODUCT="Fedora SuiteSpot Base Package"
DIR=base
endif

ifeq ($(BUILD_MODULE), SETUP_MCC)
PRODUCT="Fedora Mission Control package"
DIR=mcc
endif

ifeq ($(BUILD_MODULE), UNINST_SHELL)
PRODUCT="Fedora Uninstall Shell"
DIR=installer
endif

ifeq ($(BUILD_MODULE), UNINST_ADMIN)
PRODUCT="Fedora Administration Uninstaller"
DIR=admin
endif

#
# -- Default Section --------------------------------------------------------
#
# Some of the _OBJDIR is maintained for backward compatibility until they
# are all cleaned up.  Most of them heavily dependent on value of $(DIR)
#

ifndef ADMSERV_OBJDIR
ADMSERV_OBJDIR=$(PLATFORM_OBJDIR)-admin
endif

ifndef COMMON_OBJDIR
COMMON_OBJDIR=$(DEFAULT_OBJDIR)
endif

ifndef OBJDIR
OBJDIR=$(DEFAULT_OBJDIR)
endif

RELTOOLS=$(MCOM_ROOT)/reltools
